// ****************************************************************************
//
// Copyright ?2008 AOL LLC  All rights reserved.
// This software contains valuable confidential and proprietary information
// of AOL LLC and is subject to applicable licensing agreements.
// Unauthorized reproduction, transmission or distribution of this file and
// its contents is a violation of applicable laws.
//
//           A O L  L L C   C O N F I D E N T I A L
//
// ****************************************************************************
//
//     File Name:   content\buddyList\aim.js
//
//****************************************************************************

AIM.prototype.baseURI = "http://iwarg.ddns.net";
AIM.prototype.devKey = null;
AIM.prototype.clientName = null;
AIM.prototype.clientVersion = null;

// These are constants for the request states for an xmlHTTPRequest object
AIM.prototype.requestStates = {
    uninitialized : 0,
    open : 1,
    sent : 2,
    receiving : 3,
    loaded : 4
}

AIM.prototype.transactions = {
	getBuddyInfo:"presence/get",
	getBuddyList:"presence/get",
	sendTextIM:"im/sendIM",
	sendDataIM:"im/sendDataIM",
	getPresenceInfo:"presence/get",
	startSession:"aim/startSession",
	setState:"presence/setState",
	setStatus:"presence/setStatus",
	typingStatus:"im/setTyping",
	setProfile:"/presence/setProfile",
	endSession:"aim/endSession",
	setPresenceState:"presence/setState",
	moveGroup:"buddylist/moveGroup",
	removeGroup:"buddylist/removeGroup",
	renameGroup:"buddylist/renameGroup",
	setBuddyAttribute:"buddylist/setBuddyAttribute",
	addBuddy:"buddylist/addBuddy",
	removeBuddy:"buddylist/removeBuddy",
	moveBuddy:"buddylist/moveBuddy",
	getPreference:"preference/get",
	setPreference:"preference/set",
	getPermitDeny:"preference/getPermitDeny",
	setPermitDeny:"preference/setPermitDeny",
	reportSPIM:"im/reportSPIM",
	addTempBuddy:"aim/addTempBuddy",
	setGroupAttribute:"buddylist/setGroupAttribute"
}

AIM.prototype.connectStatus = 
{
    nothing : "nothing",
    connecting : "Connecting",
    authenticating : "Authenticating",
    validating : "Validating",
    consenting : "Consenting",
    starting : "Starting",
    buddylist : "buddylist",
    signedOff : "signedOff"
}

AIM.prototype.errorCodes = 
{
    rateLimited : "rateLimited",
    fetchError : "fetchError",
    invalidData: "invalidData",
    invalidKey : "invalidKey"
}

AIM.prototype.sessionID = null;
AIM.prototype.screenName = null;
AIM.prototype.password = null;
AIM.prototype.request = null;
AIM.prototype.fetchEventsRequest = null;
AIM.prototype.initialized = false;
AIM.prototype.aimsid = null;
AIM.prototype.fetchBaseURL = null;
AIM.prototype.fetchEventsTimer = null;
AIM.prototype.trackfetchEventsTimer = null;
AIM.prototype.fetchServerTimeOutMs = "28000";
AIM.prototype.fetchIdleTimeOutMs   = "60000";
AIM.prototype.fetchEventsIdleCounter = 0;
AIM.prototype.reconnectCount = 0;
AIM.prototype.timeToNextFetch = 0;
AIM.prototype.fetchStartTime = null;
AIM.prototype.clientApp = null;
AIM.prototype.myInfo = null;
AIM.prototype.currentConnectStatus = AIM.prototype.connectStatus.nothing;
// This buffer holds all requests going to AIM,
// this is in case many requests are being sent asynchronously
AIM.prototype.requestBuffer = null;
AIM.prototype.useBufferedRequests = true;
AIM.prototype.signingOff = false;
AIM.prototype.signInPresence = null;
AIM.prototype.permitMode = null;

AIM.prototype.isReconnect = false;
AIM.prototype.connectPending = false;
AIM.prototype.reconnectStartTime = null;

AIM.prototype.continueOffline = false;
AIM.prototype.userAgent = null;
AIM.prototype.parsedBuddyList = false;
AIM.prototype.blockedList = null;

AIM.prototype.setPermitMode = function(mode)
{
    this.permitMode = mode;
}

AIM.prototype.getPermitMode = function()
{
    return this.permitMode;
}

AIM.prototype.getBlockedList = function()
{
    return this.blockedList;
}

AIM.prototype.getAllowedList = function()
{
    return this.allowedList;
}

AIM.prototype.setContinueOffline = function(isContinueOffline)
{
    this.continueOffline = isContinueOffline;
}

AIM.prototype.getContinueOffline = function()
{
    return this.continueOffline;
}

AIM.prototype.getIsReconnect = function()
{
    return this.isReconnect;
}

AIM.prototype.setContinueOffline = function(isContinueOffline)
{
    this.continueOffline = isContinueOffline;
    if (isContinueOffline) this.finishReconnect(false);
}

AIM.prototype.updateReconnectStatusWithCode = function(statusCode)
{
    if (this.isReconnect)
    {
        if(statusCode == "200")
        {
            this.finishReconnect(true);
            this.getBuddyListPresence();
        }
        else if (statusCode == "460" || statusCode =="401")
        {
            this.startReconnect(response.statusCode);
        }
    }
}

AIM.prototype.reconnect = function(statusCode)
{
    //shell.app.debugLog("AIM.prototype.reconnect - ("+statusCode+") isReconnect: "+this.isReconnect+" connectPending: "+this.connectPending);
    if (this.isReconnect && !this.connectPending)
    {
        this.connectPending = true;
        //shell.app.debugLog("AIM.prototype.reconnect - reconnectStartTime: "+this.reconnectStartTime);
        if (this.reconnectStartTime)
        {
            var d = new Date();
            var oneMinute = 60000;
            var currentTime = d.getTime();
            var timePassed = currentTime - this.reconnectStartTime;
            var reconnectTimeInterval = 0;
            if (timePassed <= 0.5 * oneMinute)
            {
                // if it's within 30 seconds, reconnect every 5 seconds
                reconnectTimeInterval = 5000;
            }
            else if (timePassed <= 2 * oneMinute)
            {
                // if it's within 1.5 min, reconnect every 15 seconds
                reconnectTimeInterval = 15000;
            }
            
            else if (timePassed <= 5 * oneMinute)
            {
                // reconnect every 30 seconds for 3 minutes
                reconnectTimeInterval = 30000;
            }
            else if (timePassed <= 15 * oneMinute)
            {
                // reconnect every 1 minute for 10 minutes
                reconnectTimeInterval = oneMinute;
            }

            //shell.app.debugLog("AIM.prototype.reconnect - ("+this.reconnectCount+") reconnectTimeInterval: "+reconnectTimeInterval);
            if (reconnectTimeInterval)
            {
                this.reconnectCount++;
                if (this.clientApp) this.clientApp.updateNotificationBoxMessage("#reconnect.pending", "<b>Reconnecting</b>... Please Wait. " + this.reconnectCount);
                //shell.app.debugLog("AIM.prototype.reconnect - setting reconnectDelay to fire in : "+reconnectTimeInterval);
                if (statusCode == "460" || statusCode == "401")
                {
                    // 460 means our session has been dropped
                    // 401 is "authentication required"
                    setTimeoutObject(this, "reconnectStartSession", 0);
                }
                else
                {
                    // should be 12xxx (network error) so attempt a fetchEvent first
                    setTimeoutObject(this, "reconnectFetchEvents", reconnectTimeInterval);
                }
            }
            else
            {
                //shell.app.debugLog("AIM.prototype.reconnect - gave up.");
                if (this.clientApp) this.clientApp.updateNotificationBoxMessage("#reconnect.pending", "Unable to Reconnect!");
                if (this.clientApp) this.clientApp.reconnectLimitReached();
                this.finishReconnect(false);
            }
        }
    }
}

AIM.prototype.reconnectFetchEvents = function()
{
    //shell.app.debugLog("AIM.prototype.reconnectFetchEvents - this.isReconnect: "+this.isReconnect);
    this.connectPending = false;
    if (this.isReconnect)
    {
        if (this.clientApp)
        {
            //shell.app.debugLog("AIM.prototype.reconnectFetchEvents - ensureDataConnection()");
            var edcRes = this.clientApp.ensureDataConnection();
            //shell.app.debugLog("AIM.prototype.reconnectFetchEvents - ensureDataConnection: "+edcRes);
        }
        //shell.app.debugLog("AIM.prototype.reconnectFetchEvents - fireFetchEvents()");
        this.fireFetchEvents();
    }
}

AIM.prototype.reconnectStartSession = function()
{
    //shell.app.debugLog("AIM.prototype.reconnectStartSession - this.isReconnect: "+this.isReconnect);
    this.connectPending = false;
    if (this.isReconnect)
    {
        if (this.clientApp)
        {
            //shell.app.debugLog("AIM.prototype.reconnectStartSession - ensureDataConnection()");
            var edcRes = this.clientApp.ensureDataConnection();
            //shell.app.debugLog("AIM.prototype.reconnectFetchEvents - ensureDataConnection: "+edcRes);
        }
        //shell.app.debugLog("AIM.prototype.reconnectStartSession - startSignedSession()");
        this.startSignedSession();
    }
}

// Set up (if necessary) and start a new reconnect attempt
//   statusCode : request result code (should be either 460 or 12xxx)
AIM.prototype.startReconnect = function(statusCode)
{   
    if (!this.signingOff)
    {
        this.connectPending = false;
        // Initial reconnect attempt
        if (!this.isReconnect && !this.continueOffline)
        {
            //shell.app.debugLog("AIM.prototype.startReconnect - >>> Reconnecting");
            this.clientApp.signedOff();
            this.blockedList = null;
            this.allowedList = null;
            // Mark the time we started our reconnect attempts
            var d = new Date();
            this.reconnectStartTime = d.getTime();
            this.isReconnect = true;
            this.reconnectCount = 0;
            // ?? If 460, clean up aimsid and other data that indicate we're online?
            this.reconnect(statusCode);
            if (this.clientApp) this.clientApp.reconnecting(true);
        }
        // Another reconnect attempt
        else if (this.isReconnect)
        {
            //shell.app.debugLog("AIM.prototype.startReconnect - calling this.reconnect()");
            this.reconnect(statusCode);
        }
    }
}


// Clean up after a reconnect attempt
//   isConnected : parameter to indicate whether we're connected or not
//                 We probably should be keeping track of this somewhere
AIM.prototype.finishReconnect = function(isConnected)
{
    //shell.app.debugLog("AIM.prototype.finishReconnect - Finishing reconnect ("+isConnected+")");
    this.reconnectStartTime = 0;
    this.isReconnect = false;
    this.connectPending = false;
    this.reconnectCount = 0;
    if (isConnected)
    {
        this.continueOffline = false;
        //shell.app.debugLog("AIM.prototype.finishReconnect - calling clientApp.reconnectSucceeded()");
        if (this.clientApp) this.clientApp.reconnectSucceeded();
    }
}



function AIM(scene)
{
    this.scene = scene;
}

AIM.prototype.init = function(client)
{
    if(!this.initialized)
    {
        //shell.app.debugLog("AIM.prototype.init - Initializing AIM \n");
        
        this.clientApp = client;
        this.request = new XMLHttpRequest();
        this.fetchEventsRequest = new XMLHttpRequest(); 
        this.fetchEventsTimer = null;
        this.trackfetchEventsTimer = null;
        this.requestBuffer = new Array();
        
        // For development in Win32
        try 
        {
            this.userAgent = shell.app.userAgent;
            this.devKey = shell.app.devKey;
        } 
        catch (e){}
        
        _aim = this;
        this.initialized = true;
        _clientLogin = new ClientLogin(this.devKey, shell.app.productId, shell.app.version, this);
    }
}

AIM.prototype.release = function()
{
    if(this.initialized)
    {
        this.request = null;
        this.fetchEventsRequest = null;
        _aim = null;

        this.initialized = false;
        if (_clientLogin)
            _clientLogin.reset();
    }
}

AIM.prototype.getLoginId = function()
{
    var id = this.aimsid;
    if (id)
    {
        id = id.split(":");
        if (id.length == 2)
        {
            id = id[1];
        }
    }
    return id;
}

AIM.prototype.isOnline = function()
{
    return (this.aimsid != null);
}

AIM.prototype.sendRequest = function(transaction, params, responseCallBack, forcedBaseURL)
{
    if (this.request)
    {
        var d = new Date();
        var timeStamp = d.getTime();
        var requestIdIdx = (params) ? params.lastIndexOf("&r") : -1;
        if (params && requestIdIdx > -1)
        {
            timeStamp = "," + timeStamp;
            requestIdEndIdx = params.indexOf("&", requestIdIdx + 1);
            if (requestIdEndIdx > -1)
            {
                var tempParams = params.substring(requestIdEndIdx);
                params = params.substring(0, requestIdEndIdx);
                params = params + timeStamp + tempParams; 
            }
            else
            {
                params += timeStamp;
            }
        }
        else
        {   
            params = params ? params : "";
            params += "&r=" + timeStamp;
        }
        
        var readyState = this.request.readyState;
        // Always add to the buffer (fewer execution paths that way)
        // Create a simple object to remember our request
        if(this.useBufferedRequests && readyState > 0 && readyState < 4)
        {
            // Current request is opened (1), sent (2), or received (3), so add to the queue
            var requestObject = 
            {
                mTransaction        : transaction,
                mParams             : params,
                mResponseCallBack   : responseCallBack,
                mForcedBaseURL      : forcedBaseURL
            }
            // When the current request is finished, it'll get the next request
            this.requestBuffer.push(requestObject); 
        }
        else
        {
            // There is no request, force execute right now
            this.executeRequest(transaction, params, responseCallBack, forcedBaseURL);
        }
    }
}

AIM.prototype.executeRequest = function(transaction, params, responseCallBack, forcedBaseURL)
{
    var requestStr = "k=" + this.devKey + "&f=json";
    if(responseCallBack)
    {
        requestStr += "&c="+responseCallBack;
    }
    if(this.aimsid)
    {
        requestStr += "&aimsid="+this.aimsid;
    }
    if(params)
    {
        requestStr += params;
    }
    var baseURL = this.baseURI;
    if(forcedBaseURL)
    {
        baseURL = forcedBaseURL;
    }
        
    
    //shell.app.debugLog("AIM.prototype.executeRequest - baseURL: " + baseURL + transaction);
    //shell.app.debugLog("AIM.prototype.executeRequest - request: " + requestStr);
    
    // MUST DESTROY/RESTART xmlHTTPRequest because it doesn't transmit referer after the first time
    this.request = null;
    this.request = new XMLHttpRequest();
    this.request.open("GET", baseURL + transaction+"?"+requestStr);
    this.request.setRequestHeader("Referer", this.referer);
    this.request.setRequestHeader("User-Agent", this.userAgent);
    this.request.setRequestHeader("Cache-Control", "no-store,no-cache");
    this.request.onreadystatechange = rsc_global;
    this.request.send("");
}

// This is the global response handler
// it calls eval() which branches to the callback specified by the &c parameter in the request
AIM.prototype.responseReadyStateChanged = function()
{
    //shell.app.debugLog("AIM.prototype.responseReadyStateChanged - readyState: "+this.request.readyState+"\n");
    if(this.request.readyState == this.requestStates.loaded)
    {
        var requestStatus = this.request.status;
        var responseText = this.request.responseText;
        var statusText = this.request.statusText;
        //shell.app.debugLog("AIM.prototype.responseReadyStateChanged - status: " + requestStatus + " statusText: " + statusText);
        //shell.app.debugLog("AIM.prototype.responseReadyStateChanged - responseText: " + responseText);

        if(requestStatus == 200)
        {
            try
            {
                if(responseText && responseText != "")
                {
                    //shell.app.debugLog("AIM.prototype.responseReadyStateChanged - eval==>>");
                    eval(responseText);
                }
            }
            catch(e){
                //shell.app.debugLog("AIM.prototype.responseReadyStateChanged - exception in eval!\n");
            }
        }
        else if(requestStatus > 12000)
        {
            
            //shell.app.debugLog("AIM.prototype.responseReadyStateChanged - requestStatus not 200.\n");

            //shell.app.debugLog("AIM.prototype.responseReadyStateChanged - Need to reconnect...\n");
            this.startReconnect(requestStatus);
        }
		else
		{
            //shell.app.debugLog("AIM.prototype.responseReadyStateChanged - unhandled request due to altnernate error.\n");
		}
        // start another request, if exists (Need to fix this to handle disconnects?)
        this.executeNextRequestFromBuffer();
    }
}

AIM.prototype.executeNextRequestFromBuffer = function()
{
    if(this.requestBuffer.length > 0)
    {
        var rq = this.requestBuffer.shift();
        if(rq)
        {
            ////shell.app.debugLog("AIM.prototype.executeNextRequestFromBuffer - Executing next request from buffer ("+this.requestBuffer.length+" left)");
            this.executeRequest(rq.mTransaction, rq.mParams, rq.mResponseCallBack, rq.mForcedBaseURL);
        }
    }
}

AIM.prototype.signOn = function(username, password)
{
    if (username && password)
    {
        this.screenName = username;
        this.password = password;
        //Initialise the ClientLogin object for use with AIM
        if(this.initialized)
        {    
            _clientLogin.signOn(this.screenName, this.password, false);
        }
    }
}

AIM.prototype.setSecurID = function(securID)
{
    // Continue login with the securID
    if (_clientLogin) {
        _clientLogin.openAuth.securId = securID;
        _clientLogin.signOn(this.screenName, this.password, false)
    }
}

AIM.prototype.setCaptcha = function(captcha)
{
    // Continue login with the captcha
    if (_clientLogin) {
        _clientLogin.openAuth.captchaWord = captcha;
        _clientLogin.signOn(this.screenName, this.password, false)
    }
}

AIM.prototype.moveBuddy = function(groupName, buddyName, beforeBuddy)
{
    var parms = "&buddy=" + buddyName + "&group=" + groupName + "&r=" + buddyName;
    if (beforeBuddy)
    {
        parms += "&beforeBuddy=" + beforeBuddy;
    } 
    this.sendRequest(this.transactions.moveBuddy, parms, "this.moveBuddyResponse");
}

AIM.prototype.moveBuddyResponse = function(json)
{
    var response = json.response;

    this.updateReconnectStatusWithCode(response.statusCode);
}

AIM.prototype.moveGroup = function(groupName, beforeGroup)
{
    groupName = encodeURIComponent(groupName);
    beforeGroup = encodeURIComponent(beforeGroup);

    var parms = "&group=" + groupName;
    if (beforeGroup)
    {
        parms += "&beforeGroup=" + beforeGroup;
        this.sendRequest(this.transactions.moveGroup, parms, "this.emptyListenerResponse");
    }
}

AIM.prototype.emptyListenerResponse =  function(json)
{
}

AIM.prototype.addGroup = function(groupName)
{
    //some random buddy name that hopefully doesn't exist
    var buddyName = "fjezerodiehPofef";

    // since WIM has no addGroup, the work around is to add new buddy to a group that doesn't exist
    this.addBuddy(buddyName, groupName, false);
}

AIM.prototype.addBuddy = function(buddyName, groupName, isAddBuddy, messageType, friendlyName)
{
    buddyName = encodeURIComponent(buddyName);
    groupName = encodeURIComponent(groupName);
    var parms = "&buddy=" + buddyName + "&group=" + groupName + "&r=" + buddyName + "," + groupName;
    if (messageType)
    {
        parms += "," + messageType;
    }
    if (friendlyName != undefined)
    {
        parms += "," + friendlyName;
    }
    var listener = (isAddBuddy) ? "this.addBuddyResponse" : "this.addGroupResponse";
    this.sendRequest(this.transactions.addBuddy, parms, listener);
}

AIM.prototype.setFriendlyName = function(buddyName, value, showMsg)
{
    buddyName = encodeURIComponent(buddyName);
    value = value ? encodeURIComponent(value) : "";
    var parms = "&buddy=" + buddyName + "&friendly=" + value + "&r=" + buddyName;
    if (showMsg)
    {
        parms += ",showMessage=true";
    }
    this.sendRequest(this.transactions.setBuddyAttribute, parms, "this.setFriendlyNameResponse");
}

AIM.prototype.setFriendlyNameResponse = function(json)
{
    var response = json.response;
    if(response.statusCode == "200")
    {    
        var buddyName;
        var friendlyName;
        var buddyInfo = response.requestId;
        if (buddyInfo)
        {
            buddyInfo = buddyInfo.split(",");
            buddyName = buddyInfo[0];
            this.getPresenceInfo(buddyName);
            if (buddyInfo.length == 3)
            {
                if (this.clientApp) this.clientApp.friendlyNameSet(buddyName);
            }
        }
    }
    this.updateReconnectStatusWithCode(response.statusCode);
}

AIM.prototype.addGroupResponse = function(json)
{
    var response = json.response;
    var buddyInfo = response.requestId;
    var buddyName;
    var groupName;
    if (buddyInfo)
    {
        buddyInfo = buddyInfo.split(",");
        buddyName = buddyInfo[0];
        groupName = buddyInfo[1];
    }
    if(response.statusCode == "200")
    {
        if (buddyName && groupName)
        {
            this.removeTemporaryBuddyFromGroup(buddyName, groupName);
        }
    }
    this.updateReconnectStatusWithCode(response.statusCode);
}

AIM.prototype.removeTemporaryBuddyFromGroup = function(buddyName, groupName)
{
    groupName = encodeURIComponent(groupName);
    // since WIM has no addGroup, the work around is to add new buddy to a group that doesn't exist
    var parms = "&buddy=" + buddyName + "&group=" + groupName + "&r=" + groupName;
    this.sendRequest(this.transactions.removeBuddy, parms, "this.removeTemporaryBuddyFromGroupResponse");
}

AIM.prototype.removeTemporaryBuddyFromGroupResponse =  function(json)
{
    var response = json.response;
    // since WIM has no addGroup, the work around is to add new buddy to a group that doesn't exist
    if(response.statusCode == "200")
    {
        var buddyInfo = response.requestId;
        if (buddyInfo)
        {
            buddyInfo = buddyInfo.split(",");
            if (this.clientApp) this.clientApp.groupAdded(buddyInfo[0]);
        }
    }
    
    this.updateReconnectStatusWithCode(response.statusCode);
}

AIM.prototype.addBuddyResponse =  function(json)
{
    var response = json.response;
    if(response.statusCode == "200")
    {
        var buddyInfo = response.requestId;
        var buddyName;
        var groupName;
        var messageType;
        var friendlyName;
        if (buddyInfo)
        {
            buddyInfo = buddyInfo.split(",");
            buddyName = buddyInfo[0];
            groupName = buddyInfo[1];
            if (buddyInfo.length > 3)
            {
                messageType = buddyInfo[2];
            }
        }
        if (buddyName && groupName)
        {
            if (this.clientApp) this.clientApp.buddyAdded(buddyName, groupName, messageType);
            if (buddyInfo.length > 4)
            {
                this.setFriendlyName(buddyName, buddyInfo[3], false);
            }
            else
            {
                this.getPresenceInfo(buddyName);
            }
        }
    }
    this.updateReconnectStatusWithCode(response.statusCode);
}

AIM.prototype.renameGroup = function(oldGroupName, newGroupName)
{
    oldGroupName = encodeURIComponent(oldGroupName);
    newGroupName = encodeURIComponent(newGroupName);
    
    var parms = "&oldGroup=" + oldGroupName + "&newGroup=" + newGroupName + "&r=" + oldGroupName + "," + newGroupName;
    this.sendRequest(this.transactions.renameGroup, parms, "this.renameGroupResponse");
}

AIM.prototype.renameGroupResponse = function(json)
{
    var response = json.response;
    var buddyInfo = response.requestId;
    var oldGroupName;
    var groupName;
    if (buddyInfo)
    {
        buddyInfo = buddyInfo.split(",");
        oldGroupName = buddyInfo[0];
        groupName = buddyInfo[1];
    }
    if(response.statusCode == "200")
    {
        if (groupName)
        {
            if (this.clientApp) this.clientApp.groupUpdated(oldGroupName, groupName);
        }
    }
    this.updateReconnectStatusWithCode(response.statusCode);
}

AIM.prototype.removeGroup = function(groupName)
{
    groupName = encodeURIComponent(groupName);
    var parms = "&group=" + groupName + "&r=" + groupName;
    this.sendRequest(this.transactions.removeGroup, parms, "this.removeGroupResponse");
}

AIM.prototype.removeGroupResponse = function(json)
{
    var response = json.response;
    if(response.statusCode == "200")
    {
        var buddyInfo = response.requestId;
        if (buddyInfo)
        {
            buddyInfo = buddyInfo.split(",");
            if (this.clientApp) this.clientApp.groupDeleted(buddyInfo[0]);
        }
    }
    this.updateReconnectStatusWithCode(response.statusCode);
}

AIM.prototype.removeBuddy = function(buddyName, groupName, showMessage)
{
    buddyName = encodeURIComponent(buddyName);
    groupName = encodeURIComponent(groupName);
    var parms = "&buddy=" + buddyName + "&group=" + groupName + "&r=" + buddyName + "," + groupName;
    if (showMessage)
    {
        parms += ",true";
    }
    this.sendRequest(this.transactions.removeBuddy, parms, "this.removeBuddyResponse");
}

AIM.prototype.replaceBuddyFromAllGroups = function(buddyName, newBuddyName, groupArray, friendName)
{
    if (groupArray && groupArray.length > 0)
    {
        var count = groupArray.length;
        for (var x = 0; x < count; ++x)
        {
            var groupName = groupArray[x];
            this.removeBuddy(buddyName, groupName, false);
            
            var renameText = (x == count - 1) ? "edit" : "";
            this.addBuddy(newBuddyName, groupName, true, renameText, friendName);
        }
    }
}

AIM.prototype.removeBuddyFromAllGroups = function(buddyName, groupArray, displayMessage)
{
    if (groupArray && groupArray.length > 0)
    {
        var count = groupArray.length;
        var showMessage = displayMessage;
        for (var x = 0; x < count; ++x)
        {
            var groupName = groupArray[x];
            this.removeBuddy(buddyName, groupName, showMessage);
            if (x == 0)
            {
                showMessage = false;
            }
        }
    }
}

AIM.prototype.removeBuddyResponse = function(json)
{
    var response = json.response;
    var buddyInfo = response.requestId;
    var buddyName;
    var groupName;
    var isShowMessage;
    if (buddyInfo)
    {
        buddyInfo = buddyInfo.split(",");
        buddyName = buddyInfo[0];
        groupName = buddyInfo[1];
        if (buddyInfo.length > 3)
        {
            isShowMessage = buddyInfo[2];
        }
    }
    if(response.statusCode == "200")
    {
        if (buddyName && groupName)
        {
            if (this.clientApp) this.clientApp.buddyDeleted(buddyName, groupName, isShowMessage);
        }
    }
    this.updateReconnectStatusWithCode(response.statusCode);
}

AIM.prototype.startSessionResponse =  function(json)
{
    var response = json.response;

    //shell.app.debugLog("AIM.prototype.startSessionResponse - status: "+response.statusCode+", StatusDetailCode: "+response.statusDetailCode+", StatusText: "+response.statusText);

    if(response.statusCode == "200")
    {
        if(!response.data)
        {
            // some kind of error occurred (i started seeing this error 12.12.2006)
            this.onSessionEnd(this.errorCodes.invalidData);
            return;
        }
        // We are now online
        if (this.isReconnect)
        {
            //shell.app.debugLog("AIM.prototype.startSessionResponse - resetting reconnect logic.");
            this.continueOffline = false;
            this.finishReconnect(true);
        }
        this.aimsid = response.data.aimsid;
        this.fetchBaseURL = response.data.fetchBaseURL;
        this.myInfo = response.data.myInfo;
        // Tell the client we are online, in case they want to use that info
        if (this.clientApp) this.clientApp.signedIn(this.myInfo);
        this.parsedBuddyList = false;

        // Get host-based preferences.
        this.getPreference();

        // Setup local preferences
        if (this.clientApp) this.clientApp.setupLocalPreferences();

        this.fetchEvents();
    }
    else if(response.statusCode == "607")
    {
        this.onSessionEnd(this.errorCodes.rateLimited);
    }
    else
    {
        // Error in startSessionResponse
        this.onSessionEnd();

        var msg = response.statusCode + ": " + response.statusText;
        // Tell the client the server has a problem
        if (this.clientApp) this.clientApp.errorOccurred(msg);
    }
}

AIM.prototype.fetchEvents = function(doEndSession)
{
    if(this.fetchBaseURL == null || this.fetchBaseURL == "" || this.aimsid == null)
    {
        //shell.app.debugLog("AIM.prototype.fetchEvents - fetchBaseURL: "+this.fetchBaseURL+"\n");
        //shell.app.debugLog("AIM.prototype.fetchEvents - aimsid: "+this.aimsid+"\n");
        //shell.app.debugLog("AIM.prototype.fetchEvents - aborting fetchEvents\n");
        return;
    }
    
    if(this.fetchEventsTimer)
    {
        //shell.app.debugLog("AIM.prototype.fetchEvents - cancelling fetchEventsTimer.");
        this.fetchEventsTimer.cancel();
        this.fetchEventsTimer = null;
    }
    var urlPieces = this.fetchBaseURL.split("?");
    var url = urlPieces[0];
    var readyState = this.fetchEventsRequest.readyState;
    if(readyState > 0 && readyState < 4)
    {
        //shell.app.debugLog("AIM.prototype.fetchEvents - readyState > 0 && <4. Aborting request in flight.");
        this.fetchEventsRequest.abort();
    }
    
    this.fetchEventsRequest = null;
    this.fetchEventsRequest = new XMLHttpRequest();

    var d = new Date();
    var timeStamp = d.getTime();
    var requestStr = urlPieces[1]+ "&k=" + this.devKey + "&f=json&c=this.fetchEventsResponse&timeout="+this.fetchServerTimeOutMs+"&r="+timeStamp;
    if(doEndSession)
    {
        requestStr += "&endSession=1";
    }
    
    this.fetchEventsRequest.open("GET", url+"?"+requestStr);
    this.fetchEventsRequest.setRequestHeader("Referer", this.referer);
    this.fetchEventsRequest.setRequestHeader("User-Agent", this.userAgent);
    this.fetchEventsRequest.setRequestHeader("Cache-Control", "no-store,no-cache");
    //shell.app.debugLog("AIM.prototype.fetchEvents - Sending Fetch Request: " + url + "?" + requestStr);
    this.fetchEventsRequest.onreadystatechange = rsc_fetch;
    this.fetchEventsRequest.send("");
    this.fetchStartTime = new Date();

    // set up timeout timer //
    //shell.app.debugLog("AIM.prototype.fetchEvents - setting up trackFetchEventsTimer to: "+this.fetchIdleTimeOutMs);
    if (this.trackFetchEventsTimer)
    {
        this.trackFetchEventsTimer.cancel();
        this.trackFetchEventsTimer = null;
    }
    this.trackFetchEventsTimer = setTimeoutObject(this, "fetchEventIdled", this.fetchIdleTimeOutMs);

    // UI //
    if (this.clientApp) this.clientApp.onAIMFetching();
}

AIM.prototype.fetchEventsReadyStateChanged = function()
{
    //shell.app.debugLog("AIM.prototype.fetchEventsReadyStateChanged - Fetch Response: "+this.fetchEventsRequest.readyState);
    if(this.fetchEventsRequest.readyState == this.requestStates.loaded)
    {
        //shell.app.debugLog("AIM.prototype.fetchEventsReadyStateChanged - Fetch start time: "+this.fetchStartTime-0);
        var fetchLatency = (new Date()) - this.fetchStartTime;
        var responseText = this.fetchEventsRequest.responseText;
        var requestStatus = this.fetchEventsRequest.status;
        //shell.app.debugLog("AIM.prototype.fetchEventsReadyStateChanged - Fetch Response (after "+fetchLatency+"ms): <pre>" + responseText + "</pre>");
        //shell.app.debugLog("AIM.prototype.fetchEventsReadyStateChanged - request.status => " + requestStatus + "\n");

        // Cancel fetchEvents timeout timer
        if (this.trackFetchEventsTimer)
        {
            //shell.app.debugLog("AIM.prototype.fetchEventsReadyStateChanged - cancelling trackFetchEventsTimer()");
            this.trackFetchEventsTimer.cancel();
            this.trackFetchEventsTimer = null;
        }

        if(requestStatus == "200")
        {
            if(responseText && responseText != "")
            {
                try
                {
                    //shell.app.debugLog("AIM.prototype.fetchEventsReadyStateChanged - eval()!");
                    eval( '(' + responseText + ')' );
                }
                catch(e)
                {
                    //shell.app.debugLog("AIM.prototype.fetchEventsReadyStateChanged - eval() failed.");
                    // Need to continue the fetch events loop, otherwise we'll get disconnected
                    this.fetchEventsTimer = setTimeoutObject(this, "fireFetchEvents", 500);
                }
            }
            else
            {
                //shell.app.debugLog("AIM.prototype.fetchEventsReadyStateChanged - Um... empty responseText?");
                // Need to continue the fetch events loop, otherwise we'll get disconnected
                this.fetchEventsTimer = setTimeoutObject(this, "fireFetchEvents", 500);
            }
        }
        else if(requestStatus == 460 || requestStatus == 401 || requestStatus > 12000)
        {
            //shell.app.debugLog("AIM.prototype.fetchEventsReadyStateChanged - No success. :(");            

            //shell.app.debugLog("AIM.prototype.fetchEventsReadyStateChanged - initiating reconnect process >>>");            
            this.startReconnect(requestStatus);
        }
        else if (requestStatus)
        {
            // Need to continue the fetch events loop, otherwise we'll get disconnected
            // But only if the requestStatus isn't 0 (aborted)
            this.fetchEventsTimer = setTimeoutObject(this, "fireFetchEvents", 500);
        }
    }
}

AIM.prototype.fetchEventsResponse = function(json)
{
    var eventType;
    var response = json.response;
    var resetFetchIdleTimer = false;
    //shell.app.debugLog("AIM.prototype.fetchEventsResponse - status: "+response.statusCode+ " statusDetailCode: " + response.statusDetailCode + " statusText: " + response.statusText);
    
    // Reset fetchEvents idle counter since we received a response from the server
    this.fetchEventsIdleCounter = 0;
    if (response)
    {    
        if(response.statusCode == "200")
        {
            
            if (this.isReconnect)
            {
                //shell.app.debugLog("AIM.prototype.fetchEventsResponse - isReconnect is true.");
                //shell.app.debugLog("AIM.prototype.fetchEventsResponse - resetting reconnect logic.");
                this.finishReconnect(true);
                this.getBuddyListPresence();
            }
                         
            var payload = json.response.data;
            this.fetchBaseURL = payload.fetchBaseURL;
            if (payload.timeToNextFetch)
            {
                this.timeToNextFetch = payload.timeToNextFetch;
                //shell.app.debugLog("AIM.prototype.fetchEventsResponse - Time to next fetch: "+this.timeToNextFetch+"ms\n");
            }
            else
            {
                this.timeToNextFetch = 0;
            }
            
            // Parse the events since the last fetch
            try
            {
                //shell.app.debugLog("AIM.prototype.fetchEventsResponse - parsing events");
                var events = payload.events;
                eventType = this.processEvents(events);
            }
            catch(e){
                //shell.app.debugLog("AIM.prototype.fetchEventsResponse - exception in processEvents!");
            }

            if (this.timeToNextFetch > 0)
            {
                //shell.app.debugLog("AIM.prototype.fetchEventsResponse - setting up another fetchEventsTimer: "+this.timeToNextFetch);
                this.fetchEventsTimer = setTimeoutObject(this, "fireFetchEvents", this.timeToNextFetch);
            }
        }
        else if(response.statusCode == "460" || response.statusCode =="401")
        {
            // invalid or missing aimsid == we may be signing off and our fetch response came in at the wrong time
            if(!this.isOnline() || this.signingOff)
            {
                //shell.app.debugLog("AIM.prototype.fetchEventsResponse - isOnline: "+this.isOnline()+" signingOff: "+this.signingOff);
                // we have signed off, no worries
                errorCode = null;
                // Always end the session
                this.onSessionEnd(errorCode);
            }
            else
            {
                //shell.app.debugLog("AIM.prototype.fetchEventsResponse - "+response.statusCode+": startReconnect...");
                this.startReconnect(response.statusCode);
            }
        }
        else
        {
            //shell.app.debugLog("AIM.prototype.fetchEventsResponse - Unhandled error in fetchEvents. Status code: "+response.statusCode+"\n");

            //shell.app.debugLog("AIM.prototype.fetchEventsResponse - setting up another fetchEventsTimer: "+500);
            this.fetchEventsTimer = setTimeoutObject(this, "fireFetchEvents", 500);
        }
    }
    else
    {
        //shell.app.debugLog("AIM.prototype.fetchEventsResponse - response is empty...?");
        //shell.app.debugLog("AIM.prototype.fetchEventsResponse - setting up another fetchEventsTimer: "+500);
        this.fetchEventsTimer = setTimeoutObject(this, "fireFetchEvents", 500);
    }
}

AIM.prototype.fetchEventIdled = function()
{
    this.fetchEventsIdleCounter++;
    //shell.app.debugLog("AIM.prototype.fetchEventIdled - fetchEventsIdleCounter: "+this.fetchEventsIdleCounter);

    // If this method is called in multiple succession, we may have lost actual connectivity
    // If the counter got up to 5 or more, we're quite certain our AIM session is dropped.
    if (this.fetchEventsIdleCounter > 5)
    {
        // (for now), artificially start a reconnect using error "460" - "missing required parameter"
        //shell.app.debugLog("AIM.prototype.fetchEventIdled - fetchEventsIdleCounter: "+this.fetchEventsIdleCounter+" (artificially restarting AIM session)");
        this.startReconnect("460");
    }
    else
    {
        this.fireFetchEvents();

        // If we're getting 2 in a row, bolster the connectivity somehow
        if (this.fetchEventsIdleCounter > 2)
        {
            //shell.app.debugLog("AIM.prototype.fetchEventIdled - pinging the server with a getPresenceInfo request.");
            // "server ping" method
            if (this.clientApp)
            {
                var edcRes = this.clientApp.ensureDataConnection();
                //shell.app.debugLog("AIM.prototype.fetchEventIdled - ensureDataConnection: "+edcRes);
            }
            this.getPresenceInfo(this.screenName);
        }
    }
}

AIM.prototype.fireFetchEvents = function()
{
    this.fetchEvents();
}

AIM.prototype.sendIMToBuddy = function(msg, aimID, autoResponse)
{
    // Record a request ID
    var requestID = aimID;
    var parms = "";
    if (autoResponse)
    {
        parms = "&autoResponse=1";
    }
    else
    {
        parms = "&offlineIM=1";
    }
    parms += "&t="+encodeURIComponent(aimID)+"&message="+encodeURIComponent(msg)+"&r="+encodeURIComponent(requestID);
    this.sendRequest(this.transactions.sendTextIM, parms, "this.sendIMToBuddyResponse");
}

AIM.prototype.sendIMToBuddyResponse = function(json)
{
    var response = json.response;
    var buddyInfo = response.requestId;
    var sender;
    if (buddyInfo)
    {
        buddyInfo = buddyInfo.split(",");
        sender = buddyInfo[0];
    }
    if(response.statusCode == "200")
    {
        ////shell.app.debugLog("Sent an IM!");
    }
    else if(response.statusCode == "450")
    {
    }
    else if(response.statusCode == "443")
    {
        // Key used from unauthenticated site??
        //this.onSessionEnd(this.errorCodes.invalidKey);
    }
    else if (response.statusCode == "600" || response.statusCode == "602" || response.statusCode == "603")
    {
        if (this.clientApp) this.clientApp.onSendIMError(sender, response.statusCode);
    }
    else
    {
        ////shell.app.debugLog("Error in send!\n");
    }
    this.updateReconnectStatusWithCode(response.statusCode);
    if (this.clientApp) this.clientApp.onSendIMResponse(sender, response);
}

AIM.prototype.setProfile = function(profileText)
{
    var parms = "&profile="+encodeURIComponent(profileText);
    this.sendRequest(this.transactions.sendTextIM, parms, "this.setProfileResponse");
}

AIM.prototype.setProfileResponse = function(json)
{
    var response = json.response;
    if(response.statusCode == "200")
    {
        ////shell.app.debugLog("Set profile!\n");
    }
    this.updateReconnectStatusWithCode(response.statusCode);
}

AIM.prototype.getBuddyListPresence = function()
{
    var parms = "&bl=1&awayMsg=1&friendly=1&statusMsg=1";
    this.sendRequest(this.transactions.getPresenceInfo, parms, "this.getBuddyListPresenceResponse");        
}

AIM.prototype.getBuddyListPresenceResponse = function(json)
{
    var response = json.response;
    //shell.app.debugLog("AIM.prototype.getBuddyListPresenceResponse - status: "+response.statusCode);
    if(response.statusCode == "200")
    {
        if (this.clientApp) this.clientApp.parseBuddyList(response.data, true);
    }
    this.updateReconnectStatusWithCode(response.statusCode);
}

AIM.prototype.addTempBuddy = function(buddyName)
{
    var parms = "&t=" + encodeURIComponent(buddyName);
    this.sendRequest(this.transactions.addTempBuddy, parms, "this.addTempBuddyResponse");
}

AIM.prototype.addTempBuddyResponse = function(json)
{
    this.updateReconnectStatusWithCode(response.statusCode);
}

AIM.prototype.getProfile = function(buddyName)
{
    var parms = "&t=" + encodeURIComponent(buddyName) + "&awayMsg=1&location=0&memberSince=1&presenceIcon=0&profileMsg=1&statusMsg=1";
    this.sendRequest(this.transactions.getPresenceInfo, parms, "this.getProfileResponse");
}

AIM.prototype.getProfileResponse = function(json)
{
    var response = json.response;
    if(response.statusCode == "200")
    {
        var data = json.response.data;
        if (data)
        {
            if (this.clientApp) this.clientApp.getProfile(data.users[0]);
        }
    }
    this.updateReconnectStatusWithCode(response.statusCode);
}


AIM.prototype.getPresenceInfo = function(buddyName)
{
    var parms = "&t=" + encodeURIComponent(buddyName) + "&awayMsg=1&friendly=1&statusMsg=1";
    this.sendRequest(this.transactions.getPresenceInfo, parms, "this.getPresenceInfoResponse");
}

AIM.prototype.getPresenceInfoResponse = function(json)
{
    var response = json.response;
    if(response.statusCode == "200")
    {
        if (this.clientApp) this.clientApp.getPresence(json.response.data);
    }
    this.updateReconnectStatusWithCode(response.statusCode);
}

AIM.prototype.setTyping = function(aimID, status)
{
    // Record a request ID
    var requestID = aimID;
    // typing : "none", "typing", "typed"
    var parms = "&t="+encodeURIComponent(aimID)+"&typingStatus="+status+"&r="+encodeURIComponent(requestID);
    this.sendRequest(this.transactions.typingStatus, parms, "this.setTypingResponse");
}

AIM.prototype.setTypingResponse = function(json)
{
    var response = json.response;
    if(response.statusCode == "200")
    {
        //don't forget to decodeURIComponent on the requestId when trying to get the screen name from it here!!
        ////shell.app.debugLog("Successfully set typing indicator.\n");
    }
    this.updateReconnectStatusWithCode(response.statusCode);
}

AIM.prototype.setStatusMessage = function(message)
{
    var parms = "&statusMsg=" + encodeURIComponent(message);
    this.sendRequest(this.transactions.setStatus, parms, "this.setStatusResponse");
}

AIM.prototype.setStatusResponse = function(json)
{
    var response = json.response;
    if(response.statusCode == "200")
    {
        // ok
    }
    this.updateReconnectStatusWithCode(response.statusCode);
}

AIM.prototype.setPresence = function(status, msg)
{
    var params = "";
    params += "&view=" + status;        
    if (status == "away")
    {
        params += "&away=" + encodeURIComponent(msg);
    }
    else
    {
        msg = msg ? msg : "";
        params += "&r=" + encodeURIComponent(msg);    
    }
    this.signInPresence = status;
    this.sendRequest(this.transactions.setPresenceState, params, "this.setPresenceResponse");
}

AIM.prototype.setPresenceResponse = function(json)
{
    var response = json.response;
    if(response.statusCode == "200")
    {
        var requestInfo = response.requestId;
        var message;
        if (requestInfo)
        {
            requestInfo = requestInfo.split(",");
            if (requestInfo.length > 1)
            {            
                this.setStatusMessage(requestInfo[0]);
            }
        }
    }
    this.updateReconnectStatusWithCode(response.statusCode);
}

AIM.prototype.signOff = function()
{
    this.clientApp.signedOut();

    //  When a sign off is requested - if we have signed in or not nothing
    //shell.app.debugLog("AIM.prototype.signOff - Signing off...\n");
    if (this.aimsid)
    {
        if(this.fetchEventsTimer)
        {
            this.fetchEventsTimer.cancel();
            this.fetchEventsTimer = null;
        }
        if(this.trackFetchEventsTimer)
        {
            this.trackFetchEventsTimer.cancel();
            this.trackFetchEventsTimer = null;
        }
        
        //shell.app.debugLog("AIM.prototype.signOff - Need to sign off AIM: "+this.aimsid+", "+this.currentConnectStatus+"\n");
        this.finishReconnect(false);
        if (this.clientApp) this.clientApp.updateNotificationBoxMessage();
        this.continueOffline = false;
        // we are in a session, send over endSession
        this.signingOff = true;

        ////shell.app.debugLog("AIM.prototype.signOff - Sending endSession request.\n");
        this.sendRequest(this.transactions.endSession, null, "this.endSessionResponse");
        
        // clean up cached screenname and password
        this.screenname = null;
        this.password = null;
        this.permitMode = null;
    }
    else
    {
        //shell.app.debugLog("AIM.prototype.signOff - signOff called before AIM session started.\n");
        // We may be signing off during initial authentication sequence.
        // Make sure we abort any startSignedSession request in flight...
        if (this.request)
        {
            if(this.request.readyState > 0 && this.request.readyState < 4)
            {
                //shell.app.debugLog("AIM.prototype.signOff - Aborting xmlHttpRequest currently in flight: "+this.request.readyState+", "+this.request.status+"\n");
                //shell.app.debugLog("this.request.abort()");
                this.request.abort();
            }
        }
            
        // If the authentication code managed to progress this far, logout.
        if (_clientLogin.openAuth.sessionKey)
        {
            //shell.app.debugLog("AIM.prototype.signOff - Logging out of clientLogin\n");
            //shell.app.debugLog("_clientLogin.logout()");
            _clientLogin.logout();
        }
        else
        {
            //shell.app.debugLog("_clientLogin.reset()");
            _clientLogin.reset();
        }
        
    }
}

AIM.prototype.endSessionResponse = function(json)
{
    if(json.response.statusCode != "200")
    {
        // invalid or missing aimsid == we're probably signed off already (a result of a remote sign off)
        this.onSessionEnd();
    }
    //shell.app.debugLog("AIM.prototype.endSessionResponse - endSessionResponse");
    _clientLogin.logout();
}

AIM.prototype.onSessionEnd = function(errorCode)
{
    if(this.fetchEventsTimer)
    {
        this.fetchEventsTimer.cancel();
        this.fetchEventsTimer = null;
    }
    if(this.trackFetchEventsTimer)
    {
        this.trackFetchEventsTimer.cancel();
        this.trackFetchEventsTimer = null;
    }
    // if we have a fetch request active, abort it()
    var fetchReadyState = this.fetchEventsRequest.readyState;
    if(fetchReadyState > 0 && fetchReadyState < 4)
    {
        this.fetchEventsRequest.abort();
    }
    this.permitMode = null;
    this.aimsid = null;
    this.fetchBaseURL = null;
    this.timeToNextFetch = 0;
    this.signingOff = false;
    this.parsedBuddyList = false;
    /* clean up screenscraping vars */
    
    this.signInPresence = null;
    if(errorCode)
    {
        this.clientApp.errorOccurred(errorCode);
    }
    this.blockedList = null;
    this.allowedList = null;
    this.clientApp.signedOff();
}


// GLOBAL READYSTATE CHANGED listeners for maxiXML object
// Basically just passes the callback to the correct ones inside
// the AIM object
var _aim = null;
function rsc_global()
{
    if (_aim)
    _aim.responseReadyStateChanged();
}
// This is used by the main request object, but only during authentication (because it is hacking into html)
function rsc_startSession()
{
    if (_aim)
    _aim.startSessionReadyStateChanged();
}
function rsc_fetch()
{
    if (_aim)
    _aim.fetchEventsReadyStateChanged();
}


// callback called by ClientLogin after a successful signOn
AIM.prototype.clPostSignOn = function()
{
    this.startSignedSession();
}

// Called if clientLogin.signOn returns status 3011 (Passwd-Login Reqd/Invalid)
AIM.prototype.clAuthError = function(inStr)
{
    if (this.clientApp) this.clientApp.clAuthError();
}
// Called if clientLogin.signOn returns status 3012 (SecurId Reqd/Invalid) or 3013 (SecurId Next Token Required)
AIM.prototype.clEnterPasscode = function(inStr)
{
    securityIdChanllege();
}
// Called if clientLogin.signOn returns status 3015 (Captcha Reqd/Invalid)
AIM.prototype.clEnterCaptcha = function(inStr, inUrl)
{
    //shell.app.debugLog("Gather captcha info: " + inStr + " " + inUrl);
    captchaChallenge(inStr, inUrl);
}

// Called if clientLogin.signOn returns a status we don't handle (yet?)
AIM.prototype.clSignOnError = function(inStr)
{
    // Tell the client the server has a problem
    if (this.clientApp) this.clientApp.errorOccurred(inStr);
}

AIM.prototype.setSignInPresence = function(presence)
{
    this.signInPresence = presence;
}

AIM.prototype.getSignInPresence = function()
{
    return this.signInPresence;
}

AIM.prototype.getToken = function()
{
    return (_clientLogin) ? _clientLogin.openAuth.authToken : null;
}

AIM.prototype.getSessionKey= function()
{
    return (_clientLogin) ? _clientLogin.openAuth.sessionKey : null;
}

AIM.prototype.startSignedSession = function()
{
    var queryString = "";
    var sig_sha256 = "";

    // Set up params in alphabetical order
    queryString += "a="+encodeStrPart(_clientLogin.openAuth.authToken);
    queryString += "&clientName="+encodeStrPart(_clientLogin.openAuth.clientName);
    queryString += "&clientVersion="+encodeStrPart(_clientLogin.openAuth.clientVersion);
    queryString += "&events="+encodeStrPart("myInfo,presence,buddylist,im,dataIM,offlineIM");
    queryString += "&f=json";
    queryString += "&k="+_clientLogin.openAuth.devId;
    queryString += "&language="+shell.app.locale.toLowerCase();
    queryString += "&sessionTimeout=240";
        
    var now = new Date().getTime() / 1000;
    queryString += "&ts="+parseInt(_clientLogin.openAuth.hostTime + Math.floor(now - _clientLogin.openAuth.clientTime));
    
    if (this.signInPresence)
    {
        queryString += "&view=" + this.signInPresence;
    }

    var encodedQuery = escape(queryString);
    var requestURL = this.baseURI + this.transactions.startSession;

    // Generate OAuth Signature Base
    var sigBase = "GET&"+encodeStrPart(requestURL)+"&"+encodedQuery;
    //shell.app.debugLog("AIM.prototype.startSignedSession - Signature Base : "+sigBase);
    //shell.app.debugLog("AIM.prototype.startSignedSession - _clientLogin.openAuth.sessionKey : "+_clientLogin.openAuth.sessionKey);
    
    // Generate hash signature
    var sigData = shell.crypto.hmacSHA256Encode(_clientLogin.openAuth.sessionKey, sigBase);
    sig_sha256 = sigData;
    //shell.app.debugLog("AIM.prototype.startSignedSession - Signature Hash : "+encodeURIComponent(sig_sha256));

    // Append the sig_sha256 data
    queryString += "&sig_sha256="+encodeURIComponent(sig_sha256);
    //shell.app.debugLog("AIM.prototype.startSignedSession - StartSessionQuery: "+queryString);

    this.request = null;
    this.request = new XMLHttpRequest();
    this.request.open("GET", requestURL+"?"+queryString);
    this.request.setRequestHeader("User-Agent", this.userAgent);
    this.request.setRequestHeader("Cache-Control", "no-store,no-cache");
    this.request.onreadystatechange = rsc_startSession;
    this.request.send("");

    //shell.app.debugLog("AIM.prototype.startSignedSession - Sending startSession...\n");


    //var parms = "&events=im,myInfo,buddylist,presence";
    //this.sendRequest(this.transactions.startSession, parms, "this.startSessionResponse");
}

AIM.prototype.startSessionReadyStateChanged = function()
{
    if(this.request.readyState == this.requestStates.loaded)
    {
        //shell.app.debugLog("AIM.prototype.startSessionReadyStateChanged");
        var requestStatus = this.request.status;
        var statusText    = this.request.statusText;
        var responseText  = this.request.responseText;
        //shell.app.debugLog("AIM.prototype.startSessionReadyStateChanged - status: " + requestStatus + " statusText: " + statusText);
        //shell.app.debugLog("AIM.prototype.startSessionReadyStateChanged - responseText: " + responseText);

        if(requestStatus == 200)
        {
            if(responseText && responseText != "")
            {
                var json = eval( '(' + responseText + ')' );
                this.startSessionResponse(json);
            }
            else
            {
                //shell.app.debugLog("AIM.prototype.startSessionReadyStateChanged - Got empty text...\n");
                this.clientApp.errorStartingAIM();
            }
        }
        else if (this.isReconnect)
        {
            //shell.app.debugLog("AIM.prototype.startSessionReadyStateChanged - reconnect in progress. Attempt again.\n");
            this.startReconnect(requestStatus);
        }
        else if (requestStatus > 0)
        {
            //shell.app.debugLog("AIM.prototype.startSessionReadyStateChanged - Error back from server signing on to aim...: "+requestStatus+"\n");
            // Error at the server
            this.clientApp.errorServerError(requestStatus);
        }
    }
}

AIM.prototype.processEvents = function(events)
{
    var eventType;
    var eventQueue = (!this.parsedBuddyList) ? new Array() : null;
    if(events && events.length >= 1)
    {
        for(var i=0; i<events.length; i++)
        {
            var evt = events[i];
            //shell.app.debugLog("AIM.prototype.processEvents - event type: <b>:"+evt.type+"</b>\n");
            // evt has a type and eventData
            eventType = evt.type;
            switch(eventType)
            {
                case "presence":
                {
                    if(this.parsedBuddyList)
                    {
                        if (this.clientApp) this.clientApp.presenceUpdated(evt.eventData, false);
                    }
                    else
                    {
                        eventQueue.push(evt);
                    }
                    break;
                }
                case "im":
                {
                    // Im object received, send to client
                    if (this.clientApp) this.clientApp.receivedIM(evt.eventData, this.myInfo);
                    break;
                }
                case "offlineIM":
                {
                    if(this.parsedBuddyList)
                    {
                        //Offline IMs received. send to client.
                        if (this.clientApp) this.clientApp.receivedOfflineIM(evt.eventData, this.myInfo);
                    }
                    else
                    {
                        eventQueue.push(evt);
                    }
                    break;

                }
                case "dataIM":
                {
                    if (this.clientApp) this.clientApp.receivedDataIM(evt.eventData, this.myInfo);
                    break;
                }
                case "buddylist":
                {
                    this.currentConnectStatus = this.connectStatus.buddylist;
                    if (this.clientApp) this.clientApp.connectStatusUpdated(this.currentConnectStatus);
                    if (this.clientApp)
                    {
                        this.clientApp.parseBuddyList(evt.eventData);
                        if(!this.parsedBuddyList)
                        {
                            this.parsedBuddyList = true;
                        }
                    }
                    break;
                }
                case "sessionEnded":
                {
                    if (this.signingOff)
                    {
                        this.onSessionEnd();
                    }
                    else
                    {
                        if (this.clientApp) this.clientApp.systemSignedOff();
                    }
                    break;
                }
                case "typing":
                {
                    if (this.clientApp) this.clientApp.onBuddyTypingUpdated(evt.eventData);
                    break;
                }
                case "myInfo":
                {
                    if (this.clientApp) this.clientApp.myInfoUpdated(evt.eventData);
                    break;
                }
                default:
                {
                    //shell.app.debugLog("AIM.prototype.processEvents - couldn't find a matching eventType: "+eventType);
                    break;
                }
            } //end of switch
        }//end of for
    }//end of if

    if(eventQueue && eventQueue.length >=1)
    {
        this.processEvents(eventQueue);
        //clean up the queue. This queue should be used only once, during signon process
        //to avoid race condition.
        eventQueue = null;
    }
    return eventType;
}

AIM.prototype.getCurrentScreenname = function()
{
    return this.screenName;
}

AIM.prototype.getPreference = function()
{
    // blank parms will gets us all the prefs, but we're only interested in these two for now.
    var parms = "&noSeeRecentBuddies=1&acceptOffLineIM=1";
    this.sendRequest(this.transactions.getPreference, parms, "this.getPreferenceResponse");        
}

AIM.prototype.getPreferenceResponse = function(json)
{
    var response = json.response;
    if(response.statusCode == "200")
    {
        // ok
        if (this.clientApp) this.clientApp.processPreferenceResponse(json.response);
    }
    this.updateReconnectStatusWithCode(response.statusCode);
}

AIM.prototype.setPreference = function(prefEnum, prefBool)
{
    var boolVal = prefBool ? 1 : 0;
    var parms = "&"+prefEnum+"="+boolVal;
    this.sendRequest(this.transactions.setPreference, parms, "this.setPreferenceResponse");        
}

AIM.prototype.setPreferenceResponse = function(json)
{
    var response = json.response;
    if(response.statusCode == "200")
    {
        // ok
    }
    this.updateReconnectStatusWithCode(response.statusCode);
}

AIM.prototype.getPermitDeny = function()
{
    this.sendRequest(this.transactions.getPermitDeny, null, "this.getPermitDenyResponse");        
}

AIM.prototype.getPermitDenyResponse = function(json)
{
    var response = json.response;
    if(response.statusCode == "200")
    {
        // ok
        if (this.clientApp) this.clientApp.processPermitDenyResponse(json.response);
    }
    this.updateReconnectStatusWithCode(response.statusCode);
}

AIM.prototype.setPermitDeny = function(pdEnum, pdVal, useRequestId)
{
    /* Valid pdEnums: pdAllow, pdBlock, pdIgnore, pdAllowRemove, pdBlockRemove, pdIgnoreRemove, pdMode */
    var encodedVal = encodeURIComponent(pdVal);
    var parms = "&"+pdEnum+"="+encodedVal;
    // Block buddy setting only works if we set the pdMode to 'denySome'
    if (pdEnum == "pdBlock" || pdEnum == "pdBlockRemove")
    {
        if (pdEnum == "pdBlock")
        {
            //Add to blockedList
            if (this.blockedList)
            {
                this.blockedList.addValue(pdVal);
            }
            parms += "&pdMode=denySome";
            this.permitMode = "denySome";
            if (this.clientApp) this.clientApp.updatePrivacyLevel("denySome");
        }
        else if(pdEnum == "pdBlockRemove" && this.blockedList)
        {
             //Remove from blockedList
             this.blockedList.removeValue(pdVal);
        }
        if (useRequestId)
        {
            parms += "&r=" + pdEnum + "," + encodedVal;
        }
    }
    else
    {
        this.permitMode = pdVal;
    }
    this.sendRequest(this.transactions.setPermitDeny, parms, "this.setPermitDenyResponse");
}

AIM.prototype.setPermitDenyResponse = function(json)
{
    var response = json.response;
    if(response.statusCode == "200")
    {
        var requestId = response.requestId;
        var mode;
        var buddyName;
        if (requestId)
        {
            requestId = requestId.split(",");
            mode = requestId[0];
            buddyName = requestId[1];
        }
        if (this.clientApp) this.clientApp.setPermitDeny(mode, buddyName)
    }
    this.updateReconnectStatusWithCode(response.statusCode);
}

AIM.prototype.reportSPIM = function(screenname, spimType, spimEvent)
{
    /*
        Valid spimType: abusive, spim
        Valid spimEvent: user, decline, swAuth, swim
    */
    var parms = "&t="+encodeURIComponent(screenname)+"&spimType="+spimType+"&spimEvent="+spimEvent+"&r=" + screenname + "," + spimType;
    this.sendRequest(this.transactions.reportSPIM, parms, "this.reportSPIMResponse");        
}

AIM.prototype.reportSPIMResponse = function(json)
{
    var response = json.response;
    if (this.clientApp) this.clientApp.reportSpam(response.requestId, response.statusCode, response.statusDetailCode)
    this.updateReconnectStatusWithCode(response.statusCode);
}

AIM.prototype.setGroupAttribute = function(groupName, attribute, value)
{
    /*
        Valid attributes: collapsed
    */
    if (groupName != "Offline Buddies")
    {
        var parms = "&group="+encodeURIComponent(groupName)+"&"+attribute+"="+value;
        this.sendRequest(this.transactions.setGroupAttribute, parms, "this.setGroupAttributeResponse");        
    }
}

AIM.prototype.setGroupAttributeResponse = function(json)
{
    var response = json.response;
    if(response.statusCode == "200")
    {
        // ok
    }
    this.updateReconnectStatusWithCode(response.statusCode);
}

/**
 * Escapes additional characters that encodeURI or encodeURIComponent doesn't handle
 */
function encodeStrPart(s)
{
    var r = encodeURIComponent(s);
    r = r.replace(/\+/, "%2B");
    r = r.replace(/_/, "%5F");
    return r;
}