// ****************************************************************************
//
// Copyright ?2008 AOL LLC  All rights reserved.
// This software contains valuable confidential and proprietary information
// of AOL LLC and is subject to applicable licensing agreements.
// Unauthorized reproduction, transmission or distribution of this file and
// its contents is a violation of applicable laws.
//
//           A O L  L L C   C O N F I D E N T I A L
//
// ****************************************************************************

var gAimCallbacks =
{
    buddyListGadget : null,

    sessionUpdated : function(aimsid)
    {
    },
    clAuthError : function()
    {
        this.errorOccurred(scene.rootBox.getAttribute("signon.message.screenNamePasswordError"));
        scene.getBoxById("authPanelBox").clearStorageForCurrentUser();
    },
    errorStartingAIM : function()
    {
        this.errorOccurred(scene.rootBox.getAttribute("signon.message.errorStartingSession"));
    },
    errorServerError : function(code)
    {
        this.errorOccurred(formatString1(scene.rootBox.getAttribute("signon.message.serverError"), code));
    },
    signedIn : function(myInfo)
    {
        // Display online icon
        try
        {
            shell.app.appIcon = 2;
        }
        catch (e){}
        
        var buddyListObj = scene._buddyListObj;
        var buddyListExisted = buddyListObj.groups.count > 0;
        var contentContainer = scene.getBoxById("contentContainer");
        if (scene.prefObj.enableAllTransitions && !buddyListExisted)
        {
            takeSnapshot(contentContainer);
        }
        
        var loginStatusBox = scene.getBoxById("loginStatusBox");
        if (!loginStatusBox.collapsed)
        {
            loginStatusBox.collapsed = true;
        }
        
        authSignedOn(myInfo);
        if (!buddyListExisted)
        {
            contentContainer.showPanelByAttribute(panelAttribute_buddyList);
            if (scene.prefObj.enableAllTransitions)
            {
                doTransition(contentContainer, "zoomIn", 500, "ease");
            }
            
            //Software Update: under certain condition call:
            //notifyUpdateOnCarousel();
            var updateAvailable = scene.updateObj.isUpdateAvailable();
            if (updateAvailable == true)
            {
                notifyUpdateOnCarousel();
            }
            scene.focusedBox = null;
            updateNotificationBox("#reconnect.pending", scene.rootBox.getAttribute("bl.message.loadingBuddyList"));
        }
        else
        {
            scene.getBoxById("buddyList").setPresence(scene.AIMobj.getSignInPresence());
        }
        
        var showMail;
        try
        {
            var storeName = scene.prefObj.prefsGetStoreForCurrentIdentity();
            if (storeName)
            {
                var kvs = new keyValueStorage();
                kvs.open(storeName);
                showMail = kvs.getValue( scene.prefObj.showMailCountKey , scene.prefObj.showMailCountKeyDefaultValue );
                kvs.close();
                kvs = null;
            }
        }
        catch (e) {}
        
        showMailIcon(showMail.toString());
        scene.adControllerObj.init();
        
        // Delete the current data
        var groups = scene._buddyListDataSrc;
        groups.removeAllValues();


        // Create our buddy list collection data
        var buddyListObj = scene._buddyListObj;
        
        // add the ad to the buddy list
        var blAd = new objBuddyListAd();
        groups.addValue(blAd);
    
         // Add the offline buddy group as a special case
        var offlineGroup = new objBuddyListGroup(null);
        if (offlineGroup)
        {
            offlineGroup.name = GROUPID_OFFLINE_BUDDIES;
            offlineGroup.collapsed = 1;
            groups.addValue(offlineGroup);
        }
        scene.paint();
    },
    parseBuddyList : function(blData)
    {
        //shell.app.debugLog("aimClientCallbacks.js - parseBuddyList ");

        if (!gAimOnline && blData && scene.AIMobj.isOnline())
        {
            //get the privacy list.
            scene.AIMobj.getPermitDeny();
            
            updateNotificationBox("#reconnect.pending", scene.rootBox.getAttribute("bl.message.loadingBuddyList"));
        
            //shell.app.debugLog("aimClientCallbacks.js - parseBuddyList - actually parse the data");
            gAimOnline = true;
            
            // Create our buddy list collection data
            var buddyListObj = scene._buddyListObj;
            var buddyList = scene.getBoxById("buddyList");
            scene.getBoxById("chatPanel").setSignedInScreenName(buddyList.getAttribute("aimId"));
            
            // Iterate the groups and create each one
            var groupsObj = blData.groups;
            for (var g=0; g < groupsObj.length; ++g)
            {
                var group = groupsObj[g];
                buddyListObj.insertGroup(new objBuddyListGroup(group));
                if(g < 3)
                {
                    // only update the screen for the first 3 groups
                    // after that most buddy lists are being needlessly
                    // updated for groups that are off the screen.
                    scene.paint();
                }
            }
            
            // Populate the offline buddy group
            buddyListObj.buildOfflineBuddyGroup();
            
            scene.paint();
         
            updateNotificationBox();

            // Set focus/selection to the first buddy in the list
            buddyList.selectFirstBuddyListGroup();

            if (!scene.focusedBox)
            {
                scene.focusedBox = scene.getBoxById("buddyList").getPartById("buddyListGrid");
            }
            updateConversations();
            
            var buddyListAdBox = scene.getBoxById("buddyListAdBox");
            if (buddyListAdBox)
            {
                buddyListAdBox.setAttribute("respectUIScale", scene.rootBox.getAttribute("respectUIScale"));
                buddyListAdBox.TSMretrieveAd();
            }
        }
        else
        {
            //shell.app.debugLog("aimClientCallbacks.js - parseBuddyList: ignored buddylist update ");
        }
    },
    signedOut : function()
    {
        scene.adControllerObj.release();
    },

    errorOccurred: function(msg)
    {
        gAimOnline = false;
        var text = msg == "rateLimited" ? scene.rootBox.getAttribute("signon.message.rateLimited") : msg;
        loginError(text + ".");
    },
    onAIMFetching : function ()
    {
        //shell.print("fetching\n");    
    },
    receivedIM:function(imData, myInfo)
    {
        var source = imData.source;
        var message = imData.message;
        
        var autoAcceptUnknown = scene.prefObj.autoAcceptUnknownDefaultValue;
        var displayNotification = true;
        try
        {
            var storeName = scene.prefObj.prefsGetStoreForCurrentIdentity();
            if (storeName)
            {
                var kvs = new keyValueStorage();
                kvs.open(storeName);
                autoAcceptUnknown = kvs.getValue( scene.prefObj.autoAcceptUnknownKey , scene.prefObj.autoAcceptUnknownDefaultValue );
                autoAcceptUnknown = autoAcceptUnknown.toString() == "true";

                displayNotification = kvs.getValue( scene.prefObj.externalNotifyKey , scene.prefObj.externalNotifyDefaultValue );
                displayNotification = displayNotification.toString() == "true";
                kvs.close();
                kvs = null;
            }
        }
        catch (e) {}
        
        if (source.friendly)
        {
            source.displayId = source.friendly;
        }
        
        var buddyInfo = scene._buddyListObj.getBuddyInfo(source.aimId);
        if (buddyInfo)
        {   
            // we need to do this here because WIM return "online" state for "invisible" buddy
            source.state = buddyInfo.state;
        }
        else if (!autoAcceptUnknown && source.aimId != "aolsystemmsg")
        {
            source.state= "unknown";
            source.buddyIcon = "#buddyList.unknownUser";
        }
        
        scene.getBoxById("chatPanel").receivedIM(source, message, imData.autoresponse);
        
        var carousel = scene.getBoxById("activeConversationBar");
        var contentContainer = scene.getBoxById("contentContainer");
        if (contentContainer.getAttribute(panelAttribute_chatPanel) == "false" || carousel.getActiveBuddy() != source.aimId)
        {
            source.flags = 2;      
            scene._buddyListObj.updateBuddiesFromObj(source);
            carousel.onReceivedIM(source.aimId);
        }

        this.playReceivedIMSound();
        
        //
        // Create a notification toast for received messages while running in the background
        //
        try
        {        
            if(displayNotification)
            {
                // Wake up the device
                shell.device.setPowerState("ON");
            
                if (!scene.rootBox.active)
                {
                    var rootBox = scene.rootBox;
                    var buddy = source.displayId;
                    var message;
                    var imType = "knownIM";
                    if (source.state == "unknown")
                    {
                        message = formatString1(rootBox.getAttribute("unknownUser.notifyOutsideClient"), buddy);
                        imType = "unknownIM";
                    }
                    else
                    {
                        message = formatString2(rootBox.getAttribute("im.notifyOutsideClient"), buddy, message);
                        imType = "knownIM";
                    }
                    shell.app.newNotification(scene, "<html><body>" + message + "</body></html>", source.aimId, 10, imType);
                    shell.device.playSoundOrVibrate("sysSoundExclamation", 250, 250, 2);
                }
            }
        }
        catch (e){}
        
        //
        // Receiving an IM is an action that can trigger an ad refresh
        //
        if (scene.adControllerObj)
        {
            scene.adControllerObj.trigger();
        }
    },
    
    receivedOfflineIM:function(offlineIMData, myInfo)
    {
        var aimId = offlineIMData.aimId;
        var message = offlineIMData.message;
        var buddyInfo = scene._buddyListObj.getBuddyInfo(aimId);
        if (!buddyInfo)
        {
            // TODO This buddy is not in the buddy list 
            // we should notify user and see if he wants to see the message
            // and perhaps add the user to buddylist?
        }
        else
        {
            scene.getBoxById("chatPanel").receivedOfflineIM(buddyInfo, message, offlineIMData.timestamp);
            
            var carousel = scene.getBoxById("activeConversationBar");
            var contentContainer = scene.getBoxById("contentContainer");
            if (contentContainer.getAttribute(panelAttribute_chatPanel) == "false" || carousel.getActiveBuddy() != aimId)
            {
                if (buddyInfo)
                {
                    buddyInfo.flags = 2;      
                    scene._buddyListObj.updateBuddiesFromObj(buddyInfo);
                }
                carousel.onReceivedIM(aimId);
                carousel.setVisible(true);   
            }

            this.playReceivedIMSound();
        }
    },

    playReceivedIMSound : function()
    {
        if (scene.rootBox.active)
        {
            try
            {
                var store = scene.prefObj.prefsGetStoreForCurrentIdentity();
                if (store)
                {
                    var kvs = new keyValueStorage();
                    kvs.open( store );
                    var playIMSound = kvs.getValue(scene.prefObj.playIMSoundKey, scene.prefObj.playIMSoundDefaultValue);
                    kvs.close();
                    if (playIMSound.toString() == "true")
                    {
                        var path = shell.app.path + "\\resources\\imrcv.wav";
                        shell.device.playSoundOrVibrate(path, 100, 0, 0);
                    }
                }
            }
            catch (e)
            {
            }
        }
    },
    processBuddyInfo : function (pData, manualUpdate)
    {
        if (pData)
        {
            // Update the buddy list collection data
            var cacheMode = scene.AIMobj.getPermitMode();
            if (cacheMode)
            {
                if (cacheMode == "denySome")
                {
                    var blockedList = scene.AIMobj.getBlockedList();
                    if (blockedList && blockedList.containsValue(pData.aimId))
                    {
                        pData.state = "blocked";
                    }
                }
                else if (cacheMode == "denyAll")
                {
                    pData.state= "blocked";
                }
                else if (cacheMode == "permitSome")
                {
                    var allowedList = scene.AIMobj.getAllowedList();
                    if (allowedList && !allowedList.containsValue(pData.aimId))
                    {
                        pData.state = "blocked";
                    }
                }
            }
            
            var buddyInfo = scene._buddyListObj.getBuddyInfo(pData.aimId);
            if (buddyInfo)
            {
                if (buddyInfo.state != pData.state)
                {
                    if (pData.state == "mobile")
                    {
                        pData.buddyIcon = "#buddyList.placeHolderText";
                    }
                    else if (buddyInfo.state == "mobile")
                    {
                        if (!pData.buddyIcon)
                        {
                            pData.buddyIcon = "#buddyList.placeHolderBuddy";
                        }
                    }
                    else if (cacheMode == "permitOnList" && buddyInfo.groupId == "Recent Buddies")
                    {
                        pData.state= "blocked";
                    }
                    if (!manualUpdate)
                    {
                        scene.getBoxById("buddyList").buddyPresenceUpdate(pData.aimId, pData.state);
                    }
                }
            }
            else if (!pData.buddyIcon)
            {
                pData.buddyIcon = "#buddyList.placeHolderBuddy";
            }
            if (pData.friendly)
            {
                pData.displayId = pData.friendly;
            }
        }
    },
    getProfile : function (pData)
    {
        this.processBuddyInfo(pData, true);
        this.displayBuddyInfo(pData, true);
        if (!scene.getBoxById("profileBox").collapsed)
        {
            if (!scene.AIMobj.getIsReconnect() && !scene.AIMobj.getContinueOffline())
            {
                updateNotificationBox();  
            }
        }
    },
    displayBuddyInfo : function (pData, isUpdateProfile)
    {
        var profileBox = scene.getBoxById("profileBox");
        if (!profileBox.collapsed)
        {
            profileBox.updateProfile(pData, isUpdateProfile);
        }
    },
    getPresence : function (pData)
    {
        if (pData && pData.users && pData.users.length > 0)
        {
            this.presenceUpdated(pData.users[0], true);
        }
    },
    presenceUpdated : function (pData, manualUpdate)
    {
        this.processBuddyInfo(pData, manualUpdate);
        scene._buddyListObj.updateBuddiesFromObj(pData);
        
        var carousel = scene.getBoxById("activeConversationBar");
        if (carousel)
        {
            if (carousel.updateBuddyPresence(pData) || manualUpdate)
            {
                var conversationWindow = scene.getBoxById("chatPanel");
                if (conversationWindow)
                {
                    conversationWindow.updateBuddyPresence(pData, manualUpdate);
                }
            }
        }
        this.displayBuddyInfo(pData, false);
    },

    getPresenceInfoReceived : function (piData)
    {
    },

    onBuddyTypingUpdated : function (tData)
    {
    },

    onSendIMResponse : function(aimId, eData)
    {
        //
        // Sending an IM is an action that can trigger an ad refresh
        //
        if (scene.adControllerObj)
        {
            scene.adControllerObj.trigger();
        }
    },
    signedOff : function ()
    {
        gAimOnline = false;
        
        // Display offline icon
        try
        {
            shell.app.appIcon = 1;
        }
        catch (e){}
    },
    connectStatusUpdated : function(connectStatus)
    {
    },
    
    myInfoUpdated : function (updatedInfo)
    {
    },
    groupAdded : function (groupName)
    {
        // Update the buddy list collection data
        scene._buddyListObj.addGroup(groupName, false);
        updateNotificationBox(null, formatString1(scene.rootBox.getAttribute("bl.pendingAction.added"), groupName), 2000);
    },
    groupDeleted : function (groupName)
    {
        // Update the buddy list collection data
        scene._buddyListObj.deleteGroup(groupName, false);
        updateNotificationBox(null, formatString1(scene.rootBox.getAttribute("bl.pendingAction.deleted"), groupName), 2000);
    },
    groupUpdated : function (oldName, newName)
    {
        // Update the buddy list collection data
        scene._buddyListObj.renameGroup(oldName, newName, false);
        updateNotificationBox(null, formatString1(scene.rootBox.getAttribute("bl.pendingAction.rename"), newName), 2000);
    },
    buddyDeleted : function (screenName, groupName, isShowMessage)
    {
        // Update the buddy list collection data
        scene._buddyListObj.deleteBuddy(screenName, groupName, false);
        if (!scene._buddyListObj.getBuddyInfo(screenName))
        {
            var unknownBuddyObj = new Object();
            unknownBuddyObj.aimId = screenName;
            unknownBuddyObj.displayId = screenName;
            
            var carouselBar = scene.getBoxById("activeConversationBar");
            var icon = carouselBar.findBuddy(screenName);
            if (icon)
            {
                unknownBuddyObj.state= "unknown";
                unknownBuddyObj.buddyIcon = "#buddyList.unknownUser";
                icon.setPresence(unknownBuddyObj.state);
                icon.setAttribute("buddyIcon", unknownBuddyObj.buddyIcon);
            }
            scene.getBoxById("chatPanel").updateBuddyPresence(unknownBuddyObj, true);
        }
        if (isShowMessage)
        {
            updateNotificationBox(null, formatString1(scene.rootBox.getAttribute("bl.pendingAction.deleted"), screenName), 2000);
        }
    },
    buddyDeletedFailed : function (screenName)
    {
        //TO DO get the buddy prensece back...   
    },
    buddyAdded : function (screenName, groupName, messageType)
    {
        // Update the buddy list collection data
        scene._buddyListObj.addBuddy(screenName, groupName, false);
        
        if (messageType)
        {   
            var message = (messageType == "add") ? "bl.pendingAction.added" : "bl.pendingAction.rename";
            updateNotificationBox(null, formatString1(scene.rootBox.getAttribute(message), screenName), 2000);
        }
        
        scene._buddyListObj.deleteBuddy(screenName, "Recent Buddies",false);
    },
    onSendIMError : function (screenName, errorCode)
    {
        var message = (errorCode == 603) ? "im.mobile.noOfflineIM" : "im.mobile.notAvailable";
        scene.getBoxById("chatPanel").addAlertForScreenName(screenName, formatString1(scene.rootBox.getAttribute(message), screenName));
    },
    reconnecting : function (reconnecting)
    {
        scene.getBoxById("contentContainer").setAttribute("reconnecting", reconnecting ? "true" : "false");
        if (reconnecting)
        {
            try
            {
                if (scene.mailObj)
                {
                    scene.mailObj.cancelCheckMailTimer();
                }
            }
            catch(e){}
        }
    },
    reconnectLimitReached : function ()
    {
        scene.getBoxById("buddyList").reconnectLimitReached();
    },
    reconnectSucceeded : function ()
    {
        // Display online icon
        try
        {
            shell.app.appIcon = 2;
        }
        catch (e){}
    
        this.reconnecting(false);
        updateNotificationBox("#reconnect.connected", scene.rootBox.getAttribute("reconnect.connected"), 4000);
        scene.getBoxById("chatPanel").setHideReconnectPopup();
        
        try
        {
            if (scene.mailObj)
            {
                scene.mailObj.checkMail();
            }
        }
        catch(e){}
    },
    updateNotificationBoxMessage : function (icon, message, millisecond)
    {
        updateNotificationBox(icon, message, millisecond);
    },
    ensureDataConnection : function()
    {
        var isConnected = true;
        try
        {
            isConnected = shell.device.ensureDataConnection();
        }
        catch(err)
        {
        }
        return isConnected;
    },
    setupLocalPreferences : function()
    {
        // Set up local preferences
        var showStatusAndAwayMessages = scene.prefObj.showStatusAndAwayMessagesDefaultValue;
        try
        {
            var storeName = scene.prefObj.prefsGetStoreForCurrentIdentity();
            if (storeName)
            {
                var kvs = new keyValueStorage();
                kvs.open(storeName);
                showStatusAndAwayMessages = kvs.getValue( scene.prefObj.showStatusAndAwayMessagesKey , scene.prefObj.showStatusAndAwayMessagesDefaultValue );
                kvs.close();
                kvs = null;
            }
        }
        catch (e) {}
        // Configure display of status and away messages
        // NOTE: We're binding to the 'showStatusMsg' attribute on the root box to collapse/uncollapse the status message label in the buddylist.
        scene.rootBox.setAttribute("showStatusMsg", showStatusAndAwayMessages);
    },
    updatePrivacyLevel : function(pdMode)
    {
        // Update preference with Host provided values
        try
        {
            var storeName = scene.prefObj.prefsGetStoreForCurrentIdentity();
            if (storeName)
            {
                var kvs = new keyValueStorage();
                kvs.open(storeName);
                kvs.setValue( scene.prefObj.PdModeKey , pdMode.toString() );
                kvs.close();
            }
        }
        catch (e) {}
    },
    processPermitList : function(responseData)
    {
        var blockList = responseData.data.blocks;
        var allowList = responseData.data.allows;
        var pdMode = responseData.data.pdMode;
        
        scene.AIMobj.blockedList = null;
        scene.AIMobj.blockedList = new xArray;
        
        scene.AIMobj.allowedList = null;
        scene.AIMobj.allowedList = new xArray;
        
        try
        {      
            //Block List                              
            if(blockList)
            {
                for(var i = 0; i < blockList.length; i++)
                {
                    var blockedSN = blockList[i];
                    scene.AIMobj.blockedList.addValue(blockedSN);
                }
            }
            
            //Allow List
            if(allowList)
            {
                for(var i = 0; i < allowList.length; i++)
                {
                    var allowedSN = allowList[i];
                    scene.AIMobj.allowedList.addValue(allowedSN);
                }
            }
            var cacheMode = scene.AIMobj.getPermitMode();
            if (cacheMode)
            {   
                if (cacheMode != pdMode)
                {
                    pdMode = cacheMode;
                    scene.AIMobj.setPermitDeny("pdMode", pdMode, false);
                }
            }
            else
            {
                scene.AIMobj.setPermitMode(pdMode);
            }
            setPresencePerSetting(pdMode, false);         
   
       } catch (e) {}
        
    },
    processPermitDenyResponse : function(responseData)
    {
        var pdMode = responseData.data.pdMode;
        
        // Update privacy level with Host provided values
        this.updatePrivacyLevel(pdMode);
        
        //process the block and allow list & enfore the privacy setting.
        this.processPermitList(responseData);
    },
    processPreferenceResponse : function(responseData)
    {
        var noSeeRecentBuddiesVal = responseData.data.noSeeRecentBuddies;
        var acceptOffLineIMVal    = responseData.data.acceptOffLineIM;

        var noSeeRecentBuddies = noSeeRecentBuddiesVal ? "true" : "false";
        var acceptOffLineIM = acceptOffLineIMVal ? "true" : "false";

        // Update preference with Host provided values
        try
        {
            var storeName = scene.prefObj.prefsGetStoreForCurrentIdentity();
            if (storeName)
            {
                var kvs = new keyValueStorage();
                kvs.open(storeName);
                kvs.setValue( scene.prefObj.noSeeRecentBuddiesKey , noSeeRecentBuddies.toString() );
                kvs.setValue( scene.prefObj.acceptOffLineIMKey , acceptOffLineIM.toString() );
                kvs.close();
            }
        }
        catch (e) {}
    },
    reportSpam : function(requestInfo, statusCode, statusDetailCode)
    {
        if(statusCode == "200")
        {
            var message;
            if (requestInfo)
            {
                requestInfoArray = requestInfo.split(",");
                var screenName = requestInfoArray[0];
                var reportType = requestInfoArray[1];
                if (screenName && reportType)
                {
                    var chatPanel = scene.getBoxById("chatPanel");
                    var conversation = chatPanel.findConversation(screenName);
                    chatPanel.closeConversationHelper(conversation);
                    chatPanel.blockUnblockBuddyById(screenName, false);
                    if (reportType == "abuse")
                    {
                        var groupItemArray = scene._buddyListObj.getGroupListForBuddy(screenName);
                        scene.AIMobj.removeBuddyFromAllGroups(screenName, groupItemArray, false);   
                    }
                    message = (reportType == "spim") ? "im.reportSpam.notification" : "im.reportAbuse.notification";
                    message = formatString1(scene.rootBox.getAttribute(message), screenName);
                    updateNotificationBox("", message, 3000);
                }
            }            
        }
        else if (statusCode == "604")
        {
            // reportSPIM: target not allowed
            // statusDetailCode : 1(Can't report spim someone that has not imed you),
            //                    2(Can't report spim someone he/she has started a conversation with),
            //                    6(Can't report spim more than once for a user per session),
            //                    7(Can't report spim buddy on your buddylist),
            //                    8(Can't report spim a BOT)
            switch(statusDetailCode)
            {
                case 1:
                {
                    message = "im.reportSpam.failed.noIMFromUser";
                    break;
                }
                case 2:
                case 4:
                {
                    message = "im.reportSpam.failed.conversationStarted";
                    break;
                }
                case 6:
                {
                    message = "im.reportSpam.failed.maxOncePerSession";
                    break;
                }
                case 7:
                {
                    message = "im.reportSpam.failed.onBuddyList";
                    break;
                }
                case 8:
                {
                    message = "im.reportSpam.failed.reportBot";
                    break;
                }
            }
            if (message)
            {
                var rootBox = scene.rootBox;
                this.displayAlertBox(rootBox.getAttribute("im.reportSpam.failed.title"), rootBox.getAttribute(message));
            }
        }
    },
    displayAlertBox : function(title, alertText)
    {
        var alertBox = scene.getBoxById("alertBox");
        alertBox.alert("<b>"+title+"</b>", "alertContentMultiline", scene.rootBox.getAttribute("aim.ok"));
        alertBox.getPartById("label").setAttribute("value", alertText);
    },
    setPermitDeny : function(mode, buddyName)
    {
        if (mode && (mode == "pdBlock" || mode == "pdBlockRemove") && buddyName)
        {
            var action = mode == "pdBlock" ? "blocked" : "unblocked";
            updateNotificationBox("", formatString2(scene.rootBox.getAttribute("bl.pendingAction.action"), buddyName, action), 2000);
        }
    },
    systemSignedOff : function()
    {
        signOff(true);
        scene.getBoxById("authPanelBox").onLoginError(scene.rootBox.getAttribute("signon.message.sessionEndedRemotely"));
    },
    friendlyNameSet : function (buddyName)
    {
        updateNotificationBox(null, formatString1(scene.rootBox.getAttribute("bl.pendingAction.rename"), buddyName), 2000);
    }
}
