// ****************************************************************************
//
// Copyright ?2008 AOL LLC  All rights reserved.
// This software contains valuable confidential and proprietary information
// of AOL LLC and is subject to applicable licensing agreements.
// Unauthorized reproduction, transmission or distribution of this file and
// its contents is a violation of applicable laws.
//
//           A O L  L L C   C O N F I D E N T I A L
//
// ****************************************************************************

function component (_gadget)
{
    this.object;
    this.functionName;
}

component.prototype.escape = function()
{
    var focusedBox = this.scene.focusedBox;
    if (focusedBox.tag != "input")
    {
        this.notify(1);
    }
}
component.prototype.setObject = function(object)
{
    this.object = object;
}

component.prototype.setFunctionName = function(functionName)
{
    this.functionName = functionName;
}

component.prototype.notify = function(buttonIndex)
{
    var button = buttonIndex == 0 ? "button1" : "button2";
    button = this._gadget.getPartById(button);
    if (button && !button.disabled)
    {
        this.close();
        var object = this.object;
        try
        {
            eval("object." + this.functionName+ "(" +  buttonIndex + ")");
        }
        catch(e){}
    }
}

component.prototype.close = function()
{
    // restore the softkey menu
    if (!this._gadget.getPartById("button1").collapsed || !this._gadget.getPartById("button2").collapsed)
    {
        propagateEventForBox(this._gadget, "menuChanged");
    }

    try
    {
        shell.app.overrideBackButton(this.scene.rootBox.windowHandle, false);
    }
    catch(e){}
    
    // Close the alert
    this._gadget.collapsed = true;
}

component.prototype.clickOut = function()
{
    // Do nothing
}

component.prototype.onEnter = function()
{
    // Fire whatever button has focus
    // If neither button has focus, fire button1
    var btn1 = this._gadget.getPartById("button1");
    var btn2 = this._gadget.getPartById("button2");
    if (btn1.focused)
    {
        this.notify(0);
    }
    else if (btn2.focused)
    {
        this.notify(1);
    }
    else
    {
        if (!btn1.collapsed && !btn1.disabled)
        {
            this.notify(0);
        }
    }
}

component.prototype.alert = function(description, contentId, button1Label, button2Label, object, callback)
{
    this._gadget.deleteContentChildren();
    
    if (contentId)
    {
        var content = this.scene.createBox(contentId);
        content.id = contentId;
        this._gadget.addContentChild(content);
    }

    if (object)
    {
        this.setObject(object);
        this.setFunctionName(callback);
    }
    if (description)
    {
        this._gadget.setAttribute("description", description);
    }
    this._gadget.setAttribute("hideDescription", description ? "false" : "true");
    
    if (button1Label)
    {
        this._gadget.setAttribute("button1Label", button1Label);
    }
    var button1 = this._gadget.getPartById("button1");
    button1.collapsed = (button1Label) ? false : true;
    button1.disabled = false;
    
    if (button2Label)
    {
        this._gadget.setAttribute("button2Label", button2Label);
    }
    var button2 = this._gadget.getPartById("button2");
    button2.collapsed = (button2Label) ? false : true;

    this._gadget.getPartById("buttonBox").collapsed = (button1.collapsed && button2.collapsed) ? true : false;
    
    // Show it
    this._gadget.collapsed = false;
    
    // Set focus
    var focusedBox;
    if (contentId)
    {
        var input = this._gadget.getPartById("input");
        if (input)
        {
            focusedBox = input;
        }
    }
    
    if (!focusedBox)
    {
        focusedBox = button1.collapsed ? null : button1;
    }
    if (focusedBox)
    {
        this.scene.focusedBox = focusedBox;
    }
    
    if (!button1.collapsed || !button2.collapsed)
    {
        // Set the softkey menus with our two buttons
        OverrideSoftkeyMenus(this.scene, button1.collapsed ? "" : button1Label, "IDM_ALERT_BUTTON1", button2.collapsed ? "" : button2Label, "IDM_ALERT_BUTTON2");
    }
    try
    {
        shell.app.overrideBackButton(this.scene.rootBox.windowHandle, true);
    }
    catch(e){}
}

//****************************************************************************

// Need to take over tabbing so you can't tab out of the alert box
// We also make focus wrap instead of moving out of the alert
component.prototype.onTabForward = function()
{
    var event = shell.currentEvent;
    if (event)
    {
        event.preventDefault();
    }

    this.scene.advanceFocus();

    var focusedBox = this.scene.focusedBox;
    
    if (!this.isChildBox(focusedBox))
    {
        this.wrapFocus(true);
    }
}

component.prototype.onTabBackward = function()
{
    var event = shell.currentEvent;
    if (event)
    {
        event.preventDefault();
    }

    this.scene.rewindFocus();
    
    var focusedBox = this.scene.focusedBox;
    if (!this.isChildBox(focusedBox))
    {
        this.wrapFocus(false);
    }
}

//****************************************************************************

component.prototype.isChildBox = function(child)
{
    if (child)
    {
        var gadget = this._gadget;
    
        var p = child.parent;
        while (p)
        {
            if (p == gadget)
            {
                return true;
            }
            p = p.parent;
        };
    }
    
    return false;
}

//****************************************************************************

component.prototype.wrapFocus = function(forward)
{
    var gadget = this._gadget;
    
    if (forward)
    {
        var box = this.findFirstFocusableBox(this._gadget.firstChild);
        if (box)
        {
            this.scene.focusedBox = box;
        }
    }
    else
    {
        var box = this.findLastFocusableBox(this._gadget.firstChild);
        if (box)
            this.scene.focusedBox = box;
    }
}

//****************************************************************************

component.prototype.findFirstFocusableBox = function(child)
{
    while (child)
    {
        var focusMode = child.getAttribute("focusMode");
        if (!child.collapsed && focusMode == "normal")
        {
            return child;
        }
        
        var child2 = child.firstChild;
        if (child2)
        {
            var found = this.findFirstFocusableBox(child2);
            if (found)
                return found;
        }
        
        child = child.nextSibling;
    }
}

component.prototype.findLastFocusableBox = function(child)
{
    var lastBox = null;
    
    while (child)
    {
        var focusMode = child.getAttribute("focusMode");
        if (!child.collapsed && focusMode == "normal")
        {
            lastBox = child;
        }
        
        var child2 = child.firstChild;
        if (child2)
        {
            var found = this.findLastFocusableBox(child2);
            if (found)
            {
                lastBox = found;
            }
        }
        
        child = child.nextSibling;
    }
    
    return lastBox;
}

