// ****************************************************************************
//
// Copyright ?2008 AOL LLC  All rights reserved.
// This software contains valuable confidential and proprietary information
// of AOL LLC and is subject to applicable licensing agreements.
// Unauthorized reproduction, transmission or distribution of this file and
// its contents is a violation of applicable laws.
//
//           A O L  L L C   C O N F I D E N T I A L
//
// ****************************************************************************

function component(_gadget)
{
    this.alertList;
    this.productName;
    // For development in Win32
    try {
        this.productName = shell.app.productId;
    } catch (e) {
        this.productName = "mobileAIM";
    }
}

component.prototype.onSearchGridKeyUp = function()
{
    var searchGrid = this._gadget.getPartById("searchResultGrid");
    if (searchGrid.selectedIndex == -1)
    {
        searchGrid.selectedIndex = 0;
    }
}

component.prototype.onSearchGridKeyPressed = function()
{
    var keyCode = shell.currentEvent.keyCode;
    if ((keyCode >= 48 && keyCode <= 122) || keyCode == 8)
    {
        var searchInput = this._gadget.getPartById("searchInput")
        var currValue = searchInput.getAttribute("value");
        currValue = currValue ? currValue : "";
        var valueLength = currValue.length;    
        
        var searchList;
        if (keyCode == 8)
        {
            currValue = currValue.substr(0, valueLength - 1);  
            if (currValue != "")
            {
                searchList = this.searchPeekNextSearch(currValue, true);
            }
            else
            {
                this.cancelSearch();
            }
        }
        else if (valueLength < 30 && keyCode >= 48 && keyCode <= 122)
        {
            var key = String.fromCharCode(keyCode);
            currValue += key.toLowerCase();
            searchList = this.searchPeekNextSearch(currValue, false);
        }
        
        if (searchList)
        {
            searchInput.setAttribute("value", currValue);
            
            //need to reset every time for highlight string to work
            this.scene._searchListDataSrc = searchList;
            var searchGrid = this._gadget.getPartById("searchResultGrid");
            var selectedIdx = (searchList.count != this.scene._searchListDataSrc.count) ? 0 : searchGrid.selectedIndex;
            searchGrid.selectedIndex = selectedIdx;
        }
    }
}

component.prototype.searchPeekNextSearch = function(str, isNewSearch)
{
    str = str.toLowerCase();
    var searchList;
    if (!isNewSearch)
    {
        try
        {
            var searchListDataObject = this.scene._searchListDataSrc;
            var count = searchListDataObject.count;
            for (var x = 0; x < count; ++x)
            {
                var buddyObj = searchListDataObject.valueAtIndex(x);
                if (buddyObj && buddyObj.displayId.toLowerCase().indexOf(str) > -1)
                {
                    if (!searchList)
                    {
                        searchList = new liveArray();
                    }
                    if (searchList.indexOfKey("displayId", buddyObj.displayId) == -1)
                    {
                        buddyObj.matchedValue = str;
                        searchList.addValue(buddyObj);
                    }
                }            
            }
        }
        catch(e){}
    }
    else
    {
        searchList = this.scene._buddyListObj.matchBuddiesForStr(str);
    }
    
    if (!searchList)
    {
        try
        {
            var path = shell.app.path + "\\resources\\drop.wav";
            shell.device.playSoundOrVibrate(path, 100, 0, 0);
        }
        catch(e){}
    }
    return searchList;
}

component.prototype.onBuddyListChanged = function(object, type)
{
    if (this._gadget.getAttribute("searching") == "true")
    {
        var aimId;
        var displayId;
        try
        {
            displayId = object.displayId;
            aimId = object.aimId;
        }
        catch(e){};
        
        if (displayId)
        {
            var idx = this.scene._searchListDataSrc.indexOfKey("displayId", displayId);
            if (type == "add" && idx == -1)
            {
                var currSearch = this._gadget.getPartById("searchInput").getAttribute("value");
                if (displayId.toLowerCase().indexOf(currSearch) > -1)
                {
                    this.scene._searchListDataSrc.addValue(object);
                }
            }
            else
            {
                if (idx != -1)
                {
                    if (type == "delete")
                    {
                        var listCount = this.scene._searchListDataSrc.count;
                        if (listCount == 1)
                        {
                            this.cancelSearch();
                        }
                        else
                        {
                            var searchGrid = this._gadget.getPartById("searchResultGrid");
                            if (searchGrid.selectedIndex == idx)
                            {
                                var newSelectedIndex = idx;
                                if (idx != listCount - 1)
                                {
                                    newSelectedIndex = 0;
                                }
                            }
                            this.scene._searchListDataSrc.removeValueAtIndex(idx);
                            searchGrid.selectedIndex = newSelectedIndex;
                        }
                    }
                    else
                    {
                        var state = object.state;
                        if(state == "offline" || state == "blocked")
                        {
                            var offlineObj;
                            var offlineGroup = this.scene._buddyListObj.getOfflineBuddyGroup();
                            if (offlineGroup)
                            {
                                offlineObj = offlineGroup.getBuddy(aimId);
                            }
                        }
                        this.scene._searchListDataSrc.replaceValueAtIndex(idx, offlineObj ? offlineObj : object);
                    }
                }
            }
        }
    }
}

component.prototype.getStatusMessage = function()
{
    return this._gadget.getPartById("statusMessage").getAttribute("value");
}

component.prototype.onDataGridKeyDown = function()
{
    var keyCode = shell.currentEvent.keyCode;
    if (keyCode >= 48 && keyCode <= 122)
    {
        var key = String.fromCharCode(keyCode);
        if (key)
        {
            key = key.toLowerCase();
            var searchList = this.searchPeekNextSearch(key, true);
            if (searchList)
            {
                this.scene.addDOMObject("_searchListDataSrc", searchList); 
                this._gadget.setAttribute("searching", "true");
                this._gadget.getPartById("statusMessage").setAttribute("navDown", "buddyList.searchResultGrid");
                this._gadget.getPartById("searchInput").setAttribute("value", key);
        
                var softKeyMenu = this._gadget.getPartById("leftSoftKeyMenu");
                softKeyMenu.setAttribute("menuTitle", this.scene.rootBox.getAttribute("aim.clear"));
                softKeyMenu.setAttribute("commandId", "IDM_BL_SEARCH_CANCEL");
                
                propagateEventForBox(this._gadget, "menuChanged"); // update the menu
                this.scene._buddyListObj.addListener(this._gadget);
            }
        }
    }
}

component.prototype.cancelSearch = function()
{
    if (this._gadget.getAttribute("searching") == "true")
    {
        this.scene._buddyListObj.removeListener(this._gadget);
    
        this._gadget.setAttribute("searching", "false");
        this._gadget.getPartById("statusMessage").setAttribute("navDown", "buddyList.buddyListGrid");
        
        navDown="buddyList.buddyListGrid"
        this.scene.removeDOMObject("_searchListDataSrc"); 
        this.updateSoftKey();
    }
}

component.prototype.searchEnterPressed = function()
{
    var grid = this._gadget.getPartById("searchResultGrid");
    propagateEventForBox(grid.selectedBox, "mouseDown");
}

component.prototype.enterPressed = function()
{
    var buddy = this.getSelectedBuddy();
    var group = this.getSelectedGroup();

    var grid = this._gadget.getPartById("buddyListGrid");
    
    if (buddy)
    {
        var box = grid.getPartById(buddy.aimId);
        if (box && box.tag == "buddyListBuddy")
        {   
            if (shell.currentEvent)
            {
                shell.currentEvent.stopPropagation();
            }
            propagateEventForBox(box, "mouseDown");
            if (shell.currentEvent)
            {
                shell.currentEvent.preventDefault();
            }
        }
    }
    else if (group)
    {
        var box = grid.getPartById(group.name);
        if (box && box.tag == "buddyListGroup")
        {
            box.toggle();
        }
    }
    // else nothing is selected
    // ... or an ad is selected
    else
    {
        var box = grid.getPartById("buddyListAdBox");
        box.linkClicked();
    }
}

component.prototype.signedIn = function(buddyInfo)
{
    var aimId = buddyInfo.aimId;
    this._gadget.getPartById("presenceBox").setAttribute("value", buddyInfo.displayId);
    this._gadget.setAttribute("aimId", aimId);
    if (buddyInfo.buddyIcon)
    {
        this._gadget.setAttribute("buddyIcon", buddyInfo.buddyIcon);
    }
    
    //Set the presenceIcon to none. BLT 416358
    var presenceIcon = getPresenceIcon(buddyInfo.state);
    this._gadget.setAttribute("presenceIcon", presenceIcon);
    
    try
    {
        var storeName = this.scene.prefObj.prefsGetStoreForCurrentIdentity();
        var statusMsg = buddyInfo.statusMsg;
        var kvs = new keyValueStorage();
        kvs.open(storeName);
        
        if (statusMsg)
        {
            kvs.setValue("lastStatusMessage", statusMsg); 
        }
        else
        {
            statusMsg = kvs.getValue("lastStatusMessage", ""); 
            if (statusMsg)
            {
                this.scene.AIMobj.setStatusMessage(statusMsg);  
            }
        }
        this._gadget.getPartById("statusMessage").setAttribute("value", statusMsg);
        kvs.close();
        
        //get the alert list
        kvs.open(storeName + ".alertList");
        var alertListDict = kvs.getAll();
        var allKeys = alertListDict.allKeys();
        var count = allKeys.count;

        if (this.alertList)
        {
            delete this.alertList;
            this.alertList = null;
        }
        if (count > 0)
        {
            this.alertList = new xArray();
        }
        for (var x = 0; x < count; ++x)
        {
            var key = allKeys.getValue(x);
            this.alertList.addValue(key);
        }
        kvs.close();
    }
    catch(err)
    {
    }
}

component.prototype.showConversationWindow = function()
{
    propagateEventForBox(this._gadget, "showConversationWindow");
}

component.prototype.quitApplication = function()
{
    this.scene.close();
}

component.prototype.cmdEdit = function()
{
    var selectedBuddy = this.getSelectedBuddy();
    var group = this.getSelectedGroup();
    
    var gadgetName;
    var value;
    var title;
    var groupName;
    if (group)
    {
        groupName = group.name;
        if (selectedBuddy)
        {
            gadgetName = "alertContentAddBuddy";
            value = selectedBuddy.aimId;
            title = "bl.EditBuddy";
        }
        else
        {
            gadgetName = "alertContentEditGroup";
            value = groupName;
            title = "bl.EditGroup";
        }
    }
    
    if (gadgetName && value)
    {
        var alertBox = this.scene.getBoxById("alertBox");
        var rootBox = this.scene.rootBox;
        alertBox.alert(rootBox.getAttribute(title), gadgetName, rootBox.getAttribute("aim.save"), rootBox.getAttribute("aim.cancel"), this, "editDialogSaved");
        
        if (gadgetName == "alertContentAddBuddy")
        {
            if (selectedBuddy.groupId == "Offline Buddies")
            {
                var alertcontent = alertBox.getPartById("alertContentAddBuddy");
                alertcontent.setAttribute("hideGroup", "true");
                alertcontent.setAttribute("respectUIScale", this.scene.rootBox.getAttribute("respectUIScale"));
            }
            var groupBox = alertBox.getPartById("group");
            this.createGroupListForComboBox(groupBox, groupName);
            groupBox.setAttribute("oldValue", groupName);
         
            var displayId = selectedBuddy.displayId;
            if (value == displayId.replace(/[ \t]*/ig,"").toLowerCase())
            {
                displayId = "";
            }
            
            var friendlyNameInput = alertBox.getPartById("friendNameInput");
            friendlyNameInput.setAttribute("value", displayId);
            friendlyNameInput.setAttribute("oldValue", displayId);
        }
        
        // Populate the dialog
        var editBox = alertBox.getPartById("input");
        editBox.setAttribute("value", value);
        editBox.setAttribute("oldValue", value);
        editBox.setCaretPos(value.length);
    }

    // else there isn't a selected group
}

component.prototype.editDialogSaved = function(buttonIndex)
{
    var alertBox = this.scene.getBoxById("alertBox");
    var contentBox = alertBox.firstContentChild;
    if (contentBox.tag == "alertContentAddBuddy")
    {
        this.cleaupGroupList();
    }

    if (buttonIndex == 0)
    {
        // Pull out the settings from the alert
        var alertBox = this.scene.getBoxById("alertBox");
        
        var input = alertBox.getPartById("input");
        var newValue = input.getAttribute("value");
        var oldValue = input.getAttribute("oldValue");
        
        if (contentBox.tag == "alertContentEditGroup")
        {
            if (newValue && newValue != oldValue)
            {
                // Update our data
                this.scene._buddyListObj.renameGroup(oldValue, newValue, true);
                
                // Tell the aim server to rename the group
                this.scene.AIMobj.renameGroup(oldValue, newValue);        
            }
        }
        else if (contentBox.tag == "alertContentAddBuddy")
        {
            if (this.isValidScreenName(newValue))
            {
                var groupBox = alertBox.getPartById("group");
                var newGroupName = (groupBox.collapsed) ? "" : groupBox.getSelectedValue() ;
                var groupName = (groupBox.collapsed) ? "" : groupBox.getAttribute("oldValue");
                
                var friendNameInput = alertBox.getPartById("friendNameInput");
                var friendNameNewValue = friendNameInput.getAttribute("value");
                
                if (newGroupName != groupName || newValue != oldValue)
                {
                    if (groupBox.collapsed)
                    {
                        this.replaceOfflineBuddyHelper(oldValue, newValue, friendNameNewValue);
                    }
                    else
                    {
                        this.deleteBuddyHelper(groupName, oldValue, false);
                        this.addBuddyHelper(newGroupName, newValue, "edit", friendNameNewValue);
                    }
                }
                else if (friendNameNewValue != friendNameInput.getAttribute("oldValue"))
                {
                    if (!friendNameNewValue || !friendNameNewValue.replace(/[- \t]*/ig,""))
                    {
                        friendNameNewValue = "";
                    }
                    this.scene.AIMobj.setFriendlyName(oldValue, friendNameNewValue, true);
                }
            }
        }
    }
}

component.prototype.cmdAddGroup = function()
{
    var alertBox = this.scene.getBoxById("alertBox");
    var rootBox = this.scene.rootBox;
    if(alertBox && rootBox)
    {
        alertBox.alert(rootBox.getAttribute("bl.addGroup"), "alertContentEditGroup", rootBox.getAttribute("aim.save"), rootBox.getAttribute("aim.cancel"), this, "addGroupDialogSaved");
        var button1 = alertBox.getPartById("button1");
        if (button1)
        {
            button1.setAttribute("disabled", "true");
        }
    }
}

component.prototype.addGroupDialogSaved = function(buttonIndex)
{
    if (buttonIndex == 0)
    {
        // Pull out the settings from the alert
        var alertBox = this.scene.getBoxById("alertBox");
        
        var newGroupName = alertBox.getPartById("input").getAttribute("value");
        if (newGroupName)
        {
            // Add a temporary group item to our data
            this.scene._buddyListObj.addGroup(newGroupName, true);
            
            // Tell the aim server to add the group
            this.scene.AIMobj.addGroup(newGroupName);
            this.setSelectedIndexToGroup(newGroupName);
        }
    }
}

component.prototype.cmdAddBuddy = function(screenName, displayId, isMobileUser)
{
    var selGroup = this.getSelectedGroup();
    var selectedGroupId = selGroup ? selGroup.name : "";
    
    var alertBox = this.scene.getBoxById("alertBox");
    
    var rootBox = this.scene.rootBox;
    var title = "bl.newBuddy";
    if (isMobileUser)
    {
        title = "bl.newMobile";
    }
    alertBox.alert(rootBox.getAttribute(title), "alertContentAddBuddy", rootBox.getAttribute("aim.save"), rootBox.getAttribute("aim.cancel"), this, "addBuddyDialogSaved");

    var groupBox = alertBox.getPartById("group");
    this.createGroupListForComboBox(groupBox, selectedGroupId);
    var defaultScreenName = "";
    var addBuddyContent = alertBox.getPartById("alertContentAddBuddy");
    addBuddyContent.setAttribute("respectUIScale", this.scene.rootBox.getAttribute("respectUIScale"));

    if (isMobileUser)
    {
        addBuddyContent.setAttribute("isMobile", "true");
        defaultScreenName += "+1 ";
    }    
    if (screenName)
    {
        defaultScreenName += screenName;
    }
    if (defaultScreenName)
    {
        var input = alertBox.getPartById("input");
        input.setAttribute("value", defaultScreenName);
        if (isMobileUser)
        {    
            input.inputMode = 7;
            input.isMobileUser = isMobileUser;
            input.setCaretPos(defaultScreenName.length);
        }
        else
        {
            this.scene.focusedBox = groupBox;
        }
    }
    else
    {
        alertBox.getPartById("button1").setAttribute("disabled", "true");
    }
    if (displayId)
    {
        if (screenName != displayId.replace(/[ \t]*/ig,"").toLowerCase())
        {
            alertBox.getPartById("friendNameInput").setAttribute("value", displayId);
        }
    }
}

component.prototype.createGroupListForComboBox = function(comboBox, selectedGroupId)
{
    var dropdown = this.scene.getBoxById("addBudddyDropDown");
    if (!dropdown)
    {
        dropdown = this.scene.createBox("dropDownMenu");
        dropdown.id = "addBudddyDropDown";
        this.scene.rootBox.addChild(dropdown);
    }
    dropdown.setParentsObject(comboBox);
    
    var groupItemArray = this.scene._buddyListObj.getGroupList();
    if (groupItemArray && groupItemArray.length > 0)
    {
        var count = groupItemArray.length;
        var selectedIndex = 0;
        for (var x = 0; x < count; ++x)
        {
            var item = this.scene.createBox("dropDownMenuItem");
            item.setAttribute("value", groupItemArray[x]);
            dropdown.appendMenuItem(item);
            if (groupItemArray[x] == selectedGroupId)
            {
                selectedIndex = x;
            }
        }
        dropdown.selectMenuAtIndex(selectedIndex);
    }
}

component.prototype.cleaupGroupList = function()
{
    var addBudddyDropDown = this.scene.getBoxById("addBudddyDropDown");
    if (addBudddyDropDown)
    {
        addBudddyDropDown.setParentsObject(null);
        addBudddyDropDown.clearContent();
        addBudddyDropDown.close();
    }    
}

component.prototype.isValidScreenName = function(screenName)
{
    var isValid = screenName == screenName.replace(/[(!#%$^&*(){}:\"><)]*/g, "");
    if (isValid && screenName.length > 16)
    {
        isValid = screenName.indexOf("@") > -1;
    }
    if (!isValid)
    {
        var rootBox = this.scene.rootBox;
        var alertBox = this.scene.getBoxById("alertBox");
        var text = formatString1(rootBox.getAttribute("bl.newBuddyError"), screenName);
        alertBox.alert(text, "alertContentMultiline", rootBox.getAttribute("aim.ok"));
    }
    return isValid;
}

component.prototype.addBuddyDialogSaved = function(buttonIndex)
{
    this.cleaupGroupList();

    if (buttonIndex == 0)
    {
        // Pull out the settings from the alert
        var alertBox = this.scene.getBoxById("alertBox");
        var input = alertBox.getPartById("input");
        var screenName = input.getAttribute("value");
        
        if (this.isValidScreenName(screenName))
        {
            if (screenName)
            {
                screenName = screenName.replace(/[- \t]*/ig,"");
                try
                {
                    if (input.isMobileUser && screenName.indexOf("+1") != 0)
                    {
                        var firstChar = screenName.substr(0, 1);
                        if (firstChar == "1")
                        {
                            screenName = "+" + screenName;
                        }
                        else if (firstChar == "+")
                        {
                            if (screenName.substr(1, 1) != "1")
                            {
                                screenName = screenName.replace("+", "+1");
                            }
                        }
                        else
                        {
                            screenName = "+1" + screenName;
                        }
                        input.isMobileUser = null;
                    }
                }
                catch(e){}
            }
            
            var groupName = alertBox.getPartById("group").getSelectedValue();
            var friendName = alertBox.getPartById("friendNameInput").getAttribute("value");
            if (!friendName || !friendName.replace(/[- \t]*/ig,""))
            {
                friendName = "";
            }
            this.addBuddyHelper(groupName, screenName, "add", friendName);
        }
    }
}

component.prototype.addBuddyHelper = function(groupName, screenName, type, friendlyName)
{
    if (screenName && groupName)
    {
        screenName = canonicalizeScreenName(screenName);
        var buddy = this.scene._buddyListObj.getBuddy(screenName, groupName);
        var isAddToList = true;
        if (buddy)
        {
            if (buddy.displayId == friendlyName || (buddy.aimId == screenName && !friendlyName))
            {
                isAddToList = false;
            }
        }
        if (isAddToList)
        {
            // Add a temporary buddy item to our data
            this.scene._buddyListObj.addBuddy(screenName, groupName, true);
            
            //Get the buddy object and set it to blocked.
            var buddyInfo = this.scene._buddyListObj.getBuddyInfo(screenName);
            var blockedList = this.scene.AIMobj.getBlockedList();
            if (blockedList)
            {
                if(blockedList.containsValue(screenName))
                {
                    buddyInfo.state = "blocked";
                    this.scene._buddyListObj.updateBuddiesFromObj(buddyInfo);
                }
            }

            // Tell the aim server to add the buddy
            this.scene.AIMobj.addBuddy(screenName, groupName, true, type, friendlyName);
        }
        else
        {
            this.propagateNotification(null, formatString1(this.scene.rootBox.getAttribute("bl.newBuddyExistError"), screenName), 4000); 
        }
    }
}

component.prototype.setSelectedIndexToBuddy = function(screenName, groupName)
{
    var dataGrid = this._gadget.getPartById("buddyListGrid");
    var groupBox = dataGrid.getPartById(groupName);
    if (groupBox)
    {
        var buddy = groupBox.getPartById(screenName);
        if (buddy)
        {
            dataGrid.selectedBox = buddy;
        }
    }
}

component.prototype.setSelectedIndexToGroup = function(groupName)
{
    var dataGrid = this._gadget.getPartById("buddyListGrid");
    var groupBox = dataGrid.getPartById(groupName);
    if (groupBox)
    {
        dataGrid.selectedBox = groupBox;
    }
}
    
component.prototype.cmdDelete = function()
{
    var fnName = "";
    
    var buddy = this.getSelectedBuddy();
    var group = this.getSelectedGroup();

    var name;
    if (buddy)
    {
        name  = canonicalizeScreenName(buddy.aimId);
        fnName = "deleteBuddy";
    }
    else if (group)
    {
        name = group.name;
        fnName = "deleteGroup";
    }
    // else nothing selected
    
    if (fnName != "")
    {
        var alertBox = this.scene.getBoxById("alertBox");
        var rootBox = this.scene.rootBox;
        alertBox.alert(formatString1(rootBox.getAttribute("bl.deleteConfirmation"), name), null, rootBox.getAttribute("aim.delete"), rootBox.getAttribute("aim.cancel"), this, fnName);
    }    
}

component.prototype.groupUpdated = function(oldName, groupName)
{
    var group;
        this.scene._buddyListObj.setGroupPendingAction(groupName, ePendingActions.kNone);
        
        // TODO - update the buddy online/offline counts
    return group;
}

component.prototype.addGroup = function(group, idx)
{
    scene._buddyListObj.addGroup(groupName, true);
}

component.prototype.editStatusMessage = function()
{
    var statusMessage = this._gadget.getPartById("statusMessage");
    if ((statusMessage.getAttribute("editing") == "false") && !this.scene.AIMobj.getIsReconnect() && !this.scene.AIMobj.getContinueOffline())
    {   
        statusMessage.setAttribute("navLeft", "");
        statusMessage.setAttribute("navRight", "");
        statusMessage.setAttribute("editing", "true");
        var rootBox = this.scene.rootBox;
        OverrideSoftkeyMenus(this.scene, rootBox.getAttribute("aim.done"), "IDM_BL_STATUS_DONE", rootBox.getAttribute("aim.cancel"), "IDM_BL_STATUS_CANCEL");
    }
}

component.prototype.cancelEditStatusMessage = function()
{
    var statusMessage = this._gadget.getPartById("statusMessage");
    if (statusMessage.getAttribute("editing") == "true")
    {
        statusMessage.setAttribute("editing", "false");
        statusMessage.setAttribute("navLeft", "activeConversationBar");
        statusMessage.setAttribute("navRight", "buddyList.mailIcon");
        
        try
        {
            var kvs = new keyValueStorage();
            kvs.open(this.productName + "." + this._gadget.getAttribute("aimId"));
            var currStatusMsg = kvs.getValue("lastStatusMessage", ""); 
            statusMessage.setAttribute("value", currStatusMsg);
            kvs.close();
        }
        catch(e){}
    }
    this.scene.focusedBox = statusMessage;
}

component.prototype.doneEditStatusMessage = function()
{
    var statusMessage = this._gadget.getPartById("statusMessage");
    if (statusMessage.getAttribute("editing") == "true")
    {
        statusMessage.setAttribute("editing", "false");
        statusMessage.setAttribute("navLeft", "activeConversationBar");
        statusMessage.setAttribute("navRight", "buddyList.mailIcon");
        
        try
        {
            var kvs = new keyValueStorage();
            kvs.open(this.productName + "." + this._gadget.getAttribute("aimId"));
            var currStatusMsg = kvs.getValue("lastStatusMessage", ""); 
            var newStatusMsg = statusMessage.getAttribute("value");
            if (currStatusMsg != newStatusMsg)
            {
                newStatusMsg = newStatusMsg ? newStatusMsg : "";
                kvs.setValue("lastStatusMessage", newStatusMsg);
                
                if (this._gadget.getAttribute("presenceIcon").indexOf("away") != -1)
                {
                    // we need to do this because WIM does not allow setStatus message when the user is away
                    if (!newStatusMsg || newStatusMsg == "")
                    {
                        newStatusMsg = this.scene.rootBox.getAttribute("bl.defaultAwayMessage");
                    }
                    this.scene.AIMobj.setPresence("away", newStatusMsg);
                }
                else
                {
                    this.scene.AIMobj.setStatusMessage(newStatusMsg);
                }
            }
            kvs.close();
        }
        catch(e){}
    }
    this.updateSoftKey();
    this.scene.focusedBox = statusMessage;
}

component.prototype.updateSoftKey = function()
{
    var softKeyMenu = this._gadget.getPartById("leftSoftKeyMenu");
    var label;
    var commandId;
    var isContinueOffline = this.scene.AIMobj.getContinueOffline()
    if (isContinueOffline)
    {
        label = this.scene.rootBox.getAttribute("reconnect.Reconnect");
        commandId = "IDM_RECONNET_SIGNIN";
    }
    else
    {
        if (this._gadget.getAttribute("searching") == "true")
        {
            label = this.scene.rootBox.getAttribute("aim.clear");
            commandId = "IDM_BL_SEARCH_CANCEL";
        }
        else if (softKeyMenu.getAttribute("menuTitle") != "")
        {
            label = "";
            commandId = "IDM_NOIMPL";
        }
    }
    
    if (commandId)
    {
        softKeyMenu.setAttribute("menuTitle", label);
        softKeyMenu.setAttribute("commandId", commandId);
    }
    propagateEventForBox(this._gadget, "menuChanged"); // update the menu
}   

component.prototype.navDownGadget = function()
{
    var targetBox = shell.currentEvent.targetBox;
    var wrapAround = false;
    var index = targetBox.selectedIndex;
    if (this._gadget.getAttribute("searching") == "false")
    {
        var offlineGroup = targetBox.getPartById("Offline Buddies");
        if (offlineGroup)
        {
            var offlineIndex = targetBox.getRowOfBox(offlineGroup);
            if (index >= offlineIndex)
            {
                if (offlineGroup.toggled)
                {
                    var offlineGroupObj = this.scene._buddyListObj.getOfflineBuddyGroup();
                    if (offlineGroupObj && index == offlineIndex + offlineGroupObj.getOnlineBuddyCount())
                    {
                        wrapAround = true;
                    }
                }
                else
                {
                    wrapAround = true;
                }
            }
        }
        else
        {
            wrapAround = true;
        }
    }
    else
    {
        if (index == this.scene._searchListDataSrc.count - 1)
        {
            wrapAround = true;
        }
    }
    if (wrapAround)
    {
        targetBox.selectedIndex = 0;
        this.scene.focusedBox = this._gadget.getPartById("presenceBox");
    }   
}

component.prototype.navUpGadget = function()
{
    var id = (this._gadget.getAttribute("searching") == "false") ? "buddyListGrid" : "searchResultGrid";
    var tree = this._gadget.getPartById(id);
    var selectedIndex = tree.selectedIndex;
    if (selectedIndex > 1 || (id == "searchResultGrid" && selectedIndex == 1))
    {
        shell.currentEvent.stopPropagation();
    }
    else
    {
        if (selectedIndex == 1 && id == "buddyListGrid")
        {
            if (!tree.getPartById("buddyListAdBox").collapsed)
            {
                shell.currentEvent.stopPropagation();
                return;
            }
        }
        var event = shell.factory.createEvent(this._gadget);
        if (event)
        {	    
            event.type = "buddyListGridNavUp";
            event.currentBox = tree;
            this._gadget.dispatchEvent(event);
        }
    }
}

component.prototype.reconnectLimitReached = function()
{
    if (!this.scene.getBoxById("reconnectLimitReached"))
    {
        // Pop a toast when outside the client
        if (!this.scene.rootBox.active)
        {
            var message = this.scene.rootBox.getAttribute("reconnect.reconnectOutsideClient");
            var html = "<html><body>" + message + "</body></html>";
            shell.app.newNotification(this.scene, html, "",  -1, "connectionLost");
            shell.device.playSoundOrVibrate("sysSoundExclamation", 250, 250, 3);
        }
    
        var alertBox = this.scene.getBoxById("alertBox");
        var rootBox = this.scene.rootBox;
        alertBox.alert(rootBox.getAttribute("reconnect.reconnectLimitReached"), null, rootBox.getAttribute("reconnect.Reconnect"), rootBox.getAttribute("reconnect.ContinueOffline"), this, "reconnectLimitReachedResult");
    }    
}

component.prototype.reconnectLimitReachedResult = function(buttonIndex)
{
    var event = shell.factory.createEvent(this._gadget);
    if (event)
    {	    
        event.type = "reconnectAlertResult";
        event.reconnect = (buttonIndex == 0) ? true : false;
        this._gadget.dispatchEvent(event); 
    }
}

component.prototype.deleteGroup = function(buttonIndex)
{
    if (buttonIndex == 0)
    {
        var group = this.getSelectedGroup();
        if (group)
        {
            var groupId = group.name;
            
            // Mark the group as pending deletion
            this.scene._buddyListObj.deleteGroup(groupId, true);
            
            // Notify the aim server
            this.scene.AIMobj.removeGroup(groupId);
        }
        return true;
    }
}

component.prototype.deleteBuddy = function(buttonIndex)
{
    if (buttonIndex == 0)
    {
        var buddy = this.getSelectedBuddy();
        if (this._gadget.getAttribute("searching") == "false")
        {
            var group = this.getSelectedGroup();
            if (group && buddy)
            {
                this.deleteBuddyHelper(group.name, buddy.aimId, true);
            }
        }
        else
        {
            var groupItemArray = this.scene._buddyListObj.getGroupListForBuddy(buddy.aimId);
            this.scene.AIMobj.removeBuddyFromAllGroups(buddy.aimId, groupItemArray, true);   
        }
    }

}

component.prototype.replaceOfflineBuddyHelper = function(oldValue, newValue, friendNameNewValue)
{
    var groupItemArray = this.scene._buddyListObj.getGroupListForBuddy(oldValue);
    this.scene.AIMobj.replaceBuddyFromAllGroups(oldValue, newValue, groupItemArray, friendNameNewValue);
}

component.prototype.deleteBuddyHelper = function(groupName, buddyId, pendingAction)
{
    if (groupName && buddyId)
    {
        // mark the buddy as pending deletion
        this.scene._buddyListObj.deleteBuddy(buddyId, groupName, pendingAction);
        this.removeAlertByScreenName(buddyId);
        
        // Notify the aim server
        if (groupName == "Offline Buddies")
        {
            var groupItemArray = this.scene._buddyListObj.getGroupListForBuddy(buddyId);
            this.scene.AIMobj.removeBuddyFromAllGroups(buddyId, groupItemArray, true);
        }
        else
        {
            this.scene.AIMobj.removeBuddy(buddyId, groupName, pendingAction);
        }
    }
}

component.prototype.getSelectedBuddy = function()
{
    var grid = (this._gadget.getAttribute("searching") == "false") ? this._gadget.getPartById("buddyListGrid") : this._gadget.getPartById("searchResultGrid");
    
    var selection = grid.selection;
    if (selection)
    {
        var data = selection.firstSelectedData;
        if (data)
        {
            var index = data.value;
            var object = data.collection.getValue(index);
            if (object && object.aimId)
            {
                return object;
            }
        }
    }    
    
    return null;
}

component.prototype.getSelectedGroup = function()
{
    var grid = (this._gadget.getAttribute("searching") == "false") ? this._gadget.getPartById("buddyListGrid") : this._gadget.getPartById("searchResultGrid");
    
    var selection = grid.selection;
    if (selection)
    {
        var data = selection.firstSelectedData;
        if (data)
        {
            var index = data.value;
            var object = data.collection.getValue(index);
            if (object)
            {
                var aimId = object.aimId;
                if (aimId)
                {
                    // This is a buddy
                    groupId = object.groupId;
                    var group = this.scene._buddyListObj.getGroup(groupId);
                    return group;
                }
                else if (object.visibleBuddies)
                {
                    // This is a group
                    return object;
                }
            }
        }
    }    
    
    return null;
}

component.prototype.selectFirstBuddyListGroup = function()
{
    var grid = this._gadget.getPartById("buddyListGrid");
    if (grid)
    {
        grid.selectedIndex = 1;
    }
}

component.prototype.selectFirstOnlineBuddy = function()
{
    var grid = this._gadget.getPartById("buddyListGrid");
    if (grid)
    {
        // Find the first online buddy in the list
        var box = grid.getBoxByTag("buddyListBuddy");
        if (box)
        {
            // Found an online buddy to select
            // Get its grid index
            var index = grid.getRowOfBox(box);
            if (index >= 0)
            {
                // Set selection and focus to it
                grid.setAttribute("selectedIndex", ""+index);
                grid.setAttribute("cursorIndex", ""+index);
            }
        }
    }
}

component.prototype.updateMenu = function()
{
    var focusedBox = this.scene.focusedBox;
    if (focusedBox)
    {   
        var collapsed = true;
        var buddyInfoCollapsed = true;
        var manageMenuItem = this._gadget.getPartById("manageMenuItem");
        var buddyProfileItem = this._gadget.getPartById("buddyProfileItem");
            
        if (focusedBox.tag == "buddyListDataGrid" || focusedBox.tag == "searchDataGrid")
        {
            focusedBox = focusedBox.selectedBox;
            if (focusedBox)
            {
                if (focusedBox.tag == "buddyListGroup")
                {
                    collapsed = (focusedBox.id == "Recent Buddies" || focusedBox.id == "Offline Buddies") ? true : false;
                }
                else if (focusedBox.tag == "buddyListBuddy")
                {
                    buddyInfoCollapsed = false;
                    collapsed = false;
                }
            }
        }
        buddyProfileItem.collapsed = buddyInfoCollapsed;
        manageMenuItem.collapsed = collapsed;
    }
}

//Cleanup function that will be called on sign out.
component.prototype.clearAll = function()
{
    this._gadget.setAttribute("mailCount", "");
    this._gadget.setAttribute("mailBadgeFill", "");
    this._gadget.setAttribute("buddyIcon", "");
    this._gadget.getPartById("buddyIcon").setAttribute("placeholder", "true");
    
    //try to remove extra alerts here
    if (this.alertList)
    {
        var storeName;
        var kvs;
        var count = this.alertList.count;
        for (var x = 0; x < count; ++x)
        {
            var screenName = this.alertList.getValue(x);
            if (!this.scene._buddyListObj.getBuddyInfo(screenName))
            {
                try
                {
                    if (!storeName)
                    {
                        storeName = this.scene.prefObj.prefsGetStoreForCurrentIdentity() + ".alertList";
                    }
                    if (!kvs)
                    {
                        kvs = new keyValueStorage();
                    }
                    kvs.open(storeName);
                    kvs.removeKey(screenName);
                    kvs.close();
                }
                catch(err){}
            }
        }
        delete this.alertList;
        this.alertList = null;
    }
    var softKeyMenu = this._gadget.getPartById("leftSoftKeyMenu");
    softKeyMenu.setAttribute("menuTitle", "");
    softKeyMenu.setAttribute("commandId", "IDM_NOIMPL");
}

component.prototype.onShowSubmenu = function()
{
    var submenuBox = shell.currentEvent.submenuBox;
    if (submenuBox)
    {
        if (submenuBox.tag == "subMenuManage")
        {
            var selectedBuddy = this.getSelectedBuddy();
            
            var blockMenuItem = submenuBox.getPartById("blockMenuItem");
            blockMenuItem.collapsed = (selectedBuddy) ? false : true;

            var alertMenuItem = submenuBox.getPartById("alertMenuItem");
            alertMenuItem.collapsed = (selectedBuddy) ? false : true;

            if (selectedBuddy)
            {
                var state = selectedBuddy.state;
                var rootBox = this.scene.rootBox;
                var newValue = (state == "blocked") ? "bl.submenu.label.Unblock" : "bl.submenu.label.Block";
                newValue = rootBox.getAttribute(newValue);
                var currValue = blockMenuItem.getAttribute("value");
                
                // don't update the menu if it's the same
                if (newValue != currValue)
                {
                    blockMenuItem.setAttribute("label", newValue);
                    blockMenuItem.setAttribute("value", newValue);
                    
                    var newAccessKey = (state == "blocked") ? "bl.submenu.label.Unblock_accesskey" : "bl.submenu.label.Block_accesskey";
                    blockMenuItem.setAttribute("accessKey", rootBox.getAttribute(newAccessKey));
                }
                
                var alertFound = (this.alertList && this.alertList.indexOfValue(selectedBuddy.aimId.toLowerCase()) > -1) ? true : false;
                newValue = (alertFound) ? "bl.submenu.label.TurnOffAlert" : "bl.submenu.label.SetAlert";
                newValue = rootBox.getAttribute(newValue);
                currValue = alertMenuItem.getAttribute("value");
                if (newValue != currValue)
                {
                    alertMenuItem.setAttribute("label", newValue);
                    alertMenuItem.setAttribute("value", newValue);
                    var newAccessKey = (alertFound) ? "bl.submenu.label.TurnOffAlert_accesskey" : "bl.submenu.label.SetAlert_accesskey";
                    alertMenuItem.setAttribute("accessKey", rootBox.getAttribute(newAccessKey));
                }
                
                submenuBox.getPartById("editMenuItem").collapsed = (selectedBuddy.groupId == "Recent Buddies") ? true : false;
                submenuBox.getPartById("deleteMenuItem").collapsed = (selectedBuddy.groupId == "Recent Buddies") ? true : false;
            }
        }
        else if (submenuBox.tag == "subMenuState")
        {
            var selectedIndex = this.getPresenceIndex();
            var count = submenuBox.childCount;
            for (var x = 0; x < count; ++x)
            {
                var menuItem = submenuBox.getChildAt(x);
                menuItem.setAttribute("hideSelected", (x == selectedIndex) ? "false" : "true");
            }
            submenuBox.setAttribute("reconnecting", this._gadget.getAttribute("reconnecting"));
        }
    }
}

component.prototype.getPresenceIndex = function()
{
    var selectedIndex = 0;
    var currentIcon = this._gadget.getAttribute("presenceIcon");
    if (currentIcon)
    {
        currentIcon = currentIcon.split(".");
        var iconName;
        if (currentIcon && currentIcon.length == 2)
        {
            iconName = currentIcon[1];
        }
        if (iconName)
        {
            if (iconName == "away")
            {
                selectedIndex = 1;
            }
            else if (iconName == "invisible")
            {
                selectedIndex = 2;
            }
        }
    }
    return selectedIndex;
}

component.prototype.blockUnblockBuddy = function()
{
    var buddy = this.getSelectedBuddy();
    if(buddy)
    {
        var event = shell.factory.createEvent(this._gadget);
        if (event)
        {	    
	        event.type = "blockUnBlock";
	        event.buddyId = buddy.aimId;
	        event.displayMessage = true;
	        this._gadget.dispatchEvent(event);
        }
    }
}

component.prototype.presenceBoxLayout = function()
{
    var scale = shell.uiScale / 100;
    var topHat = this._gadget.getPartById("topHat");
    var dropDownLabel = this._gadget.getPartById("presenceBox");
    var presenceScreenNameLabel = dropDownLabel.getPartById("label");
    var dropdownIcon = dropDownLabel.getPartById("presenceButton");
    var mailIcon = this._gadget.getPartById("mailIcon");
    
    //work around for maxWidth="auto" not working.  temporary fix.
    var newPresenceLabelWidth = topHat.boxWidth - (63 * scale);
    if (!mailIcon.collapsed)
    {
        newPresenceLabelWidth -= mailIcon.minWidth * scale;
    }
    presenceScreenNameLabel.maxWidth = newPresenceLabelWidth;
    dropDownLabel.maxWidth = presenceScreenNameLabel.boxWidth + (13 * scale);
    
    var globalDropDown = this.scene.getBoxById("globalDropDown");
    if (!globalDropDown.collapsed)
    {
        var parentBox = globalDropDown.getParentBox();
        if (parentBox && parentBox.gadgetParent && parentBox.gadgetParent.tag == "buddyListBox")
        {
            globalDropDown.layoutDropdown();
        }
    }
}

component.prototype.onDropdownClosed = function()
{
    this.scene.focusedBox = this._gadget.getPartById("presenceBox");
}

component.prototype.toggleDropDownLabel= function()
{
    var targetBox = shell.currentEvent.targetBox;
    var globalDropDown = this.scene.getBoxById("globalDropDown");
    if (globalDropDown.collapsed)
    {
        if (globalDropDown.getParentBox() != targetBox)
        {
            globalDropDown.setParentBox(targetBox);
            var rootBox = this.scene.rootBox;
            globalDropDown.appendMenuItem(rootBox.getAttribute("bl.available"), "#badge.online");
            globalDropDown.appendMenuItem(rootBox.getAttribute("bl.away"), "#badge.away");
            globalDropDown.appendMenuItem(rootBox.getAttribute("bl.invisible"), "#badge.invisible");    
        }
        globalDropDown.layoutDropdown();
        var selectedIndex = this.getPresenceIndex();
        globalDropDown.setSelectedBoxByIndex(selectedIndex, true);
    }
    targetBox.setAttribute("selected", globalDropDown.collapsed ? "true" : "false");
    globalDropDown.collapsed = !globalDropDown.collapsed;
}

component.prototype.setPresence = function(value)
{
    var forceSetPresence = true;
    if (!value)
    {
        forceSetPresence = false;
        var currentEvent = (shell.currentEvent) ? shell.currentEvent : null;
        if (currentEvent)
        {
            value = currentEvent.value;
        }
    }
    if(value)
    {
        value = value.toLowerCase();
        switch(value)
        {
            case "available":
            {
                value = "online";
                break;
            }
            case "away":
            case "invisible":
            {
                break;
            }
            default:
            {
                value = "online"
                break;
            }
        }
        
        var event = shell.factory.createEvent(this._gadget);
        if (event)
        {	    
            event.type = "presenceChanged";
            event.presence = value;
            this._gadget.dispatchEvent(event);
        }
        var newPresenceIcon = getPresenceIcon(value);
        if (this._gadget.getAttribute("presenceIcon") != newPresenceIcon || forceSetPresence)
        {
            this._gadget.setAttribute("presenceIcon", newPresenceIcon);
        
            var statusMsg = this._gadget.getPartById("statusMessage").getAttribute("value");
            if (value == "away" && (!statusMsg || statusMsg == ""))
            {
                statusMsg = this.scene.rootBox.getAttribute("bl.defaultAwayMessage");
            }
            
            this.scene.AIMobj.setPresence(value, statusMsg);
        }
    }
}

component.prototype.setAlert = function(buddy)
{
    var screenName = buddy.aimId;
    if (screenName)
    {
        var message;
        var isRemoved = this.removeAlertByScreenName(screenName);
        if (isRemoved)
        {
            message = "bl.message.turnOffAlert";
        }
        else
        {
            message = "bl.message.setAlert";
            var lowerScreenName = screenName.toLowerCase();
            if (!this.alertList)
            {
                this.alertList = new xArray();
            }
            this.alertList.addValue(lowerScreenName);
            
            try
            {
                var storeName = this.scene.prefObj.prefsGetStoreForCurrentIdentity() + ".alertList";
                var kvs = new keyValueStorage();
                kvs.open(storeName);
                kvs.setValue(lowerScreenName, ""); 
                kvs.close();
            }
            catch(err){}
        }
        if (message)
        {
            this.propagateNotification(null, formatString1(this.scene.rootBox.getAttribute(message), screenName), 2000); 
        }
    }
}

component.prototype.notifyAlert = function(screenName, state)
{
    if (this.alertList && (state == "online" || state =="offline") 
        && this.alertList.indexOfValue(screenName.toLowerCase()) > -1)
    {
        var message = state == "online" ? "bl.message.alert.available" : "bl.message.alert.signOff";
        message = formatString1(this.scene.rootBox.getAttribute(message), screenName);
        this.propagateNotification(null, message, 2000); 
        try
        {
            var store = this.scene.prefObj.prefsGetStoreForCurrentIdentity();
            if (store)
            {
                var kvs = new keyValueStorage();
                kvs.open( store );
                var playIMSound = kvs.getValue(this.scene.prefObj.playAlertSoundKey, this.scene.prefObj.playAlertSoundDefaultValue);
                var displayNotification = kvs.getValue(this.scene.prefObj.externalNotifyKey , this.scene.prefObj.externalNotifyDefaultValue);
                    
                kvs.close();
                if (displayNotification.toString() == "true" && !this.scene.rootBox.active)
                {
                    var html = "<html><body>" + message + "</body></html>";
                    shell.app.newNotification(this.scene, html, screenName,  10, "alert");
                    shell.device.playSoundOrVibrate("sysSoundExclamation", 250, 250, 3);
                }
                else 
                {
                    if (playIMSound.toString() == "true")
                    {
                        var path = shell.app.path + "\\resources\\newalert.wav";
                        shell.device.playSoundOrVibrate(path, 100, 0, 0);
                    }
                    
                    if(displayNotification.toString() == "true")
                    {
                        shell.device.setPowerState("ON");
                    }
                }
                
                
            }
        }
        catch (e){}
    }
}


component.prototype.removeAlertByScreenName = function(screenName)
{
    var isRemoved = false;
    if (this.alertList)
    {
        var tempName = screenName.toLowerCase();
    
        var index = this.alertList.indexOfValue(tempName);
        if (index > -1)
        {
            this.alertList.removeValueAtIndex(index);
            
            try
            {
                var storeName = this.scene.prefObj.prefsGetStoreForCurrentIdentity() + ".alertList";
                var kvs = new keyValueStorage();
                kvs.open(storeName);
                kvs.removeKey(screenName);
                kvs.close();
            }
            catch(err){}
            
            if (this.alertList.count == 0)
            {
                delete this.alertList;
                this.alertList = null;
            }
            isRemoved = true;
        }
    }
    return isRemoved;
}

component.prototype.propagateNotification = function(icon, message, timeToDisplay)
{
    var event = shell.factory.createEvent(this._gadget);
    if (event)
    {	    
        event.type = "showNotification";
        event.icon = icon;
        event.message = message;
        event.timeToDisplay = timeToDisplay;
        this._gadget.dispatchEvent(event);
    }
}

component.prototype.buddyPresenceUpdate = function(screenName, state)
{
    this.notifyAlert(screenName, state);
}

//****************************************************************************

component.prototype.updateMailCount = function(mailCount)
{
    if (this._gadget.getAttribute("showMailIcon") == "true")
    {
        var count = mailCount == 0 ? "" : mailCount;
        var badgeFill = "";
        if (count)
        {
            badgeFill = "#mailCount.digit.";
            if (count < 10)
            {
                badgeFill += "1";
            }
            else if (count < 100)
            {
                badgeFill += "2";
            }
            else if (count < 1000)
            {
                badgeFill += "3";
            }
            else
            {
                badgeFill += "3";
                count = '\u221E'; // Unicode infinity
            }
        }
        this._gadget.setAttribute("mailBadgeFill", badgeFill);
        this._gadget.setAttribute("mailCount", count);
    }
}

component.prototype.onMailIconCommand = function()
{
    this.scene.focusedBox = this._gadget.getPartById("mailIcon");
    try
    {
        appUtils.shellExecute("http://wap.aol.com/mail?ncid=txtlnknew00000003");
    }
    catch(e){}
}

component.prototype.selectLastBuddyListRow = function()
{
    var grid;
    var selectedIndex = 0;
    if (this._gadget.getAttribute("searching") == "false")
    {
        grid = this._gadget.getPartById("buddyListGrid");
        var offlineGroup = grid.getPartById("Offline Buddies");
        var index = grid.getRowOfBox(offlineGroup);
        if (offlineGroup.toggled)
        {
            var offlineGroupObj = this.scene._buddyListObj.getOfflineBuddyGroup();
            if (offlineGroupObj)
            {
                index += offlineGroupObj.getOnlineBuddyCount();
            }
        }
        selectedIndex = index;
    }
    else
    {
        grid = this._gadget.getPartById("searchResultGrid");
        selectedIndex = this.scene._searchListDataSrc.count;
    }
    grid.selectedIndex = selectedIndex;
    this.scene.focusedBox = grid;
}

