// ****************************************************************************
//
// Copyright  2008 AOL LLC  All rights reserved.
// This software contains valuable confidential and proprietary information
// of AOL LLC and is subject to applicable licensing agreements.
// Unauthorized reproduction, transmission or distribution of this file and
// its contents is a violation of applicable laws.
//
//           A O L  L L C   C O N F I D E N T I A L
//
// ****************************************************************************

function component (_gadget)
{
}

component.prototype.onUrlLoadComplete = function()
{
    this._gadget.setAttribute("placeholder", "false");
}

//****************************************************************************

component.prototype.setIMCount = function(count)
{
    var icon = this._gadget;

    icon.setAttribute("imCount", "" + count);
    if (count > 0)
    {
        icon.setAttribute("throbber", "true");
    
        icon.setAttribute("badgeIcon", "#badge.newIM");
        icon.setAttribute("badgeLabel", "" + count);
        icon.setAttribute("showBadgeLabel", "true");

        // Turn on the animation
        icon.setAttribute("throbber", "true");
        
        this.showBadge(true);
    }
    else
    {
        icon.removeAttribute("throbber");
    
        icon.setAttribute("showBadgeLabel", "false");
        this.showBadge(false);

        // Remove animation        
        icon.removeAttribute("throbber");
        
        var presence = icon.getAttribute("presenceState");
        this.setPresence(presence);
    }
}

//****************************************************************************

component.prototype.setPresence = function(state)
{
    var icon = this._gadget;
    
    icon.setAttribute("presenceState", state);
    
    var imCount = parseInt(icon.getAttribute("imCount"));
    if (imCount == 0)
    {
        var badge = this._gadget.getPartById("badge");
    
        icon.setAttribute("badgeLabel", "");
        icon.setAttribute("showBadgeLabel", "false");
        icon.setAttribute("badgeIcon", getPresenceIcon(state));
        this.showBadge(true);
    }
}

//****************************************************************************

component.prototype.showBadge = function(state)
{
    var icon = this._gadget;
    var currentState = (icon.getAttribute("showBadge") == "true") ? true : false;
    if (state != currentState)
    {
        icon.setAttribute("showBadge", state ? "true" : "false");
        
        if (!state)
            icon.removeAttribute("throbber");
    }
}

//****************************************************************************

component.prototype.onFocusChanged = function()
{
    var carousel = this.scene.getBoxById("activeConversationBar");
    propagateEventForBox(carousel, "focusChanged");
}



