// ****************************************************************************
//
// Copyright ?2008 AOL LLC  All rights reserved.
// This software contains valuable confidential and proprietary information
// of AOL LLC and is subject to applicable licensing agreements.
// Unauthorized reproduction, transmission or distribution of this file and
// its contents is a violation of applicable laws.
//
//           A O L  L L C   C O N F I D E N T I A L
//
// ****************************************************************************

function component(_gadget)
{
    this.signedInScreenName;
    this.currConversationBuddy;
    this.softKeyAsSend = false;
    this.reconnectPopupTimer;
    this.autoResponseArray;
}

component.prototype.setTrackAutoResponse = function(isTrack)
{
    if (isTrack)
    {
        if (!this.autoResponseArray)
        {
            this.autoResponseArray = new xArray();
        }
    }
    else
    {
        this.autoResponseArray = null;
    }
}

component.prototype.setSignedInScreenName = function(aName)
{
    this.signedInScreenName = aName;
}

component.prototype.newMessage = function(isMobileConversation)
{   
    var conversation = this._gadget.getPartById("1_newmessage");
    if (conversation)
    {
        this._gadget.deleteChild(conversation);
    }
    var buddyInfo = new Object();
    buddyInfo.aimId="1_newmessage";
    var conversation = this._gadget.startConversation(buddyInfo, true, true, isMobileConversation, true);
    if (conversation)
    {
        // Change the menu items to reflect the editing mode
        // This is an ugly way to dynamically change the softkey menu items
        // We need to be able to just set an atttribute on the chat panel and have this switch
        
        var rootBox = this.scene.rootBox;
        var softKeyMenu = this._gadget.getPartById("leftSoftKeyMenu");
        softKeyMenu.setAttribute("menuTitle", "");
        softKeyMenu.setAttribute("commandId", "IDM_NOIMPL");
        softKeyMenu.setAttribute("hasSubMenu", "false");

        softKeyMenu = this._gadget.getPartById("rightSoftKeyMenu");
        softKeyMenu.setAttribute("menuTitle", rootBox.getAttribute("aim.cancel"));
        softKeyMenu.setAttribute("commandId", "IDM_CONV_EDIT_CANCEL");
        softKeyMenu.setAttribute("hasSubMenu", "false");

        propagateEventForBox(this._gadget, "menuChanged"); // update the menu
    }
}

component.prototype.getProfileForCurrConversation = function()
{
    propagateEventForBox(this._gadget, "getBuddyProfile");
}

component.prototype.startConversation = function(buddyInfo, show, disableChat, isMobileConversation, isEditing)
{
    // Make sure this buddy has an icon on the carousel
    if (buddyInfo.state == "mobile" || isMobileConversation)
    {
        buddyInfo.state = "mobile";
        buddyInfo.buddyIcon = "#buddyList.placeHolderText";
    }

    var buddyId = buddyInfo.aimId;
    var conversation = this._gadget.getPartById(buddyId);
    var carousel = this.scene.getBoxById("activeConversationBar");
    var convExisted = false;
    if (conversation)
    {
        convExisted = true;
    }
    
    if (!conversation)
    {
        conversation = this.scene.createBox("conversation");
        conversation.setBuddyInfo(buddyInfo, true);
        conversation.setAttribute("respectUIScale", this._gadget.getAttribute("respectUIScale"));
        conversation.setAttribute("signedInScreenName", this.signedInScreenName);
        this._gadget.addChild(conversation, "part");
        conversation.addEventHandler("sendIM", "gadget:sendIM();");
        conversation.addEventHandler("inputModified", "gadget:updateSoftKey();");
        conversation.addEventHandler("newMessageScreenNameSet", "gadget:onNewMessageScreenNameSet();");
        conversation.addEventHandler("navLeft", "gadget:onNavLeft();");
        if (disableChat)
        {
            conversation.setAttribute("disableChat", "true");
        }
        if (isMobileConversation)
        {
            conversation.setAttribute("mobileConversation", "true");
            conversation.addAlertToConversation(this.scene.rootBox.getAttribute("im.message.mobile"));
        }
    }
    if (show)
    {   
        //collapsed the previous conversation
        if (this.currConversationBuddy && this.currConversationBuddy != buddyId)
        {
            var currConversation = this.getCurrConversation();
            currConversation.collapsed = true;
        }
        
        if (isEditing)
        {
            conversation.setEditing(true);
        }
        this.currConversationBuddy = buddyId;
        conversation.collapsed = false;
        
        // Activate the buddy
        //carousel.activateBuddy(buddyId);
        
        var event = shell.factory.createEvent(this._gadget);
        event.type = "buddyTabActivated";
        event.screenName = buddyId;
        event.prevActiveIdx = -1;
        event.currActiveIdx = -1;
        this._gadget.dispatchEvent(event);
        
        if (!isEditing)
        {    
            this.updateSoftKey();
            conversation.setComposeInputFocus();
        }
    }
    else if (!convExisted)
    {
        conversation.collapsed = true;
    }

    var carouselIcon = carousel.findBuddy(buddyId);
    if (!carouselIcon)
    {
        carousel.addBuddy(buddyInfo, (!show || carousel.contentChildCount > 0));
    }
    if (show)
    {
        carousel.activateBuddy(buddyId, false);
    }

    return conversation;
}

component.prototype.onNavLeft = function()
{
    var event = shell.factory.createEvent(this._gadget);
    if (event)
    {	    
	    event.type = "navLeft";
	    event.currentBox = this._gadget;
	    this._gadget.dispatchEvent(event);
    }
}

component.prototype.findConversation = function(buddyId)
{
    return this._gadget.getPartById(buddyId);
}   

component.prototype.onCloseCurrentConversation = function()
{
    this.closeConversationHelper(this.getCurrConversation());
}

component.prototype.closeConversationHelper = function(conversation)
{
    if (conversation)
    {
        var carousel = this.scene.getBoxById("activeConversationBar");
        var activeBuddy = carousel.getActiveBuddy();
        if (activeBuddy == "1_advertisement")
        {
            // Close the ad
            this._gadget.deleteChild(conversation);
            propagateEventForBox(this._gadget, "conversationBack");
            this.currConversationBuddy = null;
        }
        else
        {
            // remove the active conversation carousel icon
            carousel.removeActiveBuddy();
            if (!carousel.getActiveBuddyBox())
            {
                // This is the last open conversation - close the conversation window
                propagateEventForBox(this._gadget, "conversationBack");
                this.currConversationBuddy = null;
            }
            var store = this.scene.prefObj.prefsGetStoreForCurrentIdentity();
            if (store)
            {
                var kvs = new keyValueStorage();
                kvs.open( store );
                var saveConversation = kvs.getValue(this.scene.prefObj.saveConversationsKey, this.scene.prefObj.saveConversationsDefaultValue);
                kvs.close();
                if (saveConversation.toString() == "true")
                {
                    conversation.collapsed = true;
                }
                else
                {
                    this._gadget.deleteChild(conversation);
                }
            }
        }
    }
}

component.prototype.onBuddyTabActivated = function()
{
    var event = shell.currentEvent;
    var transition = null;
    var prevIdx = event.prevActiveIdx;
    var currIdx = event.currActiveIdx;
    
    var buddyId = event.screenName;
    var currConversation = this._gadget.getPartById(buddyId);
    
    var source = this.scene._buddyListObj.getBuddyInfo(buddyId)
    if (source)
    {
        source.flags = 1;
        this.scene._buddyListObj.updateBuddiesFromObj(source);
    }
    
    var panelController = this.scene.getBoxById("contentContainer");
    var isConversationView = panelController.getAttribute("show_chatPanel") == "true";
    if (this.scene.prefObj.enableAllTransitions && isConversationView && buddyId != this.currConversationBuddy)
    {
        if (prevIdx > -1 || currIdx > -1)
        {
            if (prevIdx > currIdx)
            {
                transition = "pushDown"
            }
            else
            {
                transition = "pushUp"
            }
        }
    }
    if (buddyId != this.currConversationBuddy)
    {
        if (transition)
        {
            takeSnapshot(this._gadget);
        }
        var prevConversation = this._gadget.getPartById(this.currConversationBuddy);
        if (prevConversation)
        {
            prevConversation.collapsed = true;
        }
        if (currConversation)
        {
            this.setHideReconnectPopup();
            currConversation.collapsed = false;
            this.currConversationBuddy = buddyId;
            this.updateSoftKey();
        }
        if (transition)
        {
            doTransition(this._gadget, transition, 400);
        }
    }
    if (currConversation)
    {
        var editing = currConversation.getAttribute("editing");
        if(!editing || editing != "true")
        {
            currConversation.setComposeInputFocus();
        }
    }
    if (!isConversationView)
    {
        // Tell the panel controller to display the conversation window	    
        var buddyList = this.scene.getBoxById("buddyList");
        propagateEventForBox(buddyList, "showConversationWindow");
    }
    var carouselBar = this.scene.getBoxById("activeConversationBar");
    if (!carouselBar.collapsed)
    {
        this.scene.getBoxById("activeConversationBar").moveBuddyToTop(buddyId);
    }
}

component.prototype.insertComposeText = function(string)
{
    var currConversation = this.getCurrConversation();
    if (currConversation)
    {
        var value = currConversation.getPartById("composeInput").getAttribute("value");
        currConversation.insertComposeText(string);
        if ((!value || value == "") && string)
        {
            this.updateSoftKey();
        }
    }
}

component.prototype.receivedIM = function(buddyInfo, message, isAutoResponse)
{
    // We received an IM - add the buddy to the carousel
    var fromBuddy = this.startConversation(buddyInfo, false);
    if (fromBuddy)
    {
        var conversationHistory = fromBuddy.getPartById("conversationHistory");
        var displayName = buddyInfo.displayId;
        if (isAutoResponse)
        {
            displayName = formatString1(this.scene.rootBox.getAttribute("im.message.awayMessage"), displayName);
        }
        conversationHistory.addReceivedIM(displayName, message, isAutoResponse);
        
        //if we are currently away, auto response first message from anyone
        if (this.autoResponseArray)
        {
            var lowerCaseName = buddyInfo.aimId.toLowerCase();
            if (!this.autoResponseArray.containsValue(lowerCaseName))
            {
                this.autoResponseArray.addValue(lowerCaseName);
                var event = shell.factory.createEvent(this._gadget);
	            if (event)
	            {	    
		            event.type = "sendAutoResponse";
		            event.screenName = lowerCaseName;
		            this._gadget.dispatchEvent(event);
	            }
            }
        }
    }
}

component.prototype.receivedOfflineIM = function(buddyInfo, message, timestamp)
{
    // We received an offline IM - add the buddy to the carousel
    var fromBuddy = this.startConversation(buddyInfo, false);
    if (fromBuddy)
    {
        var conversationHistory = fromBuddy.getPartById("conversationHistory");
        conversationHistory.addReceivedOfflineIM(buddyInfo.aimId, message, timestamp);
    }
}


component.prototype.updateMenu = function()
{
    var focusedBox = this.scene.focusedBox;
    if (focusedBox)
    { 
        var currConversation = this.getCurrConversation();
    
        var gadgetParent = focusedBox.gadgetParent;
        if (gadgetParent && gadgetParent.tag == "dropDownMenu")
        {
            //if dropdown is opened
            if (currConversation)
            {
                this.scene.focusedBox = currConversation.getPartById("screenName");
            }
        }
        var collapsed = (focusedBox.tag == "convIconBar" || (gadgetParent && gadgetParent.tag == "convIconBar")) ? true : false;
        this._gadget.getPartById("closeMenuItem").collapsed = collapsed;
        this._gadget.getPartById("addMenuItem").collapsed = collapsed;
        this._gadget.getPartById("reportSpamMenuItem").collapsed = collapsed;
        var blockMenuItem = this._gadget.getPartById("blockMenuItem");
        blockMenuItem.collapsed = collapsed;
        if (!collapsed)
        {
            if (currConversation)
            {
                var rootBox = this.scene.rootBox;
                var state = currConversation.getAttribute("presenceState");
                var newValue = (state == "blocked") ? "im.menu.label.Unblock" : "im.menu.label.Block";
                newValue = rootBox.getAttribute(newValue);
                var currValue = blockMenuItem.getAttribute("value");
                
                // don't update the menu if it's the same
                if (newValue != currValue)
                {
                    blockMenuItem.setAttribute("label", newValue);
                    blockMenuItem.setAttribute("value", newValue);
                    var newAccessKey = (state == "blocked") ? "bl.submenu.label.Unblock_accesskey" : "bl.submenu.label.Block_accesskey";
                    blockMenuItem.setAttribute("accessKey", rootBox.getAttribute(newAccessKey));
                }
            }
        }
    }
}

component.prototype.updateSoftKey = function(forceRightKeyUpdate)
{
    var label;
    var commandId;
    var hasSubmenu;
    var softKeyMenu;
    var isUpdateMenu = false;
    var currConversation = this.getCurrConversation();
    if (currConversation)
    {
        var input = currConversation.getPartById("composeInput");
        if (input)
        {
            var inputValue = input.getAttribute("value");
            var newSoftKeyAsSend = (inputValue == undefined || !inputValue || inputValue == "") ? false : true;
            if (newSoftKeyAsSend != this.softKeyAsSend || forceRightKeyUpdate)
            {
                if (newSoftKeyAsSend)
                {
                    var isContinueOffline = this.scene.AIMobj.getContinueOffline()
                    label = (isContinueOffline) ? "reconnect.Reconnect" : "aim.menu.label.Send";
                    commandId = (isContinueOffline) ? "IDM_RECONNET_SIGNIN" : "IDM_CONV_SEND";;
                    hasSubmenu = "false"; 
                }
                else
                {
                    label = "aim.menu.label.Menu";
                    commandId = "IDM_CONV_MENU";
                    hasSubmenu = "true";
                }
                this.softKeyAsSend = newSoftKeyAsSend;
            }
        } 
    }
    
    if (label && commandId && hasSubmenu)
    {
        softKeyMenu = this._gadget.getPartById("rightSoftKeyMenu");
        if (softKeyMenu.getAttribute("commandId") != commandId)
        {        
            isUpdateMenu = true;
            softKeyMenu.setAttribute("menuTitle", this.scene.rootBox.getAttribute(label));
            softKeyMenu.setAttribute("commandId", commandId);
            softKeyMenu.setAttribute("hasSubMenu", hasSubmenu);
        }
    }
    softKeyMenu = this._gadget.getPartById("leftSoftKeyMenu");
    if (softKeyMenu.getAttribute("commandId") != "IDM_CONV_BUDDYLIST")
    {
        isUpdateMenu = true;
        softKeyMenu.setAttribute("menuTitle", this.scene.rootBox.getAttribute("im.menu.label.BuddyList"));
        softKeyMenu.setAttribute("commandId", "IDM_CONV_BUDDYLIST");
        softKeyMenu.setAttribute("hasSubMenu", "false");
    }
    
    if (isUpdateMenu)
    {
        propagateEventForBox(this._gadget, "menuChanged"); // update the menu
    }
}

component.prototype.sendIM = function()
{
    var currEvent = shell.currentEvent ? shell.currentEvent : null;
    if (currEvent)
    {
        if (!currEvent.reconnecting)
        {
            //check if this is a blocked user. If it the buddy is blocked, don't send the 
            //im since we will return an error code.
            var conversation = this._gadget.getPartById(this.currConversationBuddy);
            var state = conversation.getAttribute("presenceState");
            if(state == "blocked")
            {
                conversation.addAlertToConversation(this.scene.rootBox.getAttribute("im.message.sendBlockedUser"));   
            }
            else
            {
                var event = shell.factory.createEvent(this._gadget);
	            if (event)
	            {	    
		            event.type = currEvent.type;
		            event.screenName = currEvent.screenName;
		            event.message = currEvent.message;
		            this._gadget.dispatchEvent(event);
	            }
            }
            this.updateSoftKey();
        }
        else
        {
            var message = this.scene.AIMobj.getContinueOffline() ? "im.message.sendWhileContinueOffline" : "im.message.sendWhileReconnect";
            this._gadget.getPartById("reconnectPopup").setAttribute("label", this.scene.rootBox.getAttribute(message));
            this._gadget.setAttribute("hideReconnectPopup", "false");
        }
    }
}

component.prototype.onNewMessageScreenNameSet = function()
{
    var currentEvent = shell.currentEvent;
    var targetBox = (currentEvent) ? currentEvent.targetBox : null;
    if (targetBox)
    {
        //update the old id and display id
        //check with carousel   
        var currId = targetBox.id;
        var value = targetBox.getPartById("screenName").getAttribute("value");
        var carousel = this.scene.getBoxById("activeConversationBar");
        var currConversation = this._gadget.getPartById(value);
        if (currConversation)
        {
            currConversation.collapsed = false;
            currConversation.setComposeInputFocus();
            targetBox.collapsed = true;
        }
        else
        {
            targetBox.id = value;
        }
        this.currConversationBuddy = value;
        
        var carouselItem = carousel.findBuddy(value);
        if (carouselItem)
        {
            // if duplicate, remove the one we just created
            var newMessageId = carousel.getActiveBuddy();
            carousel.activateBuddy(value);
            carousel.removeBuddy(newMessageId);
        }
        else
        {
            var carouselItem = carousel.findBuddy(currId);
            carouselItem.setAttribute("buddyId", value);
            carouselItem.setAttribute("buddyDisplayId", value);
            carouselItem.setAttribute("label", value);
            
            var buddyObj = this.scene._buddyListObj.getBuddyInfo(value);
            if (!buddyObj)
            {
                this.scene.AIMobj.addTempBuddy(value);
                this.scene.AIMobj.getPresenceInfo(value);
            }
            else
            {
                carousel.updateBuddyPresence(buddyObj);
                if (!currConversation)
                {
                    currConversation = this.getCurrConversation();
                }
                if (currConversation)
                {
                    currConversation.setBuddyInfo(buddyObj, true);
                }
            }
        }
    }
}

component.prototype.signOut = function()
{
    propagateEventForBox(this._gadget, "buddyListSignOff");
}

component.prototype.getCurrConversation = function()
{
    return (this.currConversationBuddy) ? this._gadget.getPartById(this.currConversationBuddy) : null;
}

component.prototype.getCurrConversationId = function()
{
    return this.currConversationBuddy;
}

component.prototype.updateBuddyPresence = function(buddyInfo, manualUpdate)
{
    var buddyId = buddyInfo.aimId;
    var conversation = this._gadget.getPartById(buddyId);
    if (conversation)
    {
        conversation.setBuddyInfo(buddyInfo, manualUpdate);
    }
}

component.prototype.addAlertForScreenName = function(screenName, alertMsg)
{
    if (alertMsg)
    {
        var conversation = this._gadget.getPartById(screenName);
        if (conversation)
        {
            conversation.addAlertToConversation(alertMsg);        
        }
    }
}

component.prototype.cleanAll = function()
{
    if (this.reconnectPopupTimer)
    {
        this.setHideReconnectPopup();
    }
    this.autoResponseArray = null;
    this.signedInScreenName = null;
    this.currConversationBuddy = null;
    this.softKeyAsSend = false;
    this._gadget.setAttribute("hideReconnectPopup", "true");
    this.removeAllConversation();
}

component.prototype.removeAllConversation = function()
{
    var child = this._gadget.firstChild;
    while(child)
    {   
        var nextSibling = child.nextSibling;
        if (child.tag == "conversation" && child.id != "emptyConversation")
        {
            this._gadget.deleteChild(child);
        }
        child = nextSibling;
    }
}

component.prototype.showUnknownConversationDialog = function()
{
    var event = shell.currentEvent;
    var screenName = event.screenName;
    
    propagateEventForBox(this._gadget, "unknownDialogBoxShown"); // update the menu
    
    var alertBox = this.scene.getBoxById("alertBox");
    var message = formatString1(this.scene.rootBox.getAttribute("unknownUser.label"), screenName);
    alertBox.alert(message, "alertContentUnknownUser", null, null, this, "unknownUserAction");
    var contentBox = alertBox.getPartById("alertContentUnknownUser");
    
    contentBox.screenName = screenName;
    contentBox.prevActiveIdx = event.prevActiveIdx;
    contentBox.currActiveIdx = event.currActiveIdx;
    this.scene.focusedBox = alertBox.getPartById("viewButton");
}

component.prototype.unknownUserAction = function(buttonIndex)
{
    var alertBox = this.scene.getBoxById("alertBox");
    if (alertBox)
    {
        var isCloseConversation = false;
        var isCloseAlertBox = true;
        var contentBox = alertBox.getPartById("alertContentUnknownUser");
        var screenName = contentBox.screenName;
        if (screenName)
        {
            var blockUserCheckButton = alertBox.getPartById("blockBuddyButton");
            if (blockUserCheckButton)
            {
                if (blockUserCheckButton.toggled)
                {
                    this.scene.AIMobj.setPermitDeny("pdBlock", screenName, true);
                }
            }
            
            var unknownConversation = this._gadget.getPartById(screenName);
            if (unknownConversation)
            {
                switch(buttonIndex)
                {
                    case "0":
                    {
                        var convIcon = this.scene.getBoxById("activeConversationBar").findBuddy(screenName)
                        if (convIcon)
                        {
                            this.scene.AIMobj.getPresenceInfo(screenName);
                            var event = shell.factory.createEvent(convIcon);
                            if (event)
                            {	    
                                // Send an event to the conversation window that we active a buddy
                                event.type = "buddyTabActivated";
                                event.prevActiveIdx = contentBox.prevActiveIdx;
                                event.currActiveIdx = contentBox.currActiveIdx;
                                event.screenName = screenName;
                                this._gadget.dispatchEvent(event);
                            }
                            this.scene.AIMobj.addTempBuddy(screenName);
                        }
                        break;
                    }
                    case "1":
                    {
                        isCloseConversation = true;
                        break;
                    }
                    case "2":
                    {
                        this.reportSpamDialogOnCurrentUser(screenName);
                        isCloseAlertBox = false;
                        break;
                    }
                }
            }
            if (isCloseAlertBox)
            {
                propagateEventForBox(this._gadget, "menuChanged"); // update the menu
                alertBox.close();
            }
            if (isCloseConversation)
            {
                this.closeConversationHelper(unknownConversation);
            }
        }
    }
}

component.prototype.reportSpam = function(screenName, reportType)
{
    if (screenName && reportType)
    {
        this.scene.AIMobj.reportSPIM(screenName, reportType, "decline");
    }
}

component.prototype.addCurrentConversation = function()
{
    propagateEventForBox(this._gadget, "addCurrentConversation");
}

component.prototype.blockUnblockBuddyById = function(id, displayMessage)
{
    if (id)
    {
        var event = shell.factory.createEvent(this._gadget);
        if (event)
        {	    
	        event.type = "blockUnBlock";
	        event.buddyId = id;
	        event.displayMessage = displayMessage;
	        this._gadget.dispatchEvent(event);
        }
    }
}

component.prototype.setHideReconnectPopup = function()
{
    if (this._gadget.getAttribute("hideReconnectPopup") == "false")
    {
        this._gadget.setAttribute("hideReconnectPopup", "true");
        if (this.reconnectPopupTimer)
        {
            this.reconnectPopupTimer = null;
        }
    }
}

component.prototype.onHideReconnectPopupChanged = function()
{
    var showPopup = this._gadget.getAttribute("hideReconnectPopup");
    if (showPopup == "false")
    {
        this.reconnectPopupTimer = setTimeoutObject(this._gadget, "setHideReconnectPopup", 10000);
    }
    else if (this.reconnectPopupTimer)
    {
        this.reconnectPopupTimer.cancel();
        this.reconnectPopupTimer = null;
    }
}

component.prototype.onAdvertisementActivated = function()
{
    var event = shell.currentEvent;
    var targetBox = event ? event.targetBox : null;
    var adBox = targetBox ? targetBox.getPartById("icon") : null;;
    if (adBox)
    {
        adBox.linkClicked();
        this.scene.getBoxById("activeConversationBar").ensureIconVisible("1_advertisement");
    }
}

component.prototype.cleanSavedConversation = function()
{
    var carousel = this.scene.getBoxById("activeConversationBar");
    var child = this._gadget.firstChild;
    while(child)
    {   
        var nextSibling = child.nextSibling;
        if (child.tag == "conversation" && child.id != "emptyConversation")
        {
            if (!carousel.findBuddy(child.id))
            {
                this._gadget.deleteChild(child);
            }
        }
        child = nextSibling;
    }
}

component.prototype.reportSpamDialogOnCurrentUser = function(id)
{
    var isUnknownUser = (!id) ? false : true;
    if (!id)
    {
        id = this.getCurrConversationId();
    }
    if (id)
    {
        var rootBox = this.scene.rootBox;
        var alertBox = this.scene.getBoxById("alertBox");
        alertBox.alert(formatString1(rootBox.getAttribute("im.reportSpam.onUser"), id), "alertContentReportAbuse", rootBox.getAttribute("aim.submit"), rootBox.getAttribute("aim.cancel"), this, "reportSpamDialogResult");
        var alertContentReportAbuse = alertBox.getPartById("alertContentReportAbuse");
        this.scene.focusedBox = alertContentReportAbuse.getBoxByTag("radioBox");
        alertBox.isUnknownUser = isUnknownUser;
        alertContentReportAbuse.setAttribute("screenName", id);
    }
}

component.prototype.reportSpamDialogResult = function(buttonIndex)
{
    var alertBox = this.scene.getBoxById("alertBox");
    var screenName;
    var reportAbuseBox = alertBox.getPartById("alertContentReportAbuse");
    if (reportAbuseBox)
    {
        screenName = reportAbuseBox.getAttribute("screenName");
    }
    if (screenName)
    {
        if (buttonIndex == 0)
        {
            var selectedOption = reportAbuseBox.getBoxByTag("radioBox").selectedIndex;
            var reportType = (selectedOption == 0) ? "spim" : "abuse";
            this.reportSpam(screenName, reportType);
        }
        else if (alertBox.isUnknownUser)
        {
            this.scene.getBoxById("activeConversationBar").activateBuddy(screenName, true);
        }
    }
    alertBox.isUnknownUser = null;
    alertBox.screenName = null;
}

