// ****************************************************************************
//
// Copyright ?2008 AOL LLC  All rights reserved.
// This software contains valuable confidential and proprietary information
// of AOL LLC and is subject to applicable licensing agreements.
// Unauthorized reproduction, transmission or distribution of this file and
// its contents is a violation of applicable laws.
//
//           A O L  L L C   C O N F I D E N T I A L
//
// ****************************************************************************

function component (_gadget)
{
    this.parentObj;
}

component.prototype.setParentsObject = function(parentObject)
{
    this.parentObj = parentObject;
}

component.prototype.getParentsObject = function()
{
    return this.parentObj;
}

component.prototype.mouseUp = function()
{
    var targetBox = shell.currentEvent.targetBox;
    if (targetBox && targetBox.tag == "scrollButton")
    {   
        var nextItem = this.selectNextComboItem(targetBox.id == "buttonDown")
        if (nextItem)
        {
            var dropDownContainer = this._gadget.getPartById("dropDownContainer");
            dropDownContainer.selectedBox = nextItem;
        }
    }
}


component.prototype.selectNextComboItem = function(next)
{
    var nextSelectedBox;
    if (this.parentObj)
    {
        var list = this._gadget.getPartById("dropDownContainer");
        var selectedBox = list.selectedBox;
        if (selectedBox)
        {
            var nextSelectedBox = (next) ? selectedBox.nextSibling : selectedBox.previousSibling;
            if (nextSelectedBox && nextSelectedBox.tag == "dropDownMenuItem")
            {
                try
                {
                    this.propagateNewValue(nextSelectedBox);
                }
                catch(e)
                {
                }
            }
        }
    }
    return nextSelectedBox;
}

component.prototype.propagateNewValue = function(nextSelectedBox)
{
    if (this.parentObj && nextSelectedBox)
    {
        var value = nextSelectedBox.getAttribute("value")
        try
        {
            this.parentObj.updateValue(value);
        }
        catch(e)
        {
        }
    }
}
component.prototype.selectMenuAtIndex = function(index)
{
    if (index > -1 && index < this._gadget.contentChildCount)
    {
        if (this.parentObj)
        {
            var value = this._gadget.getContentChildAt(index).getAttribute("value")
            try
            {
                this.parentObj.updateValue(value);
            }
            catch(e){}
        }
        this._gadget.getPartById("dropDownContainer").selectedIndex = index;
    }
}

component.prototype.close = function()
{
    if (!this._gadget.collapsed)
    {
        this._gadget.collapsed = true;
        if (this.parentObj)
        {
            try
            {
                this.parentObj.dropdownClose();
            }
            catch(e)
            {
            }
        }

    }
}

component.prototype.onSelected = function(index)
{
    var event = shell.currentEvent;
    var targetBox = (event) ? event.targetBox : null;
    if (targetBox && (targetBox.tag == "dropDownMenuItem" || targetBox.tag == "selectBox"))
    {
        if (targetBox.tag == "selectBox")
        {
            targetBox = targetBox.selectedBox;
        }
        this.propagateNewValue(targetBox);
        
        if (this.parentObj)
        {
            var event = shell.factory.createEvent(this.parentObj);
            if (event)
            {	    
                event.type = "menuItemSelected";
                event.context = targetBox.getAttribute("context");
                event.value = targetBox.getAttribute("value");
                this.parentObj.dispatchEvent(event);
            }
        }
        this.close();
    }
}

component.prototype.appendMenuItem = function(menuItem)
{
    this._gadget.addContentChild(menuItem);
}

component.prototype.clearContent = function()
{
    this._gadget.deleteContentChildren();
}

