// ****************************************************************************
//
// Copyright ?2008 AOL LLC  All rights reserved.
// This software contains valuable confidential and proprietary information
// of AOL LLC and is subject to applicable licensing agreements.
// Unauthorized reproduction, transmission or distribution of this file and
// its contents is a violation of applicable laws.
//
//           A O L  L L C   C O N F I D E N T I A L
//
// ****************************************************************************

function component(_gadget)
{
    this.modified = false;
}

component.prototype.getInputValue = function()
{   
    return this._gadget.getPartById("input").getAttribute("value");
}

component.prototype.editingChanged = function()
{
    if (this._gadget.getAttribute("editing") == "true")
    {
        this.scene.focusedBox = this._gadget.getPartById("input");
        this.modified = true;
    }
    else if (this.modified)
    {   
        var input = this._gadget.getPartById("input");
        var value = input.getAttribute("value");
        if (value)
        {
            this._gadget.setAttribute("value", value);
        }
        this.modified = false;
        this.propagateNewValue("inputFocusLost");
    }
}

component.prototype.inputFocusLost = function()
{
    if (this.modified && !this._gadget.focused)
    {
        this.modified = false;
        this._gadget.setAttribute("value", this._gadget.getPartById("input").getAttribute("value"));
        this.propagateNewValue("inputFocusLost");
    }
}

component.prototype.enterPressed = function()
{
    if (this._gadget.getAttribute("editing") == "true")
    {
        this.modified = false;
        this._gadget.setAttribute("value", this._gadget.getPartById("input").getAttribute("value"));
        this.propagateNewValue("inputFocusLost");
    }
    else
    {
        var event = shell.factory.createEvent(this._gadget);
        if (event)
        {	    
	        event.type = "enterToEdit";
	        this._gadget.dispatchEvent(event);
        }    
    }
}

component.prototype.propagateNewValue = function(eventName)
{
    var event = shell.factory.createEvent(this._gadget);
    if (event)
    {	    
	    event.type = eventName;
	    event.newValue = this._gadget.getPartById("input").getAttribute("value");
	    this._gadget.dispatchEvent(event);
    }
}

component.prototype.labelValueChanged = function()
{
    var label = this._gadget.getPartById("label");
    if (!label.getAttribute("value"))
    {
        var hintText = this._gadget.getAttribute("hintText");
        if (hintText)
        {
            label.setAttribute("value", hintText);
        }
    }
}

component.prototype.setCaretPos = function(position)
{   
    this._gadget.getPartById("input").setCaretPos(position);
}
