// ****************************************************************************
//
// Copyright ?2008 AOL LLC  All rights reserved.
// This software contains valuable confidential and proprietary information
// of AOL LLC and is subject to applicable licensing agreements.
// Unauthorized reproduction, transmission or distribution of this file and
// its contents is a violation of applicable laws.
//
//           A O L  L L C   C O N F I D E N T I A L
//
// ****************************************************************************

function component (_gadget)
{
}

component.prototype.layoutDropdown = function()
{
    var dropdown = this._gadget.getPartById("dropDown");
    var parentBox = dropdown.getParentsObject();
    if (parentBox)
    {
        // parentBox.frameY - (parentBox.boxHeight/2) is used instead of parentBox.frameY here
        // because it seems like there is some bug is layout when the parent of parentBox has vAlign="center" set
        dropdown.top = (parentBox.frameY - (parentBox.boxHeight/2)) + parentBox.boxHeight;
        dropdown.left = parentBox.frameX;
    }
    this.scene.focusedBox = dropdown.getPartById("dropDownContainer");
}

component.prototype.setSelectedBoxByIndex = function(index, updateSelected)
{
    var dropdown = this._gadget.getPartById("dropDown");
    dropdown.selectMenuAtIndex(0);
    if (updateSelected)
    {
        var menuItemCount = dropdown.contentChildCount;
        for (var x = 0; x < menuItemCount; ++x)
        {
            var menuItem = dropdown.getContentChildAt(x);
            menuItem.setAttribute("hideSelected", (x != index) ? "true" : "false");
        }
    }
}

component.prototype.setParentBox = function(aBox)
{
    this._gadget.getPartById("dropDown").setParentsObject(aBox);
    this.clear();
}

component.prototype.getParentBox = function()
{
    return this._gadget.getPartById("dropDown").getParentsObject();
}

component.prototype.getMenuItemByIndex = function(idx)
{   
    var menuItem;
    var dropdown = this._gadget.getPartById("dropDown");
    var count = dropdown.contentChildCount
    if (idx > -1 && idx < count)
    {
        menuItem = dropdown.getContentChildAt(idx);
    }
    return menuItem;
}

component.prototype.appendMenuItem = function(text, iconSrc, context)
{
    var menuItem = this.scene.createBox("dropDownMenuItem");
    if (context)
    {
        menuItem.setAttribute("context", context);
    }
    if (iconSrc)
    {
        menuItem.setAttribute("imageSrc", iconSrc);
        menuItem.setAttribute("hideImage", "false");
    }
    if (text)
    {
        menuItem.setAttribute("value", text);
    }
    this._gadget.getPartById("dropDown").appendMenuItem(menuItem);
    return menuItem;
}

component.prototype.clear = function()
{
    this._gadget.getPartById("dropDown").deleteContentChildren();
}

component.prototype.closeDropdown = function()
{
    var targetBox = shell.currentEvent.targetBox;
    if (targetBox && targetBox.tag == this._gadget.tag)
    {
        this.closeDropdownHelper();
    }
}

component.prototype.closeDropdownHelper = function()
{
    if (!this._gadget.collapsed)
    {
        this._gadget.collapsed = true;
        var parentBox = this.getParentBox();
        if (parentBox)
        {
            parentBox.setAttribute("selected", "false");
            if (parentBox)
            {
                var event = shell.factory.createEvent(parentBox);
                if (event)
                {	    
                    event.type = "dropdownClosed";
                    parentBox.dispatchEvent(event);
                }
            }
        }
    }
}

component.prototype.dropDownCollapsed = function()
{
    var dropDown = this._gadget.getPartById("dropDown");
    if (dropDown.collapsed)
    {
        this.closeDropdownHelper();
        dropDown.collapsed = false;
    }
}


