// ****************************************************************************
//
// Copyright ?2008 AOL LLC  All rights reserved.
// This software contains valuable confidential and proprietary information
// of AOL LLC and is subject to applicable licensing agreements.
// Unauthorized reproduction, transmission or distribution of this file and
// its contents is a violation of applicable laws.
//
//           A O L  L L C   C O N F I D E N T I A L
//
// ****************************************************************************

function component(_gadget)
{
    this.lastTab;   
}

component.prototype.mouseUp = function()
{
    var targetBox = shell.currentEvent.targetBox;
    if (targetBox && targetBox.tag == "scrollButton")
    {   
        var tabPanels = this._gadget.getPartById("tabPanels");
        var index = parseInt(tabPanels.getAttribute("topIndex"));
        if (index > -1)
        {
            var tab = tabPanels.getChildAt(index);
            var contentBox = tab.getPartById("panelContainer")
            if (targetBox.id == "buttonDown")
            {
                tab.scrollDownHelper(contentBox);
            }
            else
            {
                tab.scrollUpHelper(contentBox);
            }
        }
    }
}

component.prototype.rewindFocus = function()
{
    var currentFocusedBox = this.scene.focusedBox;
    var tabPanels = this._gadget.getPartById("tabPanels");
    var selectedTab;
    var index = parseInt(tabPanels.getAttribute("topIndex"));
    if (index > -1)
    {
        selectedTab = tabPanels.getChildAt(index);
    }

    if(selectedTab.id == "main")
    {
        if(currentFocusedBox != this.findFirstFocusableBox(selectedTab.firstContentChild))
        {    
            this.scene.rewindFocus();
            if (shell.currentEvent)
            {
                shell.currentEvent.stopPropagation();
            }
        }
    }
}

component.prototype.advanceFocus = function()
{
    var currentFocusedBox = this.scene.focusedBox;
    var tabPanels = this._gadget.getPartById("tabPanels");
    var selectedTab;
    var index = parseInt(tabPanels.getAttribute("topIndex"));
    if (index > -1)
    {
        selectedTab = tabPanels.getChildAt(index);
    }

    if(selectedTab.id == "main")
    {
        if(currentFocusedBox != this.findLastFocusableBox(selectedTab.firstContentChild))
        {
            this.scene.advanceFocus();
            if (shell.currentEvent)
            {
                shell.currentEvent.stopPropagation();
            }
        }
    }    
}

component.prototype.wrapFocus = function(forward)
{
    var gadget = this._gadget;
    var tabPanels = this._gadget.getPartById("tabPanels");
    var selectedTab;
    var index = parseInt(tabPanels.getAttribute("topIndex"));
    if (index > -1)
    {
        selectedTab = tabPanels.getChildAt(index);
    }
    
    if (selectedTab)
    {
        if (forward)
        {
            var box = this.findFirstFocusableBox(selectedTab.firstChild);
            if (box)
            {
                this.scene.focusedBox = box;
            }
        }
        else
        {
            var box = this.findLastFocusableBox(selectedTab.firstChild);
            if (box)
            {
                this.scene.focusedBox = box;
            }
        }
    }
}

//****************************************************************************

component.prototype.findFirstFocusableBox = function(child)
{
    while (child)
    {
        var focusMode = child.getAttribute("focusMode");
        if (focusMode == "normal")
        {
            return child;
        }
        
        if (!child.collapsed)
        {
            var child2 = child.firstChild;
            if (child2 && !child2.collapsed)
            {
                var found = this.findFirstFocusableBox(child2);
                if (found)
                    return found;
            }
        }
        
        child = child.nextSibling;
    }
}

//****************************************************************************

component.prototype.findLastFocusableBox = function(child)
{
    var lastBox = null;
    
    while (child)
    {
        var focusMode = child.getAttribute("focusMode");
        if (focusMode == "normal" && !child.disabled)
        {
            lastBox = child;
        }
        
        var child2 = child.firstChild;
        if (child2)
        {
            var found = this.findLastFocusableBox(child2);
            if (found)
            {
                lastBox = found;
            }
        }
        
        child = child.nextSibling;
    }
    
    return lastBox;
}

component.prototype.onShowTab = function()
{
    var label = shell.currentEvent.targetBox;
    var event = shell.currentEvent;
    if (event)
    {
        event.stopPropagation();
        event.preventDefault();
    }
    this.setTab(label.id);
}

component.prototype.setTab = function(tabName)
{
    var tabPanels = this._gadget.getPartById("tabPanels");
    var idx = 0;
    var focusedBox;
    //debugger;
    switch(tabName)
    {
        case "main":
        {
            idx = 0;
            focusedBox = this._gadget.getPartById(this.lastTab);
            break;
        }
        case "general":
        {
            idx = 1;
            focusedBox = this._gadget.getPartById("general_q1");
            break;
        }
        case "ims":
        {
            idx = 2;
            focusedBox = this._gadget.getPartById("ims_q1");
            break;
        }
        case "status":
        {
            idx = 3;
            focusedBox = this._gadget.getPartById("status_q1");
            break;
        }
        case "manage":
        {
            idx = 4;
            focusedBox = this._gadget.getPartById("manage_q1");
            break;
        }
        case "connection":
        {
            idx = 5;
            focusedBox = this._gadget.getPartById("connection_q1");
            break;
        }
        case "feedback":
        {
            idx = 6;
            focusedBox = this._gadget.getPartById("feedback_q1");
            break;
        }
        case "about":
        {
            idx = 7;
            focusedBox = this._gadget.getPartById("tosLink");
            break;
        }
    }
    
    tabPanels.setAttribute("topIndex", idx.toString());
    this.scene.focusedBox = focusedBox;
    
    var softKeyMenu = this._gadget.getPartById("leftSoftKeyMenu");
    softKeyMenu.setAttribute("commandId", (idx == 0) ? "IDM_HELP_BACK" : "IDM_HELP_CANCEL");

    if (idx != 0)
    {
        this.lastTab = tabName;
    }
    propagateEventForBox(this._gadget, "menuChanged"); // update the menu
    
    try
    {
        shell.app.overrideBackButton(this.scene.rootBox.windowHandle, true);
    }
    catch(e){}
}

component.prototype.goBack = function()
{
    var contentContainer = this.scene.getBoxById("contentContainer");
    var help = this.scene.getBoxById("help");
    help.getPartById("rightSoftKeyMenu").closeMenu();
    contentContainer.showPanelByAttribute(help.previousPanel);
    this.scene.focusedBox = help.savedFocusedBox;
    help.previousPanel = null;
    help.savedFocusedBox = null;
}

component.prototype.showHelpPage = function()
{
    if (!this._gadget.collapsed)
    {
        this.lastTab = "general";
        this.setTab("main");
    }
}

component.prototype.cancel = function()
{
    this.setTab("main");
}
component.prototype.toggle = function()
{
    var targetBox = shell.currentEvent.targetBox;
    if (!targetBox.toggled)
    {
        targetBox.toggled = true;
    }
}

component.prototype.focusOnTeamSpinBox = function()
{   
    this.scene.focusedBox = this._gadget.getPartById("teamSpinBox");
}

component.prototype.focusOnTOSLink = function()
{
    this.scene.focusedBox = this._gadget.getPartById("tosLink");
}






