// ****************************************************************************
//
// Copyright ?2008 AOL LLC  All rights reserved.
// This software contains valuable confidential and proprietary information
// of AOL LLC and is subject to applicable licensing agreements.
// Unauthorized reproduction, transmission or distribution of this file and
// its contents is a violation of applicable laws.
//
//           A O L  L L C   C O N F I D E N T I A L
//
// ****************************************************************************
//  imageAd.js
//
//****************************************************************************

function rsc_TSMimageAd(context)
{
    if (context)
    {
        context.rsc_TSMretrieveAd();
    }
}

function component(_gadget)
{
    try 
    {
        this.userAgent = shell.app.userAgent;
    } 
    catch (e) 
    {
        this.userAgent = "mobileAIM";
    }

    try
    {
        this.deviceId = encodeURIComponent(shell.device.manufacturer + "|" + shell.device.model);
    }
    catch(e)
    {
        this.deviceId = "mobileAIM";
    }
    
    this.AdTextRegex = new RegExp();
    this.AdTextRegex.compile("\">([^&]+)\<");

}

component.prototype.displayImageAd = function(inSrc, inLink)
{
    if (inSrc)
    {
        var ad1 = this._gadget.getPartById("ad1");
        var newAdBox = (ad1.hidden) ? ad1 : this._gadget.getPartById("ad2");
        
        newAdBox.setAttribute("link", inLink);
        if (newAdBox.getAttribute("src") == inSrc)
        {
            this.onUrlLoadComplete();
        }
        else
        {
            newAdBox.setAttribute("src", inSrc);
        }
    }
}

component.prototype.displayTextAd = function(inText, inLink, currentType)
{
    if (inText)
    {
        var adText = this._gadget.getPartById("adText");
        adText.setAttribute("value", inText);
        if (currentType != "adText")
        {
            adText.collapsed = false;
            
            var ad1 = this._gadget.getPartById("ad1");
            ad1.hidden = true;
            ad1.setAttribute("src", "");
            
            var ad2 = this._gadget.getPartById("ad2");
            ad2.hidden = true;
            ad2.setAttribute("src", "");
            
            this._gadget.setAttribute("currentSource", "adText");
        }
        this._gadget.setAttribute("link", inLink);
    }
}

component.prototype.onUrlLoadComplete = function()
{
    var ad1 = this._gadget.getPartById("ad1");
    var ad2 = this._gadget.getPartById("ad2");
    var newAdBox;
    var oldAdBox;
    if (ad1.hidden)
    {
        newAdBox = ad1;
        oldAdBox = ad2;
    }
    else
    {
        newAdBox = ad2;
        oldAdBox = ad1;
    }
    
    newAdBox.hidden = false;
    oldAdBox.hidden = true; 

    if (this._gadget.getAttribute("currentSource") == "adText")
    {
        this._gadget.getPartById("adText").collapsed = true;
    }
    this._gadget.setAttribute("currentSource", newAdBox.getAttribute("src"));
    this._gadget.setAttribute("link", newAdBox.getAttribute("link"));
}

component.prototype.requestStates = {
    uninitialized : 0,
    open : 1,
    sent : 2,
    receiving : 3,
    loaded : 4
}

/*** TSM Advert  code ***/
component.prototype.TSMparseXhtmlAd = function(inDocumentElement)
{   
    var hasAd = false;
    try
    {
        var root = inDocumentElement.getElementsByTagName("markup-content");
        var adContent = (root) ? root.item(0) : null;
        if (adContent)
        {
            var adResponse = adContent.text;
            var src = parseStringFromText(adResponse, "\"", "\"", adResponse.indexOf("src"));
            var href = parseStringFromText(adResponse, "\"", "\"", adResponse.indexOf("href"));
            
            //make sure it's a safe url
            src = removeInjections(src);
            href = removeInjections(href);
            
            if (href)
            {   
                var text = "";
                // AdMob ads
                if (!src)
                {
                    var textRE = this.AdTextRegex.exec(adContent.text);
                    if (textRE && textRE[1])
                    {
                        text = textRE[1].replace(/(\s*$)/g, "");
                    }
                }
                
                if (src || text) 
                {
                    var currentSource = this._gadget.getAttribute("currentSource");
                    if (text)
                    {
                        text = "Ad: " + text;
                        this._gadget.displayTextAd(text, href, currentSource);
                    }
                    else
                    {
                        if (src != currentSource)
                        {
                            this._gadget.displayImageAd(src, href);
                        }
                        else
                        {
                            var ad1 = this._gadget.getPartById("ad1");
                            var currAdBox = (ad1.hidden) ? this._gadget.getPartById("ad2") : ad1;
                            currAdBox.setAttribute("link", href);
                        }
                    }
                    hasAd = true;
                }
            }
        }
    }
    catch(e) {}
    if (!hasAd)
    {
        this._gadget.setAttribute("currentSource", "");
        this._gadget.setAttribute("link", "");
        this._gadget.getPartById("adText").collapsed = true;
        this._gadget.getPartById("ad1").hidden = true;
        this._gadget.getPartById("ad2").hidden = true;
    }
}

component.prototype.TSMretrieveAd = function()
{
    if (!this.request)
    {
        var vars = "";
        vars += "contid=" + this._gadget.getAttribute("TSMadspaceid");
        vars += "&pubid=" + this._gadget.getAttribute("TSMpublisherid");
        vars += "&format=xhtml";
        vars += "&dev-id=" + this.deviceId;
        var adSize = this._gadget.getAttribute("TSMadsize");
        if (adSize)
            vars += "&tsm-sz=" + adSize;

        vars += "&am-tk=" + this.scene.prefObj.appGUID;

        var requestURL = "http://ad.m-adx.com/api/?" + vars;
        this.request = new XMLHttpRequest();
        var self = this;
        
        this.request.open("POST", requestURL);
        this.request.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
        this.request.onreadystatechange = function() { rsc_TSMimageAd(self) }
        this.request.send(null);
    }
}


component.prototype.rsc_TSMretrieveAd = function()
{
    if (this.request && this.request.readyState == this.requestStates.loaded && this.request.status == 200)
    {
        var responseXML = this.request.responseXML;
        var documentElement = responseXML ? responseXML.documentElement : null;;
        if (documentElement)
        {
            try
            {
                this._gadget.TSMparseXhtmlAd(documentElement);
            }
            catch(e){}
        }
        else
        {
            //this._gadget.collapsed = true;
        }
        this.request = null;
    }
}

component.prototype.linkClicked = function()
{
    var link = makeSafeUrl(this.getLink());
    if (link)
    {
        try 
        {
            appUtils.shellExecute(link);
        }
        catch(e){}
    }
}

component.prototype.getLink = function()
{
    var link = this._gadget.getAttribute("link");
    return link ? link : "http://wap.aol.com/portal/menu.do?id=5705";
}


component.prototype.respectUIScaleChanged = function()
{
    if (this._gadget.getAttribute("respectUIScale") == "true")
    {
        this._gadget.setStyle("width", this._gadget.width + "*");
        this._gadget.setStyle("height", this._gadget.height + "*");
    }
}
