﻿// ****************************************************************************
//
// Copyright © 2008 AOL LLC  All rights reserved.
// This software contains valuable confidential and proprietary information
// of AOL LLC and is subject to applicable licensing agreements.
// Unauthorized reproduction, transmission or distribution of this file and
// its contents is a violation of applicable laws.
//
//           A O L  L L C   C O N F I D E N T I A L
//
// ****************************************************************************
//
//  mailChecker
//
//////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////////
mailChecker.prototype.mailCheckInterval = 300000;
mailChecker.prototype.mailCheckTimer = null;
mailChecker.prototype.xmlhttp = null;

function mailChecker()
{
}

mailChecker.prototype.cancelCheckMailTimer = function()
{
    if (this.mailCheckTimer != null)
    {
        this.mailCheckTimer.cancel();
        this.mailCheckTimer = null;
    }
}

mailChecker.prototype.checkMail = function()
{
    this.release();

    try 
    {
        this.xmlhttp = null;
        this.xmlhttp = new XMLHttpRequest();
    }
    catch(e){}
    
    var token = scene.AIMobj.getToken();
    var devId = shell.app.devKey;
    var sessionKey = scene.AIMobj.getSessionKey();
    if (sessionKey && token && devId)
    {
        var self = this;
        var now = new Date();
        var queryString = "";
        this.xmlhttp = null;
        
        // Set up params in alphabetical order
        queryString += "a=" + encodeStrPart(token);
        queryString += "&devId=" + encodeStrPart(devId);
        queryString += "&f=json";
        queryString += "&r=" + now.getTime();

        var requestURL = "http://api.mail.aol.com/mail/newMailCount";
        var sigBase = "GET&"+encodeStrPart(requestURL)+"&"+escape(queryString);
        var sigData = shell.crypto.hmacSHA256Encode(sessionKey, sigBase);
        queryString += "&sig_sha256="+encodeURIComponent(sigData);
        this.xmlhttp = new XMLHttpRequest();
        this.xmlhttp.open("GET", requestURL+"?"+queryString);
        this.xmlhttp.setRequestHeader("User-Agent", this.userAgent);
        this.xmlhttp.setRequestHeader("Cache-Control", "no-store,no-cache");
        this.xmlhttp.onreadystatechange = function () { mailChecker_rsc_global(self) };
        this.xmlhttp.send("");
    }
}

function mailChecker_rsc_global(context)
{
    if (context)
    {
        context.onReadyStateChange();
    }
}

mailChecker.prototype.onReadyStateChange = function() 
{
    if (this.xmlhttp && this.xmlhttp.readyState==4) 
    {
        if (this.xmlhttp.status == 200)
        {            
            var json = eval( '(' + this.xmlhttp.responseText + ')' );
            var response = json ? json.response : null;
            if (response)
            {
                try
                {
                    var count = response.data.mailFolderCount.mailFolderData.mailFolderType[0].count;
                    if (count > -1)
                    {
                        scene.getBoxById("buddyList").updateMailCount(count);
                        this.mailCheckTimer = setTimeoutObject(this, "checkMail", this.mailCheckInterval);
                    }
                }
                catch(e){}
            }
        }
    }
}
mailChecker.prototype.release = function()
{
    if (this.xmlhttp)
    {
        this.xmlhttp = null;
    }
    this.cancelCheckMailTimer();
}
