// ****************************************************************************
//
// Copyright ?2008 AOL LLC  All rights reserved.
// This software contains valuable confidential and proprietary information
// of AOL LLC and is subject to applicable licensing agreements.
// Unauthorized reproduction, transmission or distribution of this file and
// its contents is a violation of applicable laws.
//
//           A O L  L L C   C O N F I D E N T I A L
//
// ****************************************************************************

var AIMobj = null;
var gAimOnline = false;

var prefObj = null;
var updateObj = null;
var mailObj = null;

var panelAttribute_buddyList = "show_buddyList";
var panelAttribute_chatPanel = "show_chatPanel";
var panelAttribute_authPanelBox = "show_authPanelBox";
var panelAttribute_settings = "show_settings";
var panelAttribute_help = "show_help";
var panelAttribute_profile = "show_profile";
function onInitialized()
{
   scene.rootBox.active = true;
   // Display offline icon
    try
    {
        shell.app.appIcon = 1;
    }
    catch (e){}

    var obj = new objBuddyList;
    scene.addDOMObject("_buddyListObj", obj); // add the buddy list object to the scene so we can access it from script
    scene.addDOMObject("_buddyListDataSrc", obj.groups); // add an object we can collection bind to
    if (shell.uiScale >= 200)
    {
        scene.getBoxById("loginStatusBox").setAttribute("iconSrc", "#login.animation");
        scene.rootBox.setAttribute("respectUIScale", "true");
    }
    else if (shell.uiScale > 130 && shell.uiScale < 140)
    {
        scene.getBoxById("authPanelBox").setAttribute("respectUIScale133", "true");
    }
    // for desktop testing...
    // scene.rootBox.setAttribute("respectUIScale", "true");
    // shell.uiScale = 200;
}

function onActivated()
{
    if (mailObj)
    {
        scene.mailObj.checkMail();
    }
}

function onDeactivated()
{
    if (mailObj)
    {
        scene.mailObj.release();
    }
}

function loadPref()
{
    var kvs = new keyValueStorage();
    var storeName = scene.prefObj.prefsGetGlobalStore()
    kvs.open( storeName );
    
    var enableAllTransitions = kvs.getValue(scene.prefObj.enableAllTransitionsKey, scene.prefObj.enableAllTransitions);
    scene.prefObj.enableAllTransitions = (enableAllTransitions && enableAllTransitions.toString() == "true") ? true : false; 

    var enableCarouselTransitions = kvs.getValue(scene.prefObj.enableCarouselTransitionsKey, scene.prefObj.enableCarouselTransitions);
    scene.prefObj.enableCarouselTransitions = (enableCarouselTransitions && enableCarouselTransitions.toString() == "true") ? true : false; 

    kvs.close();
}

function onPresented()
{
    // Set the titlebar text
    try {
        scene.rootBox.title = shell.app.productName;
    } catch (e) {
    }

    prefObj = new Preferences();
    scene.addDOMObject("prefObj", prefObj);
   
    loadPref();
    
    updateObj = new updateChecker();
    scene.addDOMObject("updateObj", updateObj);
    
    setTimeoutObject(scene.updateObj, "doUpdateCheck", 120000);  //check for updates 2 mins after launch

    var hasCriticalUpdate = false;
       
    hasCriticalUpdate = scene.updateObj.isCriticalUpdateAvailable();
    //shell.app.debugLog("hasCriticalUpdates = " + hasCriticalUpdate);

    if (!hasCriticalUpdate)
    {        
        var contentContainer = scene.getBoxById("contentContainer");
        contentContainer.addPanelAttributes(panelAttribute_buddyList);
        contentContainer.addPanelAttributes(panelAttribute_chatPanel);
        contentContainer.addPanelAttributes(panelAttribute_authPanelBox);
        contentContainer.addPanelAttributes(panelAttribute_settings);
        contentContainer.addPanelAttributes(panelAttribute_help);
        contentContainer.addPanelAttributes(panelAttribute_profile);

        AIMobj = new AIM();
        AIMobj.init(gAimCallbacks);
        scene.addDOMObject("AIMobj", AIMobj);
        scene.getBoxById("help").setAttribute("version", shell.app.version);
        
        var box = scene.getBoxById("contentBox");
        //takeSnapshot(box);
        contentContainer.showPanelByAttribute(panelAttribute_authPanelBox);
        try
        {
            //need to move this to loadPref later on
            var kvs = new keyValueStorage();
            var storeName = scene.prefObj.prefsGetGlobalStore();
            kvs.open( storeName );
            var tosAccepted = kvs.getValue("TOSAccepted", "");
            if (!tosAccepted)
            {
                var TOSDialog = scene.createBox("TOSDialog");
                UpdateSoftkeyMenu(TOSDialog);
                TOSDialog.id = "tosDialog";
                contentContainer.addChild(TOSDialog);
                scene.focusedBox = TOSDialog.getPartById("title");
            }
            
            scene.prefObj.appGUID = kvs.getValue("AIMAppGUID", "");            
            if (!scene.prefObj.appGUID)
            {
                var date = new Date();
                scene.prefObj.appGUID = (Math.ceil(Math.random() * 10000) + 10000000).toString() + date.getTime();
                kvs.setValue("AIMAppGUID", scene.prefObj.appGUID);
            }
            kvs.close();
            kvs = null;
        }
        catch(e)
        {
        }
        //doTransition(box, "blur", 800);
    }
    else
    {
        notifyCriticalUpdate();
    }
    
    var adControllerObj = new adController();
    scene.addDOMObject("adControllerObj", adControllerObj);
}

function cleanUpApp()
{
    if(AIMobj)
    {
        if (gAimOnline)
        {
            AIMobj.signOff();
        }    
        AIMobj.release();
        AIMobj = null;
    }
    
    if(updateObj)
    {
        updateObj.release();
        updateObj = null;
    }
    if (mailObj)
    {
        mailObj.release();
        mailObj = null;
    }
}

function onExit()
{
    var authPanel = scene.getBoxById("authPanelBox");
    authPanel.saveToStorage();

    cleanUpApp();
    gAimOnline = false;
    scene.removeDOMObject("_buddyListObj");
    scene.removeDOMObject("_buddyListDataSrc");
    scene.removeDOMObject("prefObj");
    scene.removeDOMObject("updateObj");
    scene.removeDOMObject("mailObj");
    scene.removeDOMObject("AIMobj");
    scene.removeDOMObject("adControllerObj");
    scene.removeDOMObject("_searchListObj");
}

function onAuthSignOn()
{
    var event = shell.currentEvent;
    if (event)
    {
        if (AIMobj && !gAimOnline)
        {
            // Make sure we're connected on mobile
            try
            {
                shell.device.ensureDataConnection();
            }
            catch(err)
            {
            }
            var screenName = event.screenname;
            screenName = screenName.toLowerCase();
            screenName = screenName.replace(/[ \t]*/ig,"");
            AIMobj.setSignInPresence(event.presence);
            AIMobj.signOn(screenName, event.password);
        }
    }
}

function authSignedOn(myInfo)
{
    scene.getBoxById("authPanelBox").setShowSigninErrorLabel(false);

    var buddyList = scene.getBoxById("buddyList");
    buddyList.signedIn(myInfo);
}

function onAuthSubmitPasscode()
{
    var event = shell.currentEvent;
    if (event && AIMobj)
    {
        AIMobj.setSecurID(event.passcode);
    }
}

function onAuthSubmitCaptcha()
{
    var event = shell.currentEvent;
    if (event && AIMobj)
    {
        AIMobj.setCaptcha(event.captcha);
    }
}

function onShowAuthenticationPanel()
{
    var contentContainer = scene.getBoxById("contentContainer");
    if (contentContainer.getAttribute(panelAttribute_authPanelBox) == "true")
    {
        scene.getBoxById("notificationBox").hide();
        scene.getBoxById("authPanelBox").authSignOnCancel();
    }
}

function signOff(signOff)
{
    if (signOff)
    {
        if(AIMobj)
        {
            AIMobj.signOff();
        }

        gAimOnline = false;

        var contentContainer = scene.getBoxById("contentContainer");
        if (contentContainer.getAttribute(panelAttribute_authPanelBox) == "false")
        {
            var showTransition= scene.prefObj.enableAllTransitions;
            if (showTransition)
            {
                scene.getBoxById("activeConversationBar").removeAllBuddies();
                takeSnapshot(contentContainer);
            }
            contentContainer.showPanelByAttribute(panelAttribute_authPanelBox);
            if (showTransition)
            {
                doTransition(contentContainer, "zoomOut", 300, true, "accelerate");
            }
        }

        // remove all the buddies
        scene.getBoxById("buddyList").clearAll();
        if (scene._buddyListObj) scene._buddyListObj.clear();
        
        //for performance, we should clear the carousel after signing out if we are not doing transition
        if (!showTransition) scene.getBoxById("activeConversationBar").removeAllBuddies();
        scene.getBoxById("chatPanel").cleanAll();
        contentContainer.setAttribute("reconnecting", "false");
    }
}

function securityIdChanllege()
{
    scene.getBoxById("authPanelBox").showPasscodeScreen();
}

function captchaChallenge(inStr, inURL)
{
    scene.getBoxById("authPanelBox").showCaptchaScreen(inStr, inURL);
}

function loginStatusMessage(aStatus)
{       
    scene.getBoxById("authPanelBox").updateLoginStatus(aStatus);
}

function loginError(message)
{
    var authPanel = scene.getBoxById("authPanelBox");
    authPanel.onLoginError(message);
    signOff(true);
}

function onBuddyClicked()
{
    var event = shell.currentEvent;
    var targetBox = (event) ? event.targetBox : null;
    if (targetBox && targetBox.tag == "buddyListBuddy")
    {
        var chatPanel = scene.getBoxById("chatPanel");
        var context = new Object();
        context.aimId = targetBox.id;
        context.displayId = targetBox.getAttribute("buddyDisplayId");
        context.buddyIcon = targetBox.getAttribute("buddyIcon");
        context.statusMsg = targetBox.getAttribute("buddyStatus");
        context.state = targetBox.getAttribute("buddyState");
        chatPanel.startConversation(context, true);
        if (event)
        {
            event.preventDefault();
        }
    }
}

function onConversationBack()
{
    var contentContainer = scene.getBoxById("contentContainer");
    if (contentContainer.getAttribute(panelAttribute_buddyList) == "false")
    {
        var showTransition = scene.prefObj.enableAllTransitions;
        if (showTransition)
        {
            takeSnapshot(contentContainer);
        }
        contentContainer.showPanelByAttribute(panelAttribute_buddyList);
        if (showTransition)
        {        
            doTransition(contentContainer, "pushRight", 400);
        }
    }
    var carousel = scene.getBoxById("activeConversationBar");
    if (carousel.contentChildCount > 0)
    {
        carousel.setVisible(true);   
        carousel.deactivateAllIcons();
    }
}

function onShowConversationWindow()
{
    var contentContainer = scene.getBoxById("contentContainer");
    if (contentContainer.getAttribute(panelAttribute_buddyList) == "true") // only if we are currently showing the buddy list
    {
        var showTransition = scene.prefObj.enableAllTransitions;
        if (showTransition)
        {
	        takeSnapshot(contentContainer);
	    }
        contentContainer.showPanelByAttribute(panelAttribute_chatPanel);
        if (showTransition)
        {
            doTransition(contentContainer, "pushLeft", 400);
        }
    }
}

function onSendIM()
{
    var event = shell.currentEvent;
    if (event && AIMobj && AIMobj.isOnline())
    {
        // Send it to our buddy
        var screenName = event.screenName;
        AIMobj.sendIMToBuddy(event.message, screenName);
        
        var noSeeRecentBuddies = false;
        try 
        {
            //first see if user wants to be notified of normal updates...check preference setting
            var kvs = new keyValueStorage();
            var storeName = scene.prefObj.prefsGetStoreForCurrentIdentity();
            kvs.open( storeName );
            noSeeRecentBuddies = kvs.getValue(scene.prefObj.noSeeRecentBuddiesKey, scene.prefObj.noSeeRecentBuddiesDefaultValue);
            kvs.close();
            kvs = null;
        } catch(e) {}

        if (noSeeRecentBuddies.toString() == "false" && !scene._buddyListObj.getBuddyInfo(screenName) && screenName != "aolsystemmsg")
        {
            scene._buddyListObj.addBuddy(screenName, "Recent Buddies", false);
            scene.AIMobj.addTempBuddy(screenName);
            scene.AIMobj.getPresenceInfo(screenName);
        }
    }
}

function onResized()
{
    var activeConversationBar = scene.getBoxById("activeConversationBar");
    activeConversationBar.onResized();
    
    // Check the SIP and close the menu if the SIP is open
    try
    {
        if (shell.device.sip)
        {
            CloseOpenMenu();
        }
    }
    catch(e) {}
    
}

function onPanelChanging()
{
    scene.getBoxById("globalDropDown").closeDropdownHelper();
    
    var object;
    var contentContainer = scene.getBoxById("contentContainer");
    if (contentContainer.getAttribute(panelAttribute_chatPanel) == "true")
    {
        scene.getBoxById("smileyPalette").setVisible(false);
        var chatPanel = scene.getBoxById("chatPanel").setHideReconnectPopup();
        object = scene.getBoxById("chatPanel");
    }
    if (object)
    {
        object.getPartById("rightSoftKeyMenu").closeMenu();
    }
}

function onPanelChanged()
{   
    onMenuChanged();
    updateFocus();
    var contentContainer = scene.getBoxById("contentContainer");
    
    var showCarouselTransition = false;
    if (contentContainer.getAttribute(panelAttribute_buddyList) == "true")
    {
        // Refresh buddylist ad
        var buddyListAdBox = scene.getBoxById("buddyListAdBox");
        if (buddyListAdBox)
        {
            buddyListAdBox.TSMretrieveAd();
        }
        scene.getBoxById("buddyList").cancelSearch();
        showCarouselTransition = true;
    }
    else if (contentContainer.getAttribute(panelAttribute_chatPanel) == "true")
    {
        showCarouselTransition = true;
    }    
    
    scene.getBoxById("activeConversationBar").setShowTransition(showCarouselTransition);
}

function onUnknownDialogBoxShown()
{
    var rootBox = scene.rootBox;
    OverrideSoftkeyMenus(scene, rootBox.getAttribute("unknownUser.viewIM"), "IDM_CONV_UNKNOWN_VIEW", rootBox.getAttribute("unknownUser.closeIM"), "IDM_CONV_UNKNOWN_CLOSE");
}

function onMenuChanged()
{
    var object = null;

    var tosDialog = scene.getBoxById("tosDialog");
    if (tosDialog)
    {
        object = tosDialog;
    }
    else
    {
        var contentContainer = scene.getBoxById("contentContainer");
        if (contentContainer.getAttribute(panelAttribute_authPanelBox) == "true")
        {
            var authPanelBox = scene.getBoxById("authPanelBox");
            if (scene.getBoxById("loginStatusBox").collapsed)
            {
                object = authPanelBox;
            }
        }
        else if (contentContainer.getAttribute(panelAttribute_buddyList) == "true")
        {
            object = scene.getBoxById("buddyList");
            // Set the "navRight" attribute on the carousel to focus on the buddyList
            var carouselNavRight = scene.getBoxById("buddyList").getAttribute("searching") == "false" ? "buddyList.buddyListGrid" : "buddyList.searchResultGrid";
            scene.getBoxById("activeConversationBar").setAttribute("navRight", carouselNavRight);
            
            var buddyList = scene.getBoxById("buddyList");
            scene.focusedBox = (buddyList.getAttribute("searching") == "false") ? buddyList.getPartById("buddyListGrid") : buddyList.getPartById("searchResultGrid");
        }
        else if (contentContainer.getAttribute(panelAttribute_chatPanel) == "true")
        {
            object = scene.getBoxById("chatPanel");
            // Set the "navRight" attribute on the carousel to focus on the text input box
            scene.getBoxById("activeConversationBar").setAttribute("navRight", "chatPanel");
            var focusedBox = scene.focusedBox;
            if (!focusedBox || (focusedBox.gadgetParent && focusedBox.gadgetParent.tag == "alertBox"))
            {
                var currentConversation = object.getCurrConversation();
                if (currentConversation)
                {
                    currentConversation.setComposeInputFocus();
                }
            }
        }
        else if (contentContainer.getAttribute(panelAttribute_profile) == "true")
        {
            object = scene.getBoxById("profileBox");
        }
        else if (contentContainer.getAttribute(panelAttribute_settings) == "true")
        {
            object = scene.getBoxById("settings");
        }
        else if (contentContainer.getAttribute(panelAttribute_help) == "true")
        {
            object = scene.getBoxById("help");
        }
        
    }
    if (object)
    {
        UpdateSoftkeyMenu(object);
    }
}

function updateFocus()
{
    var contentContainer = scene.getBoxById("contentContainer");
    if (contentContainer.getAttribute(panelAttribute_buddyList) == "true")
    {
        scene.focusedBox = scene.getBoxById("buddyList").getPartById("buddyListGrid");
    }
    else if (contentContainer.getAttribute(panelAttribute_profile) == "true")
    {
        scene.focusedBox = scene.getBoxById("profileBox").getPartById("buddyInfoContainer");
    }
}

/*
    Navigates to the next focusable box specified using the "navUp" attribute on the box.
    The attribute should specify the 'id' of the box focus on.
    To specify a part of a gadget to focus on, use the 'box_id.part_id' notation.
*/
function navUp()
{
    navDirection("navUp");
}

function navDown()
{
    navDirection("navDown");
}

function navLeft()
{
    navDirection("navLeft");
}

function navRight()
{
    navDirection("navRight");
}

function navDirection(navDir)
{
    var e = shell.currentEvent;
    var box = e.currentBox;
    var navStr = box.getAttribute(navDir);

    if (navStr)
    {
        var navBox = navStr;
        var navPart = "";
        if (navStr.search("[.]"))
        {
            var navSplit = navStr.split(".");
            navBox  = navSplit[0];
            navPart = navSplit[1];
        }

        e.stopPropagation();

        var nextBoxRef = scene.getBoxById(navBox);
        if (nextBoxRef && nextBoxRef.collapsed == false && nextBoxRef.hidden == false)
        {
            if (navPart)
            {
                nextBoxRef = nextBoxRef.getPartById(navPart);
            }
            if (nextBoxRef && nextBoxRef.collapsed == false && nextBoxRef.hidden == false)
            {
                scene.focusedBox = nextBoxRef;
            }
        }
    }
}

function updateNotificationBoxEvent()
{
    var currentEvent = shell.currentEvent;
    if (currentEvent)
    {
        updateNotificationBox(currentEvent.icon, currentEvent.message, currentEvent.timeToDisplay); 
    }
}

function updateNotificationBox(icon, message, timeToDisplayMilliseconds)
{
    var notificationBox = scene.getBoxById("notificationBox");
    if (notificationBox.getAttribute("title") != message)
    {
        notificationBox.setAttribute("title", message);
    }
    if (notificationBox.getAttribute("icon") != icon)
    {
        notificationBox.setAttribute("icon", icon);
    }

    if (message)
    {
        notificationBox.show(timeToDisplayMilliseconds);
    }
    else
    {
        notificationBox.hide();
    }
}

function onReconnectAlertResult()
{
    var rootBox = scene.rootBox;
    var updateSoftkey;
    if (shell.currentEvent && shell.currentEvent.reconnect)
    {
        // Attempt another reconnect "batch"
        if (this.scene.AIMobj.getContinueOffline())
        {
            this.scene.AIMobj.setContinueOffline(false);
            updateSoftkey = true;
        }
        this.scene.AIMobj.finishReconnect(false);
        updateNotificationBox("#reconnect.pending", rootBox.getAttribute("reconnect.reconnecting"));
        this.scene.AIMobj.startReconnect(460);
    }
    else
    {
        // Give up and go offline
        this.scene.AIMobj.setContinueOffline(true);
        updateNotificationBox(null, rootBox.getAttribute("reconnect.connectionLost")); 
        updateSoftkey = true;
    }
    
    if (updateSoftkey)
    {
        var chatPanel = scene.getBoxById("chatPanel");
        var buddyList = scene.getBoxById("buddyList");
        chatPanel.updateSoftKey(true);
        buddyList.updateSoftKey();
    }
}

function TOSAccepted()
{
    try
    {
        var kvs = new keyValueStorage();
        var storeName = scene.prefObj.prefsGetGlobalStore();
        kvs.open( storeName );
        kvs.setValue("TOSAccepted", "true");
        kvs.close();
        kvs = null;

        var contentContainer = scene.getBoxById("contentContainer");
        var TOSDialog = scene.getBoxById("tosDialog");
        contentContainer.deleteChild(TOSDialog);
        var authPanel = scene.getBoxById("authPanelBox");
        UpdateSoftkeyMenu(authPanel);
        authPanel.setScreenNameFocused();
    }
    catch(e)
    {
    }
}

// ----------------------------------------------------------------------------
// Element binding source transformers

function transformBuddyStateToCollapsed()
{
    var value = shell.currentData;
    return (value && (value != "offline")) ? "false" : "true";
}

function transformPendingActionToString()
{
    var string = "";

    var value = shell.currentData;
    if (value && value != "")
    {
        var rootBox = scene.rootBox;
        switch (parseInt(value))
        {
            case 1:
                string = rootBox.getAttribute("bl.pendingAction.adding");
                break;
            case 2:
                string = rootBox.getAttribute("bl.pendingAction.deleting");
                break;
            case 3:
                string = rootBox.getAttribute("bl.pendingAction.renaming");
                break;
        }
    }
    
    return string;
}

function transformPendingActionToCollapsed()
{
    var value = shell.currentData;
    return (value && (value != "0")) ? "false" : "true";
}

function linkClicked()
{
    var targetBox = shell.currentEvent.targetBox;
    try
    {
        appUtils.shellExecute(targetBox.getAttribute("link"));
    }
    catch(e){}
}

function toggleAddBuddyDropDown()
{
    var addBuddyDropDown = scene.getBoxById("addBudddyDropDown");
    if (addBuddyDropDown)
    {
        if (addBuddyDropDown.collapsed)
        {
            addBuddyDropDown.collapsed = false;
            var parentBox = addBuddyDropDown.getParentsObject();
            if (parentBox)
            {
                // -2 here to make the menu drop down fit in better with the button, need boxely menu popup support here
                addBuddyDropDown.width = parentBox.boxWidth - 2;
                addBuddyDropDown.left = parentBox.frameX;
                addBuddyDropDown.top = parentBox.frameY + parentBox.boxHeight;
                scene.focusedBox = addBuddyDropDown.getPartById("dropDownContainer");
            }
        }
        else
        {
            addBuddyDropDown.close();
        }
    }
    if (shell.currentEvent)
    {
        shell.currentEvent.stopPropagation();
    }
}

function unknownUserAction()
{
    var event = shell.currentEvent;
    var targetBox = event ? event.targetBox : null;
    if (targetBox)
    {
        scene.getBoxById("chatPanel").unknownUserAction(targetBox.getAttribute("value"));
    }
}
// ----------------------------------------------------------------------------=======

function onBlockUnblockBuddy()
{
    var buddyId = null;
    var event = shell.currentEvent;
    if(event)
    {
        buddyId = event.buddyId;
        if( this.scene.AIMobj.screenName != buddyId)
        {
            var param = "";
            var buddyInfo = scene._buddyListObj.getBuddyInfo( buddyId );
            if(buddyInfo)
            {
                param = "pdBlock";
                if (buddyInfo.state == "blocked")
                {
                    param = "pdBlockRemove";
                }
                else if (buddyInfo.state != "offline")
                {
                    buddyInfo.state = "offline";
                    scene._buddyListObj.updateBuddiesFromObj(buddyInfo);
                    scene.getBoxById("buddyList").notifyAlert(buddyId, "offline");
                }
            }
            if (!param)
            {        
                var conversation = scene.getBoxById("chatPanel").findConversation(buddyId);
                if(conversation)
                {
                    param = conversation.getAttribute("presenceState") == "blocked" ? "pdBlockRemove" : "pdBlock";
                }
            }
            if (param)
            {
                var isMobile = buddyId.indexOf("+") > -1;
                if (isMobile && param == "pdBlockRemove") 
                {
                    // since mobile won't get presence event, need to update mobile status here
                    scene.getBoxById("buddyList").notifyAlert(buddyId, "online");
                }
                this.scene.AIMobj.setPermitDeny(param, buddyId, event.displayMessage);
                if (param == "pdBlock" || isMobile)
                {
                    this.scene.AIMobj.getPresenceInfo(buddyId);
                }
            }
        }
        else
        {
            updateNotificationBox("", scene.rootBox.getAttribute("bl.message.blockSelf"), 2000);
        }
    }
}

function notifyCriticalUpdate()
{
    //critical update UI here....
    //shell.app.debugLog("inside notifyCriticalUpdate...");
    var criticalUpdateDialog = scene.createBox("criticalUpdateDialog");
    scene.rootBox.addChild(criticalUpdateDialog);
    
    var updateDescription = scene.updateObj.getDescription();
    if (updateDescription != "")
    {
        descriptionBox = criticalUpdateDialog.getPartById("description");
        labelText = descriptionBox.getAttribute("value");
        descriptionBox.setAttribute("value", updateDescription + "&lt;br&gt; &lt;br&gt;" + labelText);
    }
    
    scene.focusedBox = criticalUpdateDialog.getPartById("updateButton");
    OverrideSoftkeyMenus(scene, scene.rootBox.getAttribute("softwareUpdate.installNow"), "IDM_CRITICAL_UPDATE", scene.rootBox.getAttribute("aim.app.exitAIM"), "IDM_EXIT");
}

//display the carousel icon when update comes in
function notifyUpdateOnCarousel()
{
    var notifyUser = scene.prefObj.updateNotifyDefaultValue;
    try 
    {
        //first see if user wants to be notified of normal updates...check preference setting
        var kvs = new keyValueStorage();
        var storeName = scene.prefObj.prefsGetStoreForCurrentIdentity();
        kvs.open( storeName );
        var notifyUser = kvs.getValue(scene.prefObj.updateNotifyKey, scene.prefObj.updateNotifyDefaultValue);
        kvs.close();
        kvs = null;
    } catch(e) {}
    
    //shell.app.debugLog("inside notifyUpdateOnCarousel...");
    if (notifyUser.toString() == "true")
    {
        var context = new Object();
        context.aimId = "1_update";   //use number as first char and special char that shouldn't be in a screen name
        context.displayId = "Update";
        context.buddyIcon = "#softwareUpdateIcon";
        
        var newIcon = scene.getBoxById("activeConversationBar").addBuddy(context, true); //false here means wait until carousel is displayed
        if (newIcon)
        {
            newIcon.setAttribute("presenceState", "1_update");
        }
    }
}

//if the user clicks on the carousel icon, show the update dialog box
function softwareUpdateIconActivate()
{
    var rootBox = scene.rootBox;
    OverrideSoftkeyMenus(scene, rootBox.getAttribute("softwareUpdate.installNow"), "IDM_UPDATE", rootBox.getAttribute("softwareUpdate.RemindMe"), "IDM_UPDATE_REMINDME");
    var alertBox = scene.getBoxById("alertBox");
    
    //need to put this in content...
    alertBox.alert(rootBox.getAttribute("softwareUpdate.updateAvailable"), "alertContentSoftwareUpdate");
    
    /*
    var defaultDescriptionText = "New Version Available";
    var updateDescription = scene.updateObj.getDescription();
    if (updateDescription == "")
    {
        updateDescription = defaultDescriptionText;
    }
    
    var descriptionLabel = alertBox.getPartById("label");
    descriptionLabel.setAttribute("value", updateDescription);
    */
    
    scene.focusedBox = alertBox.getPartById("updateButton");
}

//if the user click on any of the item in the dialog box, execute the action
function updateAction(action)
{
    //shell.app.debugLog("in updateAction");
    var alertBox = scene.getBoxById("alertBox");
    alertBox.close();
    
    var updateMenu = true;
    switch(action)
    {
        case 0:
        {
            scene.updateObj.launchLink(0);
            break;
        }
        case 1:
        {
            //remind me later!
            //just keep showing update icon in carousel when user signs on
            break;
        }
        case 2:
        {
            updateMenu = false;
            var rootBox = scene.rootBox;
            alertBox.alert("", "alertContentMultiline", rootBox.getAttribute("softwareUpdate.turnOffAlerts"), rootBox.getAttribute("aim.cancel"), scene.updateObj, "turnOffAlerts");
            alertBox.getPartById("label").setAttribute("value", rootBox.getAttribute("softwareUpdate.turnOffAlertsDescription"));
            
            break;
        }
        case 3:
        {
            scene.updateObj.launchLink(1);
            break;
        }
    }
    if (updateMenu)
    {
        scene.getBoxById("activeConversationBar").removeBuddy("1_update");
        onMenuChanged();
    }
}


function installCriticalUpdate()
{
    scene.updateObj.launchLink(0);
    scene.close();
}

function onAddBuddyInputModified()
{
    var event = shell.currentEvent;
    var targetBox = (event) ? event.targetBox : null;
    var alertBox = this.scene.getBoxById("alertBox");
    var button1 = alertBox ? alertBox.getPartById("button1") : null;
    
    if (targetBox && button1)
    {
        var value = targetBox.value;
        if (value && value != "" && value.replace(/ /ig,"") != "")
        {
            button1.setAttribute("disabled", "false");
        }
        else
        {
            button1.setAttribute("disabled", "true");
        }
    }    
}

function onSettingsChange()
{
    var event = shell.currentEvent;
    if(event)
    {
        setPresencePerSetting(event.pdMode, true);
    }
}

function setPresencePerSetting(pMode, settings)
{
    if (!this.scene.AIMobj.getIsReconnect() && !this.scene.AIMobj.getContinueOffline())
    {
        var buddyListObj = scene._buddyListObj;
        var buddyList = buddyListObj.getBuddyList();
        if(buddyList && pMode)
        {
            var enumBL = buddyList.getEnumerator();
            var isGetPresence = true;
            var recentBuddyGroup;
            if (pMode == "permitOnList")
            {
                recentBuddyGroup = scene._buddyListObj.getRecentBuddyGroup();
            }
            while (enumBL.moveNext())
            {
                var buddyInfo = enumBL.current;
                isGetPresence = true;
                switch(pMode)
                {
                    case "denyAll":
                    {
                        //Set everything as blocked 'Block all Users'
                        //Set the blocked icon for all the buddys
                        buddyInfo.state = "blocked";
                        scene._buddyListObj.updateBuddiesFromObj(buddyInfo);
                        isGetPresence = false;
                        break;
                    }
                    case "denySome":
                    {
                         //set only the blocked users as blocked. 
                        //'Block only users in blocked list'
                        if( scene.AIMobj.blockedList.containsValue(buddyInfo.aimId))
                        {
                            buddyInfo.state = "blocked";
                            scene._buddyListObj.updateBuddiesFromObj(buddyInfo);
                            isGetPresence = false;
                        }
                        break;
                    }
                    case "permitSome":
                    {
                        //Set all the buddies not in Allow list to blocked.
                        //'Allow only users on my Allowed list'
                        if( !scene.AIMobj.allowedList.containsValue(buddyInfo.aimId))
                        {
                            buddyInfo.state = "blocked";
                            scene._buddyListObj.updateBuddiesFromObj(buddyInfo);
                            isGetPresence = false;
                        }
                        break;
                    }
                    case "permitOnList":
                    {
                        if (recentBuddyGroup)
                        {
                            if (recentBuddyGroup.hasBuddy(buddyInfo.aimId))
                            {
                                buddyInfo.state = "blocked";
                                scene._buddyListObj.updateBuddiesFromObj(buddyInfo);
                                isGetPresence = false;
                            }
                        }
                        break;    
                    }
                    case "permitAll":
                    {
                        break;
                    }
                } //end of switch
                if (isGetPresence && settings)
                {
                    if(settings)
                    {
                        scene.AIMobj.getPresenceInfo(buddyInfo.aimId);
                    }
                }
            }//end of while loop
        }// end of if(buddyList)
    }
}

function onWindowActivate()
{
    try
    {
        shell.app.dismissNotifications();
        shell.device.sip = false;
    }
    catch(e){}
}

function onMessage()
{
    var event = shell.currentEvent;
    if (event)
    {
        if (event.message == "viewBuddyConversation")
        {
            var dict = event.paramsDictionary;
            if (dict)
            {
                var buddyId = dict.valueForKey("buddyId");
                if (buddyId)
                {
                    var carousel = scene.getBoxById("activeConversationBar");
                    if (carousel)
                    {
                        var buddy = carousel.findBuddy(buddyId);
                        if (!buddy)
                        {
                            // it's not in the carousel yet - look in the buddy list for this buddy
                            var buddyInfo = scene._buddyListObj.getBuddyInfo(buddyId);
                            if (buddyInfo)
                            {
                                // start a conversation
                                var chatPanel = scene.getBoxById("chatPanel");
                                if (chatPanel)
                                {
                                    showPanel(panelAttribute_chatPanel);
                                    chatPanel.startConversation(buddyInfo, true, false, false, false);
                                }
                            }
                        }
                        else
                        {
                            var contentContainer = scene.getBoxById("contentContainer");
                            //if we are in other panel besides conversation or buddy, show it in buddyList
                            if (contentContainer.getAttribute(panelAttribute_chatPanel) == "false" &&
                                contentContainer.getAttribute(panelAttribute_buddyList) == "false")
                            {
                                contentContainer.showPanelByAttribute(panelAttribute_buddyList);
                            }
                            carousel.activateBuddy(buddyId);
                        }
                    }
                }
            }
        }
        else if (event.message == "signIn")
        {
            // Don't need to do anything here at the moment
        }
    }
}

function showPanel(panelName)
{
    var contentContainer = scene.getBoxById("contentContainer");
    if (contentContainer.getAttribute(panelName) == "false")
    {
        contentContainer.showPanelByAttribute(panelName);
    }    
}

function onRemoveSavedConversation()
{
    scene.getBoxById("chatPanel").cleanSavedConversation();
}

function onAddCurrentConversation()
{
    var currConversation = scene.getBoxById("chatPanel").getCurrConversation();
    scene.getBoxById("buddyList").cmdAddBuddy(currConversation.id, currConversation.getDisplayId());
}

function onSettingSaved()
{
    if (!this.scene.AIMobj.getIsReconnect() && !this.scene.AIMobj.getContinueOffline())
    {
        updateNotificationBox(null, "Saving changes...", 2000)
    }
}

function onPresenceChanged()
{
    scene.getBoxById("chatPanel").setTrackAutoResponse(shell.currentEvent.presence == "away");
}

function onSendAutoResponse()
{
    var screenName = shell.currentEvent.screenName;
    if (screenName && AIMobj)
    {
        var statusMessage = scene.getBoxById("buddyList").getStatusMessage();
        if (!statusMessage)
        {
            statusMessage = scene.rootBox.getAttribute("bl.defaultAwayMessage");
        }
        AIMobj.sendIMToBuddy(statusMessage, screenName, true);
    }
}

function updateConversations()
{
    var carousel = scene.getBoxById("activeConversationBar");
    var count = carousel.getNumIcons();
    for (var x = 0; x < count; ++x)
    {
        var carouselItem = carousel.getContentChildAt(x);
        if (carouselItem)
        {
            var presenceState = carouselItem.getAttribute("presenceState");
            if (presenceState != "unknown" && presenceState != "1_update")
            { 
                var id = carouselItem.getAttribute("buddyId");
                if (id && id.toLowerCase() != "aolsystemmsg")
                {
                    var buddyInfo = scene._buddyListObj.getBuddyInfo(id);
                    if (buddyInfo)
                    {
                        carouselItem.setPresence(buddyInfo.state);
                        carouselItem.setAttribute("buddyIcon", buddyInfo.buddyIcon);
                        var conversationWindow = scene.getBoxById("chatPanel");
                        if (conversationWindow)
                        {
                            conversationWindow.updateBuddyPresence(buddyInfo, true);
                        }
                    }
                    else
                    {
                        this.scene.AIMobj.addTempBuddy(id);
                        this.scene.AIMobj.getPresenceInfo(id);
                    }
                }
            }
        }
    }
}

function onAlertInputFocusChanged()
{
    try
    {
        shell.app.overrideBackButton(scene.rootBox.windowHandle, true);
    }
    catch(e){}
}

function getBuddyProfile()
{
    var screenName;
    var buddyInfo;
    var contentContainer = scene.getBoxById("contentContainer");
    var currPanelAttribute = contentContainer.getCurrentAttribute();
    if (contentContainer.getAttribute(panelAttribute_buddyList) == "true")
    {
        buddyInfo = scene.getBoxById("buddyList").getSelectedBuddy();
    }
    else
    {
        var chatPanel = scene.getBoxById("chatPanel");
        var currConversationId = chatPanel.getCurrConversationId();
        if (currConversationId)
        {
            buddyInfo = this.scene._buddyListObj.getBuddyInfo(currConversationId);
            if (!buddyInfo)
            {
                buddyInfo = chatPanel.getCurrConversation().getBuddyInfo();
            }
        }
    }
    if (buddyInfo)
    {
        var profileBox = scene.getBoxById("profileBox");
        profileBox.showProfile(buddyInfo);
        profileBox.savedFocusedBox = this.scene.focusedBox;
        profileBox.previousPanel = currPanelAttribute;
        contentContainer.showPanelByAttribute(panelAttribute_profile);
    }
}

function showMailIcon(showMail)
{
    scene.getBoxById("buddyList").setAttribute("showMailIcon", showMail);
    if (showMail == "true")
    {
        if (!mailObj)
        {
            mailObj = new mailChecker();
            scene.addDOMObject("mailObj", mailObj);
        }
        scene.mailObj.checkMail();   
    }
    else if (mailObj)
    {
        scene.mailObj.release();
        scene.removeDOMObject("mailObj");
        mailObj = null;
    }
}

function buddyInfoDialogClosed()
{
    var notificationBox = scene.getBoxById("notificationBox");
    if (!notificationBox.collapsed && !scene.AIMobj.getContinueOffline() && !scene.AIMobj.getIsReconnect())
    {
        updateNotificationBox();
    }   
}

function buddyListRowDestroyed()
{
    var row = shell.currentEvent.targetBox;
    if (row.getAttribute("selected") == "true" && gAimOnline)
    {
        var buddyList = scene.getBoxById("buddyList");
        var grid = buddyList.getPartById("buddyListGrid");
        var rowNum = grid.getRowOfBox(row);
        grid.selectedIndex = (rowNum != 0) ? rowNum - 1 : 0;;
    }
}