// ****************************************************************************
//
// Copyright  2008 AOL LLC  All rights reserved.
// This software contains valuable confidential and proprietary information
// of AOL LLC and is subject to applicable licensing agreements.
// Unauthorized reproduction, transmission or distribution of this file and
// its contents is a violation of applicable laws.
//
//           A O L  L L C   C O N F I D E N T I A L
//
// ****************************************************************************

function component (_gadget)
{
}

component.prototype.getSelectedValue = function()
{
    var selectedValue = "";
    var tabPanels = this._gadget.getPartById("tabPanels");
    var index = parseInt(tabPanels.getAttribute("topIndex"));
    if (index > -1)
    {
        selectedValue = tabPanels.getChildAt(index).getAttribute("value");
    }
    return selectedValue;
}

//****************************************************************************

component.prototype.setTopIndex = function(idx)
{
    var tabPanels = this._gadget.getPartById("tabPanels");
    tabPanels.setAttribute("topIndex", idx.toString());
}

//****************************************************************************

component.prototype.onSelect = function(delta)
{
    var tabPanels = this._gadget.getPartById("tabPanels");
    var index = parseInt(tabPanels.getAttribute("topIndex", "1"));
    index += delta;

    var contentCount = this._gadget.contentChildCount;

    // Wrap if we need to        
    if (this._gadget.getAttribute("wrapping") == "true")
    {
        if (index < 0) index = contentCount-1;
        else if (index >= contentCount) index = 0;
    }

    if (contentCount && (index >= 0) && (index < contentCount))
    {
        var snapshot1 = tabPanels.createSnapshot(false);
        tabPanels.attachSourceSnapshot(snapshot1);

    
        // ****************************
        // *** Switch the deck view ***
        tabPanels.setAttribute("topIndex", index.toString());
        // ****************************
        // ****************************

        
        var snapshot2 = tabPanels.createSnapshot(true);
        tabPanels.attachTargetSnapshot(snapshot2);

        tabPanels.renderTargetSnapshot();

        if (snapshot1 && snapshot2)
        {
            var transition = tabPanels.createTransition();
            if (transition)
            {
                transition.type = (delta > 0) ? "pushLeft" : "pushRight";
                transition.duration = 100;
                transition.dynamicsType = "none";

                transition.perform(snapshot1, snapshot2);
            }       
        }
        
        // remove our attached snapshots
        tabPanels.detachSourceSnapshot();
        tabPanels.detachTargetSnapshot();        
    }
    shell.currentEvent.stopPropagation();
}

