﻿// ****************************************************************************
//
// Copyright © 2008 AOL LLC  All rights reserved.
// This software contains valuable confidential and proprietary information
// of AOL LLC and is subject to applicable licensing agreements.
// Unauthorized reproduction, transmission or distribution of this file and
// its contents is a violation of applicable laws.
//
//           A O L  L L C   C O N F I D E N T I A L
//
// ****************************************************************************
//
//  Preference Key definitions
//

///////////////////////////////////////////////////////////////////////
//  Global prefs
///////////////////////////////////////////////////////////////////////

Preferences.prototype.appGUID = "";

Preferences.prototype.knownIdentitiesStorage = "knownIdentities";
Preferences.prototype.previousScreenNameKey = "lastScreenName";
Preferences.prototype.enableCarouselTransitionsKey = "enableCarouselTransitions";
Preferences.prototype.enableCarouselTransitions = true;
Preferences.prototype.enableAllTransitionsKey = "enableAllTransitions";
Preferences.prototype.enableAllTransitions = false;

Preferences.prototype.updateDisplayUrlKey = "updateDisplayUrl";
Preferences.prototype.updateDownloadUrlKey = "updateDownloadUrl";
Preferences.prototype.updateDescriptionKey = "updateDescription";
Preferences.prototype.updateMandatoryFlagKey = "updateMandatoryFlag";
Preferences.prototype.updateNextCheckKey = "updateNextCheck";
Preferences.prototype.updateUseTestServerKey = "updateUseTestServer";
Preferences.prototype.updateUseDevServerKey = "updateUseDevServer";

///////////////////////////////////////////////////////////////////////
//  Identity based prefs (when set, only apply to that user's settings)
///////////////////////////////////////////////////////////////////////

//identityAutoSignInKey "autoSignIn"
Preferences.prototype.autoSignInKey = "autoSignIn";
Preferences.prototype.autoSignInDefaultValue = true;

//identitySignInInvisibleKey "signInInvisible"
Preferences.prototype.signInInvisibleKey = "signInInvisible";
Preferences.prototype.signInInvisibleDefaultValue = false;

//identityScreenNameKey "screenname";
Preferences.prototype.screenNameKey = "screenname";
Preferences.prototype.screenNameDefaultValue = "";

//identityPasswordKey "password";
Preferences.prototype.passwordKey = "password";
Preferences.prototype.passwordDefaultValue = "";

Preferences.prototype.saveConversationsKey = "saveConversations";
Preferences.prototype.saveConversationsDefaultValue = true;

Preferences.prototype.autoAcceptUnknownKey = "autoAcceptUnknown";
Preferences.prototype.autoAcceptUnknownDefaultValue = false;

Preferences.prototype.acceptOffLineIMKey = "acceptOffLineIM";
Preferences.prototype.acceptOffLineIMKeyDefaultValue = true;

Preferences.prototype.showMailCountKey = "showMailCount";
Preferences.prototype.showMailCountKeyDefaultValue = true;

//permit/deny mode on WIM api
Preferences.prototype.PdModeKey = "PdMode";
Preferences.prototype.PdModePermitAll = "permitAll";
Preferences.prototype.PdModePermitOnList = "permitOnList";
Preferences.prototype.PdModeDenyAll = "denyAll";
Preferences.prototype.PdModePermitSome = "permitSome";
Preferences.prototype.PdModeDenySome = "denySome";
Preferences.prototype.PdModeDefaultValue = Preferences.prototype.PdModePermitAll;  

Preferences.prototype.noSeeRecentBuddiesKey = "noSeeRecentBuddies";
Preferences.prototype.noSeeRecentBuddiesDefaultValue = false;

Preferences.prototype.showStatusAndAwayMessagesKey = "showStatusAndAwayMessages";
Preferences.prototype.showStatusAndAwayMessagesDefaultValue = true;

Preferences.prototype.playIMSoundKey = "playIMSound";
Preferences.prototype.playIMSoundDefaultValue = true;

Preferences.prototype.playSendIMSoundKey = "playSendIMSound";
Preferences.prototype.playSendIMSoundDefaultValue = true;

Preferences.prototype.playAlertSoundKey = "playAlertSound";
Preferences.prototype.playAlertSoundDefaultValue = true; 

Preferences.prototype.externalNotifyKey = "externalNotify";
Preferences.prototype.externalNotifyDefaultValue = true; 

Preferences.prototype.updateNotifyKey = "updateNotify";
Preferences.prototype.updateNotifyDefaultValue = true; 

// ----------------------------------------------------------------------------

function Preferences()
{
}

// ----------------------------------------------------------------------------

Preferences.prototype.prefsGetGlobalStore = function()
{
    var storeName = "mobileAIM"; // Default value for Win32 builds w/o the app object.
    try {
        storeName = shell.app.productId;
    }
    catch (e) {}
    return storeName;
}

// ----------------------------------------------------------------------------

Preferences.prototype.prefsGetKnownIdentitiesStore = function()
{
    return storeName = this.prefsGetGlobalStore()+"."+this.knownIdentitiesStorage;
}

// ----------------------------------------------------------------------------
// Note: method will return an empty string in the event of a failure. Check when using.
Preferences.prototype.prefsGetStoreForCurrentIdentity = function()
{
    var storeName = "";
    try {
        var screenName = "";
        if (scene)
        {
            screenName = scene.AIMobj.getCurrentScreenname();
            //shell.app.debugLog("Preferences.prefsGetStoreForCurrentIdentity: scene.AIMobj"); // Statistical logging
        }
        else
        {
            screenName = this.scene.AIMobj.getCurrentScreenname();
            //shell.app.debugLog("Preferences.prefsGetStoreForCurrentIdentity: this.scene.AIMobj"); // Statistical logging
        }
        if (screenName)
        {
            storeName = this.prefsGetGlobalStore()+"."+screenName;
        }
    }
    catch (e)
    {
        //shell.app.debugLog("Preferences.prefsGetStoreForCurrentIdentity: !!! exception raised"); // Statistical logging
    }
    return storeName;
}

// ----------------------------------------------------------------------------

Preferences.prototype.prefsGetStoreForIdentity = function(inIdentity)
{
    var storeName = "";
    if (inIdentity)
    {
        storeName = this.prefsGetGlobalStore()+"."+inIdentity;
    }
    return storeName;
}
