// ****************************************************************************
//
// Copyright ?2008 AOL LLC  All rights reserved.
// This software contains valuable confidential and proprietary information
// of AOL LLC and is subject to applicable licensing agreements.
// Unauthorized reproduction, transmission or distribution of this file and
// its contents is a violation of applicable laws.
//
//           A O L  L L C   C O N F I D E N T I A L
//
// ****************************************************************************

function component(_gadget)
{
}

component.prototype.launchAd = function()
{
    this._gadget.getPartById("profileAd").linkClicked();
}

component.prototype.getAIMId= function()
{
    var id = this._gadget.getPartById("aimId").getAttribute("value");
    if (!id)
    {
        id = this._gadget.getPartById("displayId").getAttribute("value");
    }
    return id;
}

component.prototype.getDisplayId = function()
{
    return this._gadget.getPartById("displayId").getAttribute("value");
}

component.prototype.propagateNotification = function(icon, message, timeToDisplay)
{
    var event = shell.factory.createEvent(this._gadget);
    if (event)
    {	    
        event.type = "showNotification";
        event.icon = icon;
        event.message = message;
        event.timeToDisplay = timeToDisplay;
        this._gadget.dispatchEvent(event);
    }
}

component.prototype.showProfile = function(buddyInfo)
{
    this._gadget.getPartById("profileAd").TSMretrieveAd();
    if (buddyInfo)
    {
        // since we are not cashing profileMsg on presenceUpdate, we need to call getProfile
        if (!this.scene.AIMobj.getContinueOffline() && !this.scene.AIMobj.getIsReconnect())
        {
            this.propagateNotification("", this.scene.rootBox.getAttribute("profile.requestingProfile"));
        }
        this.scene.AIMobj.getProfile(buddyInfo.aimId);  
        this._gadget.getPartById("displayId").setAttribute("value", buddyInfo.displayId);
        this._gadget.getPartById("aimId").setAttribute("value", (buddyInfo.displayId != buddyInfo.aimId) ? buddyInfo.aimId : "");
        this._gadget.setAttribute("profileMessage", "");
        this._gadget.setAttribute("memberSince", "");
        this._gadget.setAttribute("messageLastModified", "");
        this._gadget.setAttribute("statusTimeLabel", "");
        
        this.updateBasicInfomation(buddyInfo);
    }
}

component.prototype.updateBasicInfomation = function(buddyInfo)
{
    var icon = buddyInfo.buddyIcon ? buddyInfo.buddyIcon : "#buddyList.placeHolderBuddy";
    this._gadget.setAttribute("buddyIcon", icon);
    this._gadget.setAttribute("presenceIcon", getPresenceIcon(buddyInfo.state));

    var buddyState = "profile.";;
    var messageType = "profile.status";
    switch(buddyInfo.state)
    {
        case "online":
        {
            buddyState += "available";
            break;
        }
        case "away":
        {
            messageType = "profile.away";
        }
        case "idle":
        case "blocked":
        case "mobile":
        case "offline":
        {
            buddyState += buddyInfo.state;
            break;
        }
        default:
        {
            buddyState += "offline";
            break;
        }
    }
    this._gadget.setAttribute("buddyState", this.scene.rootBox.getAttribute(buddyState));
    
    var statusMessage;
    if (buddyInfo.state == "away")
    {
        statusMessage = this.parseHTML(buddyInfo.awayMsg);
    }
    else
    {
        statusMessage = this.normalizeMessageString(buddyInfo.statusMsg);
    }
    var hideStatusMessage;
    if (this._gadget.getAttribute("statusMessage") != statusMessage)
    {
        hideStatusMessage = "true";
        if (statusMessage)
        {
            hideStatusMessage = "false";
        }
        this._gadget.setAttribute("statusMessage", statusMessage);        
    }
    else if (statusMessage && this._gadget.getAttribute("hideStatusMessage") == "true")
    {
        hideStatusMessage = "false";
    }
    if (hideStatusMessage)
    {
        this._gadget.setAttribute("hideStatusMessage", hideStatusMessage);
    }
    
    if (buddyInfo.statusMsg)
    {
        this._gadget.setAttribute("messageType", this.scene.rootBox.getAttribute(messageType));
    }
    
    try
    {
        shell.app.overrideBackButton(this.scene.rootBox.windowHandle, true);
    }
    catch(e){}
}

component.prototype.normalizeMessageString = function(message)
{
    if (message && message.indexOf("%") > -1)
    {
        if (message.indexOf("%n") > -1)
        {
            message = message.replace(/%n/ig, this.scene.AIMobj.getLoginId());
        }
        
        var date;
        if (message.indexOf("%d") > -1)
        {
            date = new Date()
            var dateStr = date.getYear() + "-" + (date.getMonth() + 1) + "-" + date.getDate();
            message = message.replace(/%d/ig, dateStr);
        }
        if (message.indexOf("%t") > -1)
        {
            if (!date)
            {
                date = new Date();
            }
            var hours = date.getHours();
            var mins = date.getMinutes();
            var timestamp = ((hours > 12) ? (hours-12) : hours) + ":" + (mins < 10 ? "0"+mins : mins);
            message = message.replace(/%t/ig, timestamp);
        }
    }
    return message;
}

component.prototype.parseHTML = function(string)
{
    var newString;
    if (string)
    {
        newString = string.replace(/(<br\/>)/ig, "&lt;br&gt; ");
        newString = newString.replace(/<b>/ig, "&lt;b&gt;");
        newString = newString.replace(/<\/b>/ig, "&lt;\/b&gt;");
        newString = newString.replace(/<i>/ig, "&lt;i&gt;");
        newString = newString.replace(/<\/i>/ig, "&lt;\/i&gt;");
        newString = newString.replace(/<u>/ig, "&lt;u&gt;");
        newString = newString.replace(/<\/u>/ig, "&lt;\/u&gt;");

        newString = this.normalizeMessageString(newString);

        newString = newString.replace(/(<span ([^>]+)>)/ig, "");
        newString = newString.replace(/<span>/ig, "");
        newString = newString.replace(/<\/span>/ig, "");
        newString = newString.replace(/(<div ([^>]+)>)/ig, "");
        newString = newString.replace(/<div>/ig, "");
        newString = newString.replace(/<\/div>/ig, "");
        newString = parseSmileys(newString);
    }
    return newString;
}

component.prototype.updateProfile = function(buddyInfo, isUpdateProfileMsg)
{
    if (buddyInfo && (this._gadget.getPartById("aimId").getAttribute("value") == buddyInfo.aimId
      || this._gadget.getPartById("displayId").getAttribute("value") == buddyInfo.aimId))
    {
        var rootBox = this.scene.rootBox;
        this.updateBasicInfomation(buddyInfo);
        
        if (isUpdateProfileMsg)
        {
            var profileMsg = "";
            
            if (buddyInfo.profileMsg)
            {
                profileMsg = this.parseHTML(buddyInfo.profileMsg);
                this._gadget.setAttribute("profileMessage", profileMsg);
            }
            this._gadget.setAttribute("hideProfileMessage", profileMsg ? "false" : "true");
        }
        
        var statusTimeLabel = "";
        if (buddyInfo.state != "blocked" && buddyInfo.onlineTime)
        {
            statusTimeLabel = rootBox.getAttribute("profile.online") + ": " + this.getTimeStringFromSeconds(buddyInfo.onlineTime);
            if (buddyInfo.idleTime)
            {
                statusTimeLabel += " | " + rootBox.getAttribute("profile.idle") + ": " + this.getTimeStringFromSeconds(buddyInfo.idleTime*60);
            }
        }
        else if (buddyInfo.state != "mobile")
        {
            statusTimeLabel = rootBox.getAttribute("profile.offline");
        }
        this._gadget.setAttribute("statusTimeLabel", statusTimeLabel);
        
        var messageLastModified;
        if (buddyInfo.awayTime)
        {
            messageLastModified = buddyInfo.awayTime;
        }
        else if (buddyInfo.statusTime)
        {
            messageLastModified = buddyInfo.statusTime;
        }
        if (messageLastModified)
        {
            var lastChange = formatString1(rootBox.getAttribute("profile.lastMessageModifiedTime"), this.getTimeStringFromSeconds(messageLastModified));
            this._gadget.setAttribute("messageLastModified", lastChange);
        }

        if (buddyInfo.memberSince)
        {        
            var date = new Date();
            date.setTime(buddyInfo.memberSince * 1000);
            var dateArray = date.toString().split(" ");
            if (dateArray.length == 6)
            {
                var memberSinceString = dateArray[1] + " " + dateArray[2] + " " + dateArray[5]
                this._gadget.setAttribute("memberSince", formatString1(rootBox.getAttribute("profile.memberSince"), memberSinceString));
            }
        }
    }
}

component.prototype.getTimeStringFromSeconds = function(seconds)
{
    var mins = Math.floor(seconds / 60);
    var hour = 0;
    var day;
    var str = "";
    if (mins == 0)
    {
        mins = 1;
    }
    else if (mins > 59)
    {
        hour = Math.floor(mins / 60);
        mins = mins % 60;
    }
    if (hour > 23)
    {
        day = Math.floor(hour / 24);
        hour = Math.floor(hour % 24);        
    }
    
    var rootBox = this.scene.rootBox;
    if (day)
    {
        str += formatString1(rootBox.getAttribute("profile.timeUnit.day"), day);
    }
    if (day || hour != 0)
    {
        str += " " + formatString1(rootBox.getAttribute("profile.timeUnit.hour"), hour);
    }
    if (mins > 0)
    {
        str += " " + formatString1(rootBox.getAttribute("profile.timeUnit.minute"), mins);
    }
    return str;
}

component.prototype.goBack = function()
{
    this.scene.getBoxById("contentContainer").showPanelByAttribute(this._gadget.previousPanel);
    this.scene.focusedBox = this._gadget.savedFocusedBox;
    this.close();
}

component.prototype.close = function()
{
    var event = shell.factory.createEvent(this._gadget);
    if (event)
    {	    
        event.type = "buddyInfoDialogClosed";
        this._gadget.dispatchEvent(event);
    }

    try
    {
         shell.app.overrideBackButton(this.scene.rootBox.windowHandle, false);
    }
    catch(e){}                    
    this._gadget.previousPanel = null;
    this._gadget.savedFocusedBox = null;
}

component.prototype.scroll = function(isUp)
{
    var scrollBox = shell.currentEvent.targetBox;
    if (scrollBox.overflowed)
    {
        var scrollPixel = isUp ? -50 : 50;
        scrollBox.scrollBy(scrollPixel);
    }
}