// ****************************************************************************
//
// Copyright ?2008 AOL LLC  All rights reserved.
// This software contains valuable confidential and proprietary information
// of AOL LLC and is subject to applicable licensing agreements.
// Unauthorized reproduction, transmission or distribution of this file and
// its contents is a violation of applicable laws.
//
//           A O L  L L C   C O N F I D E N T I A L
//
// ****************************************************************************

function component(_gadget)
{
    this.lastTab;   
}

component.prototype.mouseUp = function()
{
    var targetBox = shell.currentEvent.targetBox;
    if (targetBox && targetBox.tag == "scrollButton")
    {   
        var tabPanels = this._gadget.getPartById("tabPanels");
        var index = parseInt(tabPanels.getAttribute("topIndex"));
        if (index > -1)
        {
            var tab = tabPanels.getChildAt(index);
            var contentBox = tab.getPartById("panelContainer")
            if (targetBox.id == "buttonDown")
            {
                tab.scrollDownHelper(contentBox);
            }
            else
            {
                tab.scrollUpHelper(contentBox);
            }
        }
    }
}

component.prototype.rewindFocus = function()
{
    var currentFocusedBox = this.scene.focusedBox;
    var tabPanels = this._gadget.getPartById("tabPanels");
    var selectedTab;
    var index = parseInt(tabPanels.getAttribute("topIndex"));
    if (index > -1)
    {
        selectedTab = tabPanels.getChildAt(index);
    }

    if(currentFocusedBox != this.findFirstFocusableBox(selectedTab.firstContentChild))
    {
        this.scene.rewindFocus();
        if (shell.currentEvent)
        {
            shell.currentEvent.stopPropagation();
        }
    }
}

component.prototype.advanceFocus = function()
{
    var currentFocusedBox = this.scene.focusedBox;
    var tabPanels = this._gadget.getPartById("tabPanels");
    var selectedTab;
    var index = parseInt(tabPanels.getAttribute("topIndex"));
    if (index > -1)
    {
        selectedTab = tabPanels.getChildAt(index);
    }

    if(currentFocusedBox != this.findLastFocusableBox(selectedTab.firstContentChild))
    {
        this.scene.advanceFocus();
        if (shell.currentEvent)
        {
            shell.currentEvent.stopPropagation();
        }
    }    
}

component.prototype.wrapFocus = function(forward)
{
    var gadget = this._gadget;
    var tabPanels = this._gadget.getPartById("tabPanels");
    var selectedTab;
    var index = parseInt(tabPanels.getAttribute("topIndex"));
    if (index > -1)
    {
        selectedTab = tabPanels.getChildAt(index);
    }
    
    if (selectedTab)
    {
        if (forward)
        {
            var box = this.findLastFocusableBox(selectedTab.firstChild);
            if (box)
            {
                this.scene.focusedBox = box;
            }
        }
        else
        {
            var box = this.findFirstFocusableBox(selectedTab.firstChild);
            if (box)
            {
                this.scene.focusedBox = box;
            }
        }
    }
}

//****************************************************************************

component.prototype.findFirstFocusableBox = function(child)
{
    while (child)
    {
        var focusMode = child.getAttribute("focusMode");
        if (focusMode == "normal")
        {
            return child;
        }
        
        if (!child.collapsed)
        {
            var child2 = child.firstChild;
            if (child2 && !child2.collapsed)
            {
                var found = this.findFirstFocusableBox(child2);
                if (found)
                    return found;
            }
        }
        
        child = child.nextSibling;
    }
}

//****************************************************************************

component.prototype.findLastFocusableBox = function(child)
{
    var lastBox = null;
    
    while (child)
    {
        var focusMode = child.getAttribute("focusMode");
        if (focusMode == "normal" && !child.disabled)
        {
            lastBox = child;
        }
        
        var child2 = child.firstChild;
        if (child2)
        {
            var found = this.findLastFocusableBox(child2);
            if (found)
            {
                lastBox = found;
            }
        }
        
        child = child.nextSibling;
    }
    
    return lastBox;
}

component.prototype.onShowTab = function()
{
    var label = shell.currentEvent.targetBox;
    var event = shell.currentEvent;
    if (event)
    {
        event.stopPropagation();
        event.preventDefault();
    }
    this.setTab(label.id);
}

component.prototype.setTab = function(tabName)
{
    var tabPanels = this._gadget.getPartById("tabPanels");
    var idx = 0;
    var focusedBox;
    switch(tabName)
    {
        case "main":
        {
            idx = 0;
            focusedBox = this._gadget.getPartById(this.lastTab);
            break;
        }
        case "general":
        {
            idx = 1;
            this._gadget.loadGeneralPreferences();
            focusedBox = this._gadget.getPartById("saveConversationsButton");
            break;
        }
        case "buddyList":
        {
            idx = 2;
            this._gadget.loadBuddyListPreferences();
            focusedBox = this._gadget.getPartById("showStatusMsgButton");
            break;
        }
        case "sounds":
        {
            idx = 3;
            this._gadget.loadSoundsAndNotificationsPreferences();
            focusedBox = this._gadget.getPartById("notifyMailButton");
            break;
        }
        case "visualEnhancement":
        {
            idx = 4;
            this._gadget.loadVisualEnhancementPreferences();
            focusedBox = this._gadget.getPartById("showTransitionButton");
            break;
        }
        case "privacy":
        {
            idx = 5;
            this._gadget.loadPrivacyPreferences();
            var radioBox = this._gadget.getPartById("privacyContactMeRadioBox");
            focusedBox = (!radioBox.disabled) ? radioBox : this._gadget.getPartById("privacyNoteLabel");
            break;
        }
        case "softwareUpdates":
        {
            idx = 6;
            this._gadget.loadSoftwareUpdatePreferences();
            focusedBox = this._gadget.getPartById("notifyUpdatesButton");
            break;
        }
    }
    
    tabPanels.setAttribute("topIndex", idx.toString());
    this.scene.focusedBox = focusedBox;
    
    var rootBox = this.scene.rootBox;
    var softKeyMenu = this._gadget.getPartById("leftSoftKeyMenu");
    var newLabel = (idx == 0) ? "aim.menu.label.Back" : "aim.save";
    newLabel = rootBox.getAttribute(newLabel);
    if (softKeyMenu.getAttribute("menuTitle") != newLabel)
    {
        softKeyMenu.setAttribute("menuTitle", newLabel);
        softKeyMenu.setAttribute("commandId", (idx == 0) ? "IDM_SETTING_BACK" : "IDM_SETTING_SAVE");
    }
    
    softKeyMenu = this._gadget.getPartById("rightSoftKeyMenu");
    
    if (idx != 0)
    {
        this.lastTab = tabName;
                
        softKeyMenu.setAttribute("menuTitle", rootBox.getAttribute("aim.cancel"));
        softKeyMenu.setAttribute("commandId", "IDM_SETTING_CANCEL");
        softKeyMenu.setAttribute("hasSubMenu", "false");
    }
    else
    {
        softKeyMenu.setAttribute("menuTitle", rootBox.getAttribute("aim.menu.label.Menu"));
        softKeyMenu.setAttribute("commandId", "IDM_SETTING_MENU");
        softKeyMenu.setAttribute("hasSubMenu", "true");
    }
    propagateEventForBox(this._gadget, "menuChanged"); // update the menu
    
    try
    {
        shell.app.overrideBackButton(this.scene.rootBox.windowHandle, true);
    }
    catch(e){}
}

component.prototype.goBack = function()
{
    var contentContainer = this.scene.getBoxById("contentContainer");
    this._gadget.getPartById("rightSoftKeyMenu").closeMenu();
    contentContainer.showPanelByAttribute(this._gadget.previousPanel);
    try
    {
         shell.app.overrideBackButton(this.scene.rootBox.windowHandle, false);
    }
    catch(e){}                    
    
    this.scene.focusedBox = this._gadget.savedFocusedBox;
    this._gadget.previousPanel = null;
    this._gadget.savedFocusedBox = null;
}

component.prototype.showSettingsPage = function()
{
    if (!this._gadget.collapsed)
    {
        this.lastTab = "general";
        this.setTab("main");
    }
}

component.prototype.cancel = function()
{
    this.setTab("main");
}

component.prototype.save = function()
{
    var tabPanels = this._gadget.getPartById("tabPanels");
    var tabIdx = tabPanels.getAttribute("topIndex");
    switch(tabIdx)
    {
        case "1":
        {
            // general
            this._gadget.saveGeneralPreferences();
            break;
        }
        case "2":
        {
            // buddy list
            this._gadget.saveBuddyListPreferences();
            break;
        }
        case "3":
        {
            // sounds and notifications
            this._gadget.saveSoundsAndNotificationsPreferences();
            break;
        }
        case "4":
        {
            //visual Enhancement
            this.saveVisualEnhancementPreferences();
            break;
        }
        case "5":
        {
            // privacy
            this._gadget.savePrivacyPreferences();
            break;
        }
        case "6":
        {
            //software updates
            this.saveSoftwareUpdatePreferences();
            break;
        }        
    }
    this.setTab("main");
    propagateEventForBox(this._gadget, "settingSaved"); // update the menu
}

component.prototype.toggle = function()
{
    var targetBox = shell.currentEvent.targetBox;
    if (!targetBox.toggled)
    {
        targetBox.toggled = true;
    }
}

//------ Load -------------------------
component.prototype.loadVisualEnhancementPreferences = function()
{
    var enableCarouselTransitions;
    var enableAllTransitions;
    try
    {
        var storeName = this.scene.prefObj.prefsGetGlobalStore();
        if (storeName)
        {
            var kvs = new keyValueStorage();
            kvs.open(storeName);
            enableCarouselTransitions = kvs.getValue( this.scene.prefObj.enableCarouselTransitionsKey , this.scene.prefObj.enableCarouselTransitions );
            enableAllTransitions = kvs.getValue( this.scene.prefObj.enableAllTransitionsKey , this.scene.prefObj.enableAllTransitions );
            kvs.close();
            kvs = null;
        }
    }
    catch (e) {}
    this._gadget.getPartById("showCarouselTransitionButton").setAttribute("toggled", enableCarouselTransitions);
    this._gadget.getPartById("showTransitionButton").setAttribute("toggled", enableAllTransitions);
}

component.prototype.loadGeneralPreferences = function()
{
    var saveConversations = this.scene.prefObj.saveConversationsDefaultValue;
    var autoAcceptUnknown = this.scene.prefObj.autoAcceptUnknownDefaultValue;
    var acceptOffLineIM   = this.scene.prefObj.acceptOffLineIMDefaultValue;

    try
    {
        var storeName = this.scene.prefObj.prefsGetStoreForCurrentIdentity();
        if (storeName)
        {
            var kvs = new keyValueStorage();
            kvs.open(storeName);
            saveConversations = kvs.getValue( this.scene.prefObj.saveConversationsKey , this.scene.prefObj.saveConversationsDefaultValue );
            autoAcceptUnknown = kvs.getValue( this.scene.prefObj.autoAcceptUnknownKey , this.scene.prefObj.autoAcceptUnknownDefaultValue );
            acceptOffLineIM   = kvs.getValue( this.scene.prefObj.acceptOffLineIMKey , this.scene.prefObj.acceptOffLineIMDefaultValue );
            kvs.close();
            kvs = null;
        }
    }
    catch (e) {}

    this._gadget.getPartById("saveConversationsButton").setAttribute("toggled", saveConversations);
    this._gadget.getPartById("autoAcceptUnknownButton").setAttribute("toggled", autoAcceptUnknown);
    this._gadget.getPartById("acceptOffLineIMButton").setAttribute("toggled", acceptOffLineIM);
}

component.prototype.loadBuddyListPreferences = function()
{
    var showStatusMsg = this.scene.prefObj.showStatusAndAwayMessagesDefaultValue;
    var noSeeRecentBuddies = this.scene.prefObj.noSeeRecentBuddiesDefaultValue;

    try
    {
        var storeName = this.scene.prefObj.prefsGetStoreForCurrentIdentity();
        if (storeName)
        {
            var kvs = new keyValueStorage();
            kvs.open(storeName);
            showStatusMsg = kvs.getValue( this.scene.prefObj.showStatusAndAwayMessagesKey , this.scene.prefObj.showStatusAndAwayMessagesDefaultValue );
            noSeeRecentBuddies = kvs.getValue( this.scene.prefObj.noSeeRecentBuddiesKey , this.scene.prefObj.noSeeRecentBuddiesDefaultValue );
            kvs.close();
            kvs = null;
        }
    }
    catch (e) {}

    this._gadget.getPartById("showStatusMsgButton").setAttribute("toggled", showStatusMsg);
    // Invert key with selection, since the host option is to NOT display it while the client option is worded to display it.
    if (noSeeRecentBuddies.toString() == "true")
    {
        this._gadget.getPartById("addToRecentBuddiesButton").setAttribute("toggled", false);
    }
    else
    {
        this._gadget.getPartById("addToRecentBuddiesButton").setAttribute("toggled", true);
    }
}

component.prototype.loadSoundsAndNotificationsPreferences = function()
{
    var sndRecvIM      = this.scene.prefObj.playIMSoundDefaultValue;
    var sndSendIM      = this.scene.prefObj.playSendIMSoundDefaultValue;
    var sndRecvAlert   = this.scene.prefObj.playAlertSoundDefaultValue;
    var externalNotify = this.scene.prefObj.externalNotifyDefaultValue;
    var showMailCount  = this.scene.prefObj.showMailCountKeyDefaultValue;

    try
    {
        var storeName = this.scene.prefObj.prefsGetStoreForCurrentIdentity();
        if (storeName)
        {
            var kvs = new keyValueStorage();
            kvs.open(storeName);
            sndRecvIM      = kvs.getValue( this.scene.prefObj.playIMSoundKey     , this.scene.prefObj.playIMSoundDefaultValue );
            sndSendIM      = kvs.getValue( this.scene.prefObj.playSendIMSoundKey , this.scene.prefObj.playSendIMSoundDefaultValue );
            sndRecvAlert   = kvs.getValue( this.scene.prefObj.playAlertSoundKey  , this.scene.prefObj.playAlertSoundDefaultValue );
            externalNotify = kvs.getValue( this.scene.prefObj.externalNotifyKey  , this.scene.prefObj.externalNotifyDefaultValue );
            showMailCount   = kvs.getValue( this.scene.prefObj.showMailCountKey , this.scene.prefObj.showMailCountKeyDefaultValue );
            kvs.close();
            kvs = null;
        }
    }
    catch (e) {}

    this._gadget.getPartById("sndRecvIMButton").setAttribute("toggled", sndRecvIM);
    this._gadget.getPartById("sndSendIMButton").setAttribute("toggled", sndSendIM);
    this._gadget.getPartById("sndRecvAlertButton").setAttribute("toggled", sndRecvAlert);

    this._gadget.getPartById("notifyIMButton").setAttribute("toggled", externalNotify);
    this._gadget.getPartById("notifyMailButton").setAttribute("toggled", showMailCount);
}

component.prototype.loadPrivacyPreferences = function()
{
    var PdMode = this.scene.prefObj.PdModeDefaultValue;

    try
    {
        var storeName = this.scene.prefObj.prefsGetStoreForCurrentIdentity();
        if (storeName)
        {
            var kvs = new keyValueStorage();
            kvs.open(storeName);
            PdMode = kvs.getValue( this.scene.prefObj.PdModeKey , this.scene.prefObj.PdModeDefaultValue );
            kvs.close();
            kvs = null;
        }
    }
    catch (e) {}

    var selectedBox = this._gadget.getPartById(PdMode);
    this._gadget.getPartById("privacyContactMeRadioBox").selectedBox = selectedBox;
}

component.prototype.loadSoftwareUpdatePreferences = function()
{
    var updateNotify = this.scene.prefObj.updateNotifyDefaultValue;
    try
    {
        var storeName = this.scene.prefObj.prefsGetStoreForCurrentIdentity();
        if (storeName)
        {
            var kvs = new keyValueStorage();
            kvs.open(storeName);
            updateNotify = kvs.getValue( this.scene.prefObj.updateNotifyKey, this.scene.prefObj.updateNotifyDefaultValue );
            kvs.close();
            kvs = null;
        }
    }
    catch (e) {}
    
    var rootBox = this.scene.rootBox;
    var versionInfo = formatString1(rootBox.getAttribute("settings.SoftwareUpdates.runningVersion"), shell.app.version);
    this._gadget.getPartById("versionInfoLabel").setAttribute("value", versionInfo);
   
    var updateAvailable = this.scene.updateObj.isUpdateAvailable();
    if (updateAvailable == true)
    {
        /*
        var updateDescription = this.scene.updateObj.getDescription();
        if (updateDescription == "")
        {
            updateDescription = defaultDescriptionText;
        }
        */
        this._gadget.getPartById("updateAvailableLabel").setAttribute("value", rootBox.getAttribute("settings.SoftwareUpdates.newVersionAvailable"));
        this._gadget.setAttribute("hideUpdateButton","false");
    }
    else
    {
        this._gadget.getPartById("updateAvailableLabel").setAttribute("value", rootBox.getAttribute("settings.SoftwareUpdates.noUpdates"));
        this._gadget.setAttribute("hideUpdateButton","true");
    }
    
    this._gadget.getPartById("notifyUpdatesButton").setAttribute("toggled", updateNotify);
}


//------ Save -------------------------

component.prototype.saveVisualEnhancementPreferences = function()
{
    var showTransitionButton = this._gadget.getPartById("showTransitionButton");
    var showCarouselTransitionButton = this._gadget.getPartById("showCarouselTransitionButton");
    try
    {
        var kvs = new keyValueStorage();
        kvs.open(this.scene.prefObj.prefsGetGlobalStore());
        var isShowTransition = showTransitionButton.getAttribute("toggled");
        var isShowCarouselTransition = showCarouselTransitionButton.getAttribute("toggled");
        kvs.setValue( this.scene.prefObj.enableCarouselTransitionsKey , isShowCarouselTransition );
        kvs.setValue( this.scene.prefObj.enableAllTransitionsKey , isShowTransition );
        this.scene.prefObj.enableAllTransitions = isShowTransition == "true" ? true : false;
        this.scene.prefObj.enableCarouselTransitions = isShowCarouselTransition == "true" ? true : false;
        kvs.close();
        kvs = null;
    }
    catch (e) {}
}

component.prototype.saveGeneralPreferences = function()
{
    var saveConversationsButton = this._gadget.getPartById("saveConversationsButton");
    var autoAcceptUnknownButton = this._gadget.getPartById("autoAcceptUnknownButton");
    var acceptOffLineIMButton   = this._gadget.getPartById("acceptOffLineIMButton");
    
    var isSaveConversation      = saveConversationsButton.getAttribute("toggled");
    try
    {
        var storeName = this.scene.prefObj.prefsGetStoreForCurrentIdentity();
        if (storeName)
        {
            var kvs = new keyValueStorage();
            kvs.open(storeName);
            kvs.setValue( this.scene.prefObj.saveConversationsKey , isSaveConversation );
            kvs.setValue( this.scene.prefObj.autoAcceptUnknownKey , autoAcceptUnknownButton.getAttribute("toggled") );
            kvs.setValue( this.scene.prefObj.acceptOffLineIMKey , acceptOffLineIMButton.getAttribute("toggled") );
            kvs.close();
            kvs = null;
        }
    }
    catch (e) {}
    
    if (isSaveConversation == "false")
    {
        propagateEventForBox(this._gadget, "removeSavedConversation"); // update the menu
    }
    
    // Set the host-based preference
    this.scene.AIMobj.setPreference("acceptOffLineIM", acceptOffLineIMButton.toggled);
}

component.prototype.saveBuddyListPreferences = function()
{
    var showStatusMsgButton      = this._gadget.getPartById("showStatusMsgButton");
    var addToRecentBuddiesButton = this._gadget.getPartById("addToRecentBuddiesButton");
    var noSeeRecentBuddies       = addToRecentBuddiesButton.toggled;
    try
    {
        var storeName = this.scene.prefObj.prefsGetStoreForCurrentIdentity();
        if (storeName)
        {
            var kvs = new keyValueStorage();
            kvs.open(storeName);
            kvs.setValue( this.scene.prefObj.showStatusAndAwayMessagesKey , showStatusMsgButton.getAttribute("toggled") );
            // Invert key with selection, since the host option is to NOT display it while the client option is worded as adding to it.
            if (addToRecentBuddiesButton.getAttribute("toggled") == "true")
            {
                noSeeRecentBuddies = false;
            }
            else
            {
                noSeeRecentBuddies = true;
            }
            kvs.setValue( this.scene.prefObj.noSeeRecentBuddiesKey , noSeeRecentBuddies.toString() );
            kvs.close();
            kvs = null;
        }
    }
    catch (e) {}

    // Set the data-binding attribute on the root box
    this.scene.rootBox.setAttribute("showStatusMsg", showStatusMsgButton.toggled);
    // Set the host-based preference
    this.scene.AIMobj.setPreference("noSeeRecentBuddies", noSeeRecentBuddies);
}

component.prototype.saveSoundsAndNotificationsPreferences = function()
{
    var sndRecvIMButton    = this._gadget.getPartById("sndRecvIMButton");
    var sndSendIMButton    = this._gadget.getPartById("sndSendIMButton");
    var sndRecvAlertButton = this._gadget.getPartById("sndRecvAlertButton");

    var notifyIMButton     = this._gadget.getPartById("notifyIMButton");
    var isShowMailCount    = this._gadget.getPartById("notifyMailButton").getAttribute("toggled");
    
    try
    {
        var storeName = this.scene.prefObj.prefsGetStoreForCurrentIdentity();
        if (storeName)
        {
            var kvs = new keyValueStorage();
            kvs.open(storeName);
            kvs.setValue( this.scene.prefObj.playIMSoundKey , sndRecvIMButton.getAttribute("toggled") );
            kvs.setValue( this.scene.prefObj.playSendIMSoundKey , sndSendIMButton.toggled.toString() );
            kvs.setValue( this.scene.prefObj.playAlertSoundKey , sndRecvAlertButton.getAttribute("toggled") );

            kvs.setValue( this.scene.prefObj.externalNotifyKey , notifyIMButton.getAttribute("toggled") );
            kvs.setValue( this.scene.prefObj.showMailCountKey , isShowMailCount);
            kvs.close();
            kvs = null;
        }
    }
    catch (e) {}
    
    var mailCountEvent = (isShowMailCount == "true") ? "showMailIcon" : "hideMailIcon";
    propagateEventForBox(this._gadget, mailCountEvent); // update the menu

}

component.prototype.savePrivacyPreferences = function()
{
    var privacyContactMeRadioBox = this._gadget.getPartById("privacyContactMeRadioBox");
    var privacyContactMeSelected = privacyContactMeRadioBox.selectedBox.id;
    var pMode = "";

    try
    {
        var storeName = this.scene.prefObj.prefsGetStoreForCurrentIdentity();
        if (storeName)
        {
            var kvs = new keyValueStorage();
            kvs.open(storeName);
            pMode = kvs.getValue( this.scene.prefObj.PdModeKey , this.scene.prefObj.PdModeDefaultValue );
            kvs.setValue( this.scene.prefObj.PdModeKey , privacyContactMeSelected );
            kvs.close();
            kvs = null;
        }
    }
    catch (e) {}

    if(pMode != privacyContactMeSelected)
    {
        // Set the host-based preference
        this.scene.AIMobj.setPermitDeny("pdMode", privacyContactMeSelected, false);
        
        var event = shell.factory.createEvent(this._gadget);
        if (event)
        {	    
	        event.type = "settingPreference";
	        event.pdMode = privacyContactMeSelected;
	        this._gadget.dispatchEvent(event);
        }
    }   
}


component.prototype.saveSoftwareUpdatePreferences = function()
{
    var updateNotifyBox = this._gadget.getPartById("notifyUpdatesButton");

    var updateNotifySelected = updateNotifyBox.getAttribute("toggled");

    try
    {
        var storeName = this.scene.prefObj.prefsGetStoreForCurrentIdentity();
        if (storeName)
        {
            var kvs = new keyValueStorage();
            kvs.open(storeName);
            kvs.setValue( this.scene.prefObj.updateNotifyKey , updateNotifySelected );
            kvs.close();
            kvs = null;
        }
    }
    catch (e) {}
}

component.prototype.getSoftwareUpdate = function()
{
    //shell.app.debugLog("In getSoftwareUpdate");
    //shell.app.debugLog("Trying to launch with: " + this.scene.updateObj.getDownloadUrl());
    try
    {
        appUtils.shellExecute(this.scene.updateObj.getDownloadUrl());
    }
    catch(e){}
}

/////////////////////////////////////////////////////////////
//  Preference API methods (returns the proper path to store)
/////////////////////////////////////////////////////////////

component.prototype.prefsGetGlobalStore = function()
{
    var storeName = "mobileAIM"; // Default value for Win32 builds w/o the app object.
    try {
        storeName = shell.app.productId;
    }
    catch (e) {}
    return storeName;
}

component.prototype.prefsGetStoreForCurrentIdentity = function()
{
    var storeName = "";
    try {
        var screenName = this.scene.AIMobj.getCurrentScreenname();
        if (screenName)
        {
            storeName = this.prefsGetGlobalStore()+"."+screenName;
        }
    } catch (e){}
    return storeName;
}

component.prototype.prefsGetStoreForIdentity = function(inIdentity)
{
    return this.prefsGetGlobalStore()+"."+inIdentity;
}

component.prototype.learnMore = function()
{
    this.scene.updateObj.launchLink(1);
}

