// ****************************************************************************
//
// Copyright ?2008 AOL LLC  All rights reserved.
// This software contains valuable confidential and proprietary information
// of AOL LLC and is subject to applicable licensing agreements.
// Unauthorized reproduction, transmission or distribution of this file and
// its contents is a violation of applicable laws.
//
//           A O L  L L C   C O N F I D E N T I A L
//
// ****************************************************************************

function component (_gadget)
{
}

component.prototype.setVisible = function(state)
{
    if (this._gadget.collapsed == state)
    {
        this._gadget.collapsed = state ? false : true;
    }
}

component.prototype.onSmiley = function()
{
    var targetBox = shell.currentEvent.targetBox;
    if (targetBox && targetBox.tag == "smileyButton")
    {
        shell.currentEvent.preventDefault();
        var string = targetBox.getAttribute("value");
        // Close the panel
        this._gadget.collapsed = true;

        var chatPanel = this.scene.getBoxById("chatPanel");
        chatPanel.insertComposeText(string);
    }
}

component.prototype.keyDown = function()
{
    var conversation = this.scene.getBoxById("chatPanel").getCurrConversation();
    if (conversation)
    {
        conversation.onKeyDownOutsideComposeInput();
    }
}

component.prototype.toggle = function()
{
    this.setVisible(this._gadget.collapsed ? true : false);
}

component.prototype.navigate = function(attr)
{
    var event = shell.currentEvent;
    if (event)
    {
        var box = event.targetBox;
        if (box)
        {
            var id = box.getAttribute(attr);
            if (id)
            {
                if (id == "composeInput")
                {
                    var chatPanel = this.scene.getBoxById("chatPanel");
                    var conversation = chatPanel.getCurrConversation();
                    if (conversation)
                    {
                        conversation.setGadgetFocus(id);
                        this.toggle();
                    }

                }
                else
                {
                    var focusBox = this._gadget.getPartById(id);
                    if (focusBox)
                    {
                        this.scene.focusedBox = focusBox;
                    }
                }
            }
        }
    }
}

component.prototype.close = function()
{
    var conversation = this.scene.getBoxById("chatPanel").getCurrConversation();
    if (conversation)
    {   
        conversation.setComposeInputFocus();
    }
}

