// ****************************************************************************
//
// Copyright ?2008 AOL LLC  All rights reserved.
// This software contains valuable confidential and proprietary information
// of AOL LLC and is subject to applicable licensing agreements.
// Unauthorized reproduction, transmission or distribution of this file and
// its contents is a violation of applicable laws.
//
//           A O L  L L C   C O N F I D E N T I A L
//
// ****************************************************************************

function component(_gadget)
{
    this.executeItem;
}

component.prototype.selectIndexChangePressed = function(isUp)
{
    var targetBox = shell.currentEvent.targetBox;
    if (targetBox.tag == "softKeyMenuSelectBox")
    {
        var nextSelectItem = this.menuFindNextItem(targetBox.selectedBox, isUp);
        if (!nextSelectItem)
        {
            var menuBox = (targetBox.id == "menuPart") ? targetBox : targetBox.firstChild;
            if (menuBox)
            {
                nextSelectItem = (isUp) ? menuBox.lastChild : menuBox.firstChild;
                
                while(nextSelectItem && (nextSelectItem.collapsed || nextSelectItem.disabled || nextSelectItem.tag == "menuSep"))
                {
                    nextSelectItem = (isUp) ? nextSelectItem.previousSibling : nextSelectItem.nextSibling;
                }
            }
        }
        targetBox.selectedBox = nextSelectItem;
    }
}

component.prototype.menuFindNextItem = function(currentMenuItem, isUp)
{
    var menuUpItem;
    if (currentMenuItem)
    {
        var nextMenuItem = isUp ? currentMenuItem.previousSibling : currentMenuItem.nextSibling;
        while (nextMenuItem)
        {
            if (nextMenuItem && (nextMenuItem.tag == "menuItem" || nextMenuItem.tag == "menuItemWithSelectState") && !nextMenuItem.collapsed && !nextMenuItem.disabled)
            {
                menuUpItem = nextMenuItem;
                break;
            }
            nextMenuItem = isUp ? nextMenuItem.previousSibling : nextMenuItem.nextSibling;
        }
    }
    return menuUpItem;
}

component.prototype.closeSubmenu = function()
{
    var targetBox = shell.currentEvent.targetBox;
    if (targetBox && targetBox.tag == "softKeyMenuSelectBox")
    {
        if (targetBox.id == "submenuPart")
        {
            this.closeSubmenuHelper();
        }
        else
        {
            this.closeMenu()
        }
    }
}

component.prototype.showSubmenu = function()
{
    var targetBox = shell.currentEvent.targetBox;
    if (targetBox)
    {
        if (targetBox.id == "menuPart")
        {
            var selectedMenu = targetBox.selectedBox;
            if (selectedMenu && selectedMenu.getAttribute("topLevelMenu") == "false")
            {
                this.showSubmenuHelper(selectedMenu);
            }
        }
        else
        {
            this.scene.focusedBox = this._gadget.getPartById("submenuPart");
        }
    }
}
component.prototype.closeSubmenuHelper = function()
{
    this._gadget.setAttribute("hideSubmenu", "true");
    this.scene.focusedBox = this._gadget.getPartById("menuPart");
}

component.prototype.showSubmenuHelper = function(selectedMenu)
{
    if (selectedMenu)
    {
        var submenu = this._gadget.getPartById("submenuPart");
        var contentChild;
        //if the select menu has submenu, show it
        var submenuName = selectedMenu.getAttribute("subMenu");
        if (selectedMenu.getAttribute("topLevelMenu") == "false" && submenuName)
        {
            //if the submenu we are showing are different, update them now
            contentChild = submenu.firstChild;
            if (contentChild && contentChild.tag == submenuName && this._gadget.getAttribute("hideSubmenu") == "false")
            {
                // if the the user selected the same submenu, close it
                this.closeSubmenuHelper();
                contentChild = null;
            }
            else if (!contentChild || contentChild.tag != submenuName)
            {
                // the user clicked on the new menuItem to see submenu
                submenu.deleteChild(contentChild);
                contentChild = this.scene.createBox(submenuName);
            }
        }
        else
        {
            this.executeMenuItemCommand(selectedMenu);
        }
        if (contentChild)
        {
            submenu.anchor = selectedMenu;
            // Pinning submenu to the left of the top menu but shifting an arbitrary value to make it slightly overlap
            submenu.right = selectedMenu.boxWidth - 15;
            submenu.addChild(contentChild);
            this._gadget.setAttribute("hideSubmenu", "false");
            this.scene.focusedBox = submenu;
            
            var subMenuBox = submenu.firstChild;
            if (subMenuBox)
            {
                var submenuItem = subMenuBox.firstChild;
                while (submenuItem)
                {
                    if (!submenuItem.collapsed && !submenuItem.disabled)
                    {
                        submenu.selectedBox = submenuItem;
                        break;
                    }
                    submenuItem = submenuItem.nextSibling;
                }
            }
        }
    }
}

component.prototype.executeMenuItemCommand = function(menuItem)
{
    // if there is no submenu, execute the command
    var event = shell.factory.createEvent(menuItem);
    if (event)
    {	    
        event.type = "command";
        menuItem.dispatchEvent(event);
    }
}
    
component.prototype.onEntered = function()
{
    var event = shell.currentEvent;
    var targetBox = event.targetBox;
    if (targetBox.tag == "softKeyMenuSelectBox")
    {
        this.showSubmenuHelper(targetBox.selectedBox);
    }
    else
    {
        this.onCommand();
    }
}
    
component.prototype.onCommand = function()
{
    var event = shell.currentEvent;
    var targetBox = event.targetBox;
    if (targetBox)
    {   
        if (targetBox.tag == "menuItem" || targetBox.tag == "menuItemWithSelectState")
        {
            if (!targetBox.disabled)
            {
                this.showSubmenuHelper(targetBox);
            }
        }
        else if (targetBox.tag == this._gadget.tag)
        {
            this.closeMenu();
        }
        event.stopPropagation();
        event.preventDefault();
    }
}

component.prototype.showMenu = function()
{
    if (this._gadget.collapsed)
    {
        this._gadget.collapsed = false;
        var menuPart = this._gadget.getPartById("menuPart");
        var nextSelectItem = menuPart.firstChild;
        while(nextSelectItem && (nextSelectItem.collapsed || nextSelectItem.disabled || nextSelectItem.tag == "menuSep"))
        {
            nextSelectItem = nextSelectItem.nextSibling;
        }
        menuPart.selectedBox = nextSelectItem;
        
        this._gadget.savedFocusedBox = this.scene.focusedBox;
        this.scene.focusedBox = menuPart;
        try
        {
            shell.app.overrideBackButton(this.scene.rootBox.windowHandle, true);
        }
        catch(e){}
    }
}

component.prototype.closeMenu = function()
{
    if (!this._gadget.collapsed)
    {
        try
        {
            shell.app.overrideBackButton(this.scene.rootBox.windowHandle, false);
        }
        catch(e){}
        this._gadget.collapsed = true;
    }
}

component.prototype.MenuRestoreFocus = function()
{
    try
    {
        if (this._gadget.savedFocusedBox)
        {
            this.scene.focusedBox = this._gadget.savedFocusedBox;
            this._gadget.savedFocusedBox = null;
        }
    }
    catch(e){}
}

component.prototype.menuCollapsed = function()
{
    if (this._gadget.collapsed)
    {
        this._gadget.setAttribute("hideSubmenu", "true");
        var menuPart = this._gadget.getPartById("menuPart");
        menuPart.selectedBox = menuPart.firstChild;
        this.MenuRestoreFocus();
    }
}

component.prototype.hideSubmenuChanged = function()
{
    if (this._gadget.getAttribute("hideSubmenu") == "false")
    {
        var event = shell.factory.createEvent(this._gadget);
        if (event)
        {	    
            event.type = "showSubmenu";
            event.submenuBox = this._gadget.getPartById("submenuPart").firstChild;
            this._gadget.dispatchEvent(event);
        }
    }
}

component.prototype.onKeyUp = function()
{
    if (this.executeItem)
    {
        shell.currentEvent.stopPropagation();
        this.executeMenuItemCommand(this.executeItem);
        this.executeItem = null;
    }
}   

component.prototype.onKeyDown= function()
{
    var eventObj = shell.currentEvent;
    var targetBox = eventObj ? eventObj.targetBox : null;
    if (targetBox && targetBox.tag == "softKeyMenuSelectBox")
    {
        var keyCode = eventObj.keyCode;
        
        // if the virtual key code is from A-Z then check the access key
        if (keyCode >= 65 && keyCode <= 122)
        {
            var key = String.fromCharCode(keyCode);
            key = (key) ? key.toLowerCase() : null;
            if (key)
            {
                var menuContainer = (targetBox.id == "submenuPart") ? targetBox.firstChild : targetBox;
                if (menuContainer)
                {
                    var menuItem;
                    var childCount = menuContainer.childCount;
                    for (var x = 0; x < childCount; ++x)
                    {
                        menuItem = menuContainer.getChildAt(x);
                        if (menuItem && (menuItem.tag == "menuItem" || menuItem.tag == "menuItemWithSelectState") && !menuItem.collapsed && !menuItem.disabled)
                        {
                            var accessKey = menuItem.getAttribute("accessKey");
                            if (accessKey && key == accessKey.toLowerCase())
                            {
                                break;
                            }
                        }
                        menuItem = null;
                    }
                    if (menuItem && !menuItem.disabled)
                    {
                        if (menuItem.getAttribute("topLevelMenu") == "false")
                        {
                            targetBox.selectedBox = menuItem;
                            this.showSubmenuHelper(menuItem);
                        }
                        else
                        {
                            this.executeItem = menuItem;
                        }
                    }
                }
            }
        }
    }
}
