// ****************************************************************************
//
// Copyright ?2008 AOL LLC  All rights reserved.
// This software contains valuable confidential and proprietary information
// of AOL LLC and is subject to applicable licensing agreements.
// Unauthorized reproduction, transmission or distribution of this file and
// its contents is a violation of applicable laws.
//
//           A O L  L L C   C O N F I D E N T I A L
//
// ****************************************************************************

var LEFT_KEY_ID      = 100;
var RIGHT_KEY_ID     = 200;

var menuCommands = 
{
    "IDM_NOIMPL":888,
    "IDM_EXIT":100,
    "IDM_SIGNOUT":101,
    "IDM_SETTINGS":102,
    "IDM_HELP":103,
    "IDM_ABOUT":104,
    "IDM_BL_NEW_TEXT_MESSAGE":105,
    "IDM_BL_NEW_MESSAGE":106,
    "IDM_BL_DELETE":107,
    "IDM_CONV_BUDDYLIST":108,
    "IDM_CONV_SEND":109,
    "IDM_AUTH_MENU":110,
    "IDM_BL_MENU":111,
    "IDM_CONV_MENU":112,
    "IDM_CONV_EDIT_DONE":113,
    "IDM_CONV_EDIT_CANCEL":114,
    "IDM_ALERT_BUTTON1":115,
    "IDM_ALERT_BUTTON2":116,
    "IDM_AUTH_CANCEL":117,
    "IDM_SETTING_BACK":118,
    "IDM_SETTING_CANCEL":119,
    "IDM_SETTING_SAVE":120, 
    "IDM_TOS_ACCEPTED":121,
    "IDM_SIGNIN":122,
    "IDM_SETTING_MENU":123,
    "IDM_BL_EDIT_STATUS":124,
    "IDM_AUTH_CONTINUE":125,
    "IDM_CONV_ADDBUDDY":126, 
    "IDM_UPDATE":127,
    "IDM_UPDATE_REMINDME":128,
    "IDM_CRITICAL_UPDATE":129,
    "IDM_CONV_UNKNOWN_VIEW":130,
    "IDM_CONV_UNKNOWN_CLOSE":131,
    "IDM_BL_STATUS_DONE":132,
    "IDM_BL_STATUS_CANCEL":133,
    "IDM_CONV_REPORT_SPAM":134,
    "IDM_HELP_BACK":135,
    "IDM_HELP_MENU":136,
    "IDM_HELP_CANCEL":137,
    "IDM_HIDE":138,
    "IDM_BL_SET_ALERT":139,
    "IDM_BL_SEARCH_CANCEL":140,
    "IDM_RECONNET_SIGNIN":141,
    "IDM_GETBUDDYPROFILE":142,
    "IDM_PROFILE_BACK":143,
    "IDM_PROFILE_SENDIM":144
};

function AppendMenuItem(menu, label, command)
{
    var menuItem = menu.createItem(command, label, "", "");
    menu.insertItem(-1, menuItem);
}

function AppendMenuSeparator(menu)
{
    var menuItem = menu.createSeparator();
    menu.insertItem(-1, menuItem);
}

function OverrideSoftkeyMenus(theScene, leftLabel, leftCommandId, rightLabel, rightCommandId)
{
    var factory = shell.factory;
    var menu = (factory) ? factory.createMenu(false) : null;
    if (menu)
    {   
        AppendMenuItem(menu, leftLabel, eval('(' + "menuCommands." + leftCommandId+ ')'));
        AppendMenuItem(menu, rightLabel, eval('(' + "menuCommands." + rightCommandId+ ')'));
        
        // Attach the menu to the root window object
        theScene.rootBox.menu = menu;
    }
}

function UpdateSoftkeyMenu(object)
{
    if (object)
    {
        var leftMenu = object.getPartById("leftSoftKeyMenu");
        var rightMenu = object.getPartById("rightSoftKeyMenu");
        if (leftMenu || rightMenu)
        {
            //  Display softkey menu options
            var factory = shell.factory;
            var menu = (factory) ? factory.createMenu(false) : null;
            if (menu)
            {
                var leftMenuLabel = leftMenu ? leftMenu.getAttribute("menuTitle") : "";
                var rightMenuLabel = rightMenu ? rightMenu.getAttribute("menuTitle") : "";

                var leftMenuCommand = leftMenu ? eval('(' + "menuCommands." + leftMenu.getAttribute("commandId")+ ')') : LEFT_KEY_ID;
                var rightMenuCommand = rightMenu ? eval('(' + "menuCommands." + rightMenu.getAttribute("commandId")+ ')') : RIGHT_KEY_ID;
            
                AppendMenuItem(menu, leftMenuLabel, leftMenuCommand);
                AppendMenuItem(menu, rightMenuLabel, rightMenuCommand);

                // Attach the menu to the root window object
                scene.rootBox.menu = menu;
                if(object.id =="settings" || object.id =="help")
                {
                    try{
                        shell.app.overrideBackButton(scene.rootBox.windowHandle, true);
                    }catch(e)
                    {}
                }
            }
        }
        else
        {
            // Create and attach a blank menu so we still get the SIP button
            var factory = shell.factory;
            var menu = (factory) ? factory.createMenu(false) : null;
            scene.rootBox.menu = menu;
        }
    }
}

function OnNativeMenuCommand()
{
    var event = shell.currentEvent;
    if (event)
    {
        var menuItemId = event.menuId;
        switch (menuItemId)
        {
            case menuCommands.IDM_CONV_SEND:
                {
                    var chat = scene.getBoxById("chatPanel");
                    var currBuddy = chat.getCurrConversation();
                    if (currBuddy)
                    {
                        currBuddy.sendIM();
                    }
                }
                break;
            
            case menuCommands.IDM_CONV_BUDDYLIST:
                onConversationBack();
                break;
            case menuCommands.IDM_SIGNIN:
                {
                    scene.getBoxById("authPanelBox").authSignOn();
                }
                break;
            case menuCommands.IDM_PROFILE_BACK:
                {
                    scene.getBoxById("profileBox").goBack();
                }
                break;
            case menuCommands.IDM_PROFILE_SENDIM:
                {
                    var profileBox = scene.getBoxById("profileBox");
                    var aimId = profileBox.getAIMId();
                    var buddyInfo = this.scene._buddyListObj.getBuddyInfo(aimId);
                    if (!buddyInfo)
                    {
                        buddyInfo = new Object();
                        buddyInfo.aimId = aimId
                    }
                    scene.getBoxById("chatPanel").startConversation(buddyInfo, true);
                    this.scene.getBoxById("contentContainer").showPanelByAttribute(panelAttribute_chatPanel);
                    profileBox.close();
                }
                break;
            case menuCommands.IDM_AUTH_MENU:
            case menuCommands.IDM_BL_MENU:
            case menuCommands.IDM_CONV_MENU:
            case menuCommands.IDM_SETTING_MENU:
            case menuCommands.IDM_HELP_MENU:
                {
                    var subMenu = null;
                    if (menuItemId == menuCommands.IDM_AUTH_MENU)
                    {
                        subMenu = scene.getBoxById("authPanelBox").getPartById("rightSoftKeyMenu");
                    }
                    else if (menuItemId == menuCommands.IDM_BL_MENU)
                    {
                        var buddyList = scene.getBoxById("buddyList");
                        subMenu = buddyList.getPartById("rightSoftKeyMenu");
                        if (subMenu.collapsed)
                        {
                            buddyList.updateMenu();
                        }
                    }
                    else if (menuItemId == menuCommands.IDM_CONV_MENU)
                    {
                        var chatPanel = scene.getBoxById("chatPanel");
                        subMenu = chatPanel.getPartById("rightSoftKeyMenu");
                        if (subMenu.collapsed)
                        {
                            chatPanel.updateMenu();
                        }
                    }
                    else if (menuItemId == menuCommands.IDM_SETTING_MENU)
                    {
                        subMenu = scene.getBoxById("settings").getPartById("rightSoftKeyMenu");
                    }
                    else if (menuItemId == menuCommands.IDM_HELP_MENU)
                    {
                        subMenu = scene.getBoxById("help").getPartById("rightSoftKeyMenu");
                    }
                    
                    if (subMenu && subMenu.getAttribute("hasSubMenu") == "true")
                    {
                    
                        // toggle the appropriate submenu
                        scene.getBoxById("globalDropDown").closeDropdownHelper();
                    
                        if (subMenu.collapsed)
                        {
                            subMenu.showMenu();
                            
                            // Close the SIP if it is open
                            try
                            {
                                if (shell.device.sip)
                                {
                                    shell.device.sip = false;
                                }
                            } catch(e){}
                        }
                        else
                        {
                            subMenu.closeMenu();
                        }
                   } 
                }
                break;
            case menuCommands.IDM_BL_SEARCH_CANCEL:
                {
                    var buddyList = scene.getBoxById("buddyList");
                    var softKeyMenu = buddyList.getPartById("rightSoftKeyMenu");
                    if (softKeyMenu && !softKeyMenu.collapsed)
                    {
                        softKeyMenu.closeMenu();
                    }
                    buddyList.cancelSearch();
                }
                break;
                
            case menuCommands.IDM_CONV_EDIT_DONE:
                {
                    var chat = scene.getBoxById("chatPanel");
                    var currBuddy = chat.getCurrConversation();
                    if (currBuddy)
                    {
                        if (currBuddy.getPartById("newMessageInput").getAttribute("value"))
                        {
                            // Set focus to the compose input - which accepts the screenname editing
                            scene.focusedBox = currBuddy.getPartById("composeInput");
                            break;
                        }
                        //go to IDM_CONV_EDIT_CANCEL if there is no value
                    }
                }
            case menuCommands.IDM_CONV_EDIT_CANCEL:
                {
                    var chat = scene.getBoxById("chatPanel");
                    chat.updateSoftKey(true);
                    var currBuddy = chat.getCurrConversation();
                    if (currBuddy)
                    {
                        currBuddy.closeConversation();
                    }
                }
                break;
                
            case menuCommands.IDM_BL_STATUS_DONE:
                {
                    scene.getBoxById("buddyList").getPartById("statusMessage").enterPressed();
                }
                break;
            case menuCommands.IDM_BL_STATUS_CANCEL:
                {
                    scene.getBoxById("buddyList").cancelEditStatusMessage();
                }
                break;               
            case menuCommands.IDM_ALERT_BUTTON1:
            case menuCommands.IDM_ALERT_BUTTON2:
                {
                    var alert = scene.getBoxById("alertBox");
                    if (alert)
                    {
                        if (menuItemId == menuCommands.IDM_ALERT_BUTTON1)
                        {
                            propagateEventForBox(alert, "fireButton1");
                        }
                        else
                        {
                            propagateEventForBox(alert, "fireButton2");
                        }
                    }
                }
                break;
            case menuCommands.IDM_SETTING_BACK:
                {
                    var settings = scene.getBoxById("settings");
                    settings.goBack();
                }
                break;
            case menuCommands.IDM_SETTING_CANCEL:
                {
                    scene.getBoxById("settings").cancel();
                }
                break;
            case menuCommands.IDM_SETTING_SAVE:
                {
                    scene.getBoxById("settings").save();
                }
                break;
            case menuCommands.IDM_AUTH_CANCEL:
                {
                    var authPanel = scene.getBoxById("authPanelBox");
                    authPanel.authSignOnCancel();
                    signOff(true);
                }
                break;
            case menuCommands.IDM_TOS_ACCEPTED:
                {
                    TOSAccepted();       
                }
                break;
            case menuCommands.IDM_UPDATE:
                {
                    updateAction(0);
                }   
                break;
            case menuCommands.IDM_UPDATE_REMINDME:
                {
                    updateAction(1);
                }   
                break;
            case menuCommands.IDM_CRITICAL_UPDATE:
                {
                    installCriticalUpdate();
                }
                break;
            case menuCommands.IDM_CONV_UNKNOWN_VIEW:
                {
                    scene.getBoxById("chatPanel").unknownUserAction("0");
                }
                break;
            case menuCommands.IDM_CONV_UNKNOWN_CLOSE:
                {
                    scene.getBoxById("chatPanel").unknownUserAction("1");
                }
                break;
            case menuCommands.IDM_HELP_BACK:
                {
                    var help = scene.getBoxById("help");
                    help.goBack();
                }
                break;
            case menuCommands.IDM_HELP_CANCEL:
                {
                    var help = scene.getBoxById("help");
                    help.cancel();
                    help.getPartById("rightSoftKeyMenu").closeMenu();
                }
                break;
            case menuCommands.IDM_RECONNET_SIGNIN:
                {
                    CloseOpenMenu();
                    scene.getBoxById("buddyList").reconnectLimitReachedResult(0);
                }
                break;
            case menuCommands.IDM_EXIT:
                scene.close();
                break;
            case menuCommands.IDM_AUTH_CONTINUE:
                {
                    var authPanel = scene.getBoxById("authPanelBox");
                    if (authPanel.getPanelIndex() == "1")
                    {
                        authPanel.submitPasscode();
                    }
                    else if (authPanel.getPanelIndex == "2")
                    {
                        authPanel.submitCaptcha();                        
                    }
                }
                break;
        }
    }
}

function OnBoxelyMenuCommand(command)
{
    var event = shell.currentEvent;
    
    // close the open menu - this could definitely be improved somehow
    if (event)
    {
        // Search up until we find the softkeymenu gadget
        var menu = event.targetBox;
        while (menu && (menu.tag != "softKeyMenu"))
        {
            menu = menu.parent;
        }
        
        // Close the menu
        if (menu && (menu.tag == "softKeyMenu"))
        {
            menu.closeMenu();
        }
    }

    if (command == "IDM_EXIT")
    {
        scene.close();
    }
    else if (command == "IDM_SIGNOUT")
    {
        signOff(true);
    }
    else if (command == "IDM_ABOUT")
    {
        // TODO
    }
    else if (command == "IDM_GETBUDDYPROFILE")
    {
        getBuddyProfile();
    }
    else if (command == "IDM_HELP" || command == "IDM_SETTINGS")
    {
        var boxId;
        var focusedBox;
        var panelAttribute;
        var contentContainer = scene.getBoxById("contentContainer");
        var currPanelAttribute = contentContainer.getCurrentAttribute();
        var currPanelBox;
        var getPreviousPreviousPanel = false;
        
        // if the current panel is either settings or help, we need to get its previous panel and previous focus box information
        if (currPanelAttribute == panelAttribute_settings || currPanelAttribute == panelAttribute_help)
        {
            getPreviousPreviousPanel = true;        
        }
        
        if (command == "IDM_SETTINGS")
        {
            boxId = "settings";
            panelAttribute = panelAttribute_settings;
            if (getPreviousPreviousPanel)
            {
                currPanelBox = "help";
            }
        }
        else
        {
            boxId = "help";
            panelAttribute = panelAttribute_help;
            if (getPreviousPreviousPanel)
            {
                currPanelBox = "settings";
            }
        }
        
        var box = scene.getBoxById(boxId);
        if (getPreviousPreviousPanel)
        {
            currPanelBox = scene.getBoxById(currPanelBox);
            currPanelAttribute = currPanelBox.previousPanel;
            currPanelBox.previousPanel = null;
            
            focusedBox = currPanelBox.savedFocusedBox;
            currPanelBox.savedFocusedBox = null;
        }
        
        box.previousPanel = currPanelAttribute;
        if (!getPreviousPreviousPanel)
        {   
            focusedBox = scene.focusedBox;
            if (box.previousPanel == panelAttribute_buddyList)
            {
                if (focusedBox && focusedBox.id == "searchResultGrid")
                {
                    var buddyList = scene.getBoxById("buddyList");
                    focusedBox = buddyList.getPartById("buddyListGrid");
                }
            }
        }
        box.savedFocusedBox = focusedBox;
        contentContainer.showPanelByAttribute(panelAttribute);
    }
    else if (command == "IDM_BL_EDIT_STATUS")
    {
        scene.getBoxById("buddyList").editStatusMessage();
    }
    else if (command == "IDM_BL_NEW_MESSAGE")
    {
        scene.getBoxById("chatPanel").newMessage(false);
    }
    else if (command == "IDM_BL_NEW_TEXT_MESSAGE")
    {
        scene.getBoxById("chatPanel").newMessage(true);
    }
    else if (command == "IDM_ADDGROUP")
    {
        scene.getBoxById("buddyList").cmdAddGroup();
    }
    else if (command == "IDM_BL_EDIT")
    {
        scene.getBoxById("buddyList").cmdEdit();
    }
    else if (command == "IDM_ADDBUDDY")
    {
        scene.getBoxById("buddyList").cmdAddBuddy();
    }
    else if (command == "IDM_ADDMOBILE")
    {
        scene.getBoxById("buddyList").cmdAddBuddy(null, null, true);
    }
    else if (command == "IDM_CONV_ADDBUDDY")
    {
        onAddCurrentConversation();
    }
    else if (command == "IDM_CLOSE_CONVERSATION")
    {
        scene.getBoxById("chatPanel").onCloseCurrentConversation();
    }
    else if (command == "IDM_BL_DELETE")
    {
        scene.getBoxById("buddyList").cmdDelete();
    }
    else if (command == "IDM_CONV_BUDDYLIST")
    {
        onConversationBack();
    }
    else if (command == "IDM_SETPRESENCE")
    {
        var targetBox = event.targetBox;
        if (targetBox)
        {
            scene.getBoxById("buddyList").setPresence(targetBox.getAttribute("value"));
        }
    }
    else if (command == "IDM_HIDE")
    {
        try
        {
            shell.app.minimize();
        }
        catch(e){}
    }
    else if (command == "IDM_BL_SET_ALERT")
    {
        var buddyList = scene.getBoxById("buddyList");
        var selectedBuddy = buddyList.getSelectedBuddy();
        if (selectedBuddy)
        {
            buddyList.setAlert(selectedBuddy);
        }
    }
    else if (command == "IDM_BLOCK_UNBLOCK_BUDDY")
    {
        var chatPanel = scene.getBoxById("chatPanel");
        chatPanel.blockUnblockBuddyById(chatPanel.getCurrConversationId(), true);
    }
    else if (command == "IDM_CONV_REPORT_SPAM")
    {
        var chatPanel = scene.getBoxById("chatPanel");
        chatPanel.reportSpamDialogOnCurrentUser();
    }
    else if (command == "IDM_BL_BLOCK_UNBLOCK_BUDDY")
    {
        scene.getBoxById("buddyList").blockUnblockBuddy();
    }
    
}

function MenuRestoreFocus(menu)
{
    if (menu && menu.savedFocusedBox)
    {
        scene.focusedBox = menu.savedFocusedBox;
        menu.savedFocusedBox = null;
    }
}

function CloseOpenMenu()
{
    // Find the open menu and close it
    var menuList = scene.getBoxesByTag("softKeyMenu");
    if (menuList && menuList.count > 0)
    {
        var count = menuList.count;
        for (var x = 0; x < count; ++x)
        {
            var menu = menuList.getValue(x);
            if (menu && !menu.collapsed)
            {
                menu.closeMenu();
                break;
            }
        }
    }
}

