// ****************************************************************************
//
// Copyright ?2008 AOL LLC  All rights reserved.
// This software contains valuable confidential and proprietary information
// of AOL LLC and is subject to applicable licensing agreements.
// Unauthorized reproduction, transmission or distribution of this file and
// its contents is a violation of applicable laws.
//
//           A O L  L L C   C O N F I D E N T I A L
//
// ****************************************************************************

var snapshot1 = null;
var snapshot2 = null;
function takeSnapshot(box, attachSnapshot1, attachSnapshot2)
{
    
    snapshot1 = box.createSnapshot(false); // grab what's on the screen as our 1st snapshot
    if (attachSnapshot1 == null || attachSnapshot1)
    {
        box.attachSourceSnapshot(snapshot1);       // This box will now draw on-screen from the snapshot
    }

    snapshot2 = box.createSnapshot(true); // create a blank snapshot object
    if (attachSnapshot2 == null || attachSnapshot2)
    {
        box.attachTargetSnapshot(snapshot2);      // now we are going to be drawing INTO the 2nd snapshot
    }
}

function doTransition(box, type, duration, dynamics, cleanUp)
{       
    // At this point the box was updated so it was drawn on the target snapshot
    
    box.renderTargetSnapshot();
    if (snapshot1 && snapshot2)
    {
        // Create a transition
        var transition = box.createTransition();
        
        if (transition)
        {
            // Do the transition
            transition.type = type;
            transition.duration = duration ? duration : 250;
            transition.dynamicsType = dynamics ? dynamics : "smoothSpline";
            transition.perform(snapshot1, snapshot2);
        }       
    }
    
    // remove our attached snapshots
    if (cleanUp == null || cleanUp)
    {
        cleanupTransition(box);
    }
} 

function cleanupTransition(box)
{
    box.detachSourceSnapshot();
    box.detachTargetSnapshot();
    snapshot1 = snapshot2 = null;
}

function propagateEventForBox(box, eventName, targetBox)
{
    var event = shell.factory.createEvent((targetBox) ? targetBox : box);
	if (event)
	{	    
		event.type = eventName;
		box.dispatchEvent(event);
	}
}

function canonicalizeScreenName(name)
{
    var screenName;
    if (name)
    {
        screenName = name.toLowerCase();
        screenName = screenName.replace(/[ \t]*/ig,"");
    }
    return screenName;
}

function getPresenceIcon(state)
{
    return "#badge." + state;
}

function formatString1(string, param1)
{   
    var tempString;
    if (string)
    {
        tempString = string.replace("[_string_]", param1);
    }
    return tempString;
}

function formatString2(string, param1, parm2)
{
    var tempString;
    if (string)
    {
        tempString = formatString1(string, param1);
        tempString = formatString1(tempString, parm2);
    }
    return tempString
}

function parseSmileys(string)
{
    var newString = string;
    var size = 16 * shell.uiScale / 100;
    var htmlPre = "<img src='resources/smileys/";
    var htmlPost = ".png' width='" + size + "' height='" + size + "'/>";

    newString = newString.replace(/O:\-\)/gi, htmlPre + "Angel" + htmlPost);                 // O:-)
    newString = newString.replace(/:\-\)/gi, htmlPre + "Smile" + htmlPost);                  // :-)
    newString = newString.replace(/:\)/gi, htmlPre + "Smile" + htmlPost);                    // :)
    newString = newString.replace(/:\-\(/gi, htmlPre + "Frown" + htmlPost);                  // :-(
    newString = newString.replace(/;\-\)/gi, htmlPre + "Wink" + htmlPost);                   // ;-)
    newString = newString.replace(/:\-P/gi, htmlPre + "Sticking-Tongue-Out" + htmlPost);     // :-P
    newString = newString.replace(/=\-O/gi, htmlPre + "Uh-Oh" + htmlPost);                   // =-O
    newString = newString.replace(/:\-\*/gi, htmlPre + "Kissy-Face" + htmlPost);             // :-*
    newString = newString.replace(/&gt;:o/gi, htmlPre + "Yelling" + htmlPost);               // >:o (do replace on &gt; rather than '>' since stripHTML has already replaced that character)
    newString = newString.replace(/&amp;gt;:o/gi, htmlPre + "Yelling" + htmlPost);               // >:o (do replace on &gt; rather than '>' since stripHTML has already replaced that character)
    newString = newString.replace(/&amp;amp;gt;:o/gi, htmlPre + "Yelling" + htmlPost);               // >:o (do replace on &gt; rather than '>' since stripHTML has already replaced that character)
    newString = newString.replace(/:\-D/gi, htmlPre + "Big-Grin" + htmlPost);                // :-D
    newString = newString.replace(/:\-\$/gi, htmlPre + "Money-Where-Mouth-Is" + htmlPost);   // :-$
    newString = newString.replace(/:\-\!/gi, htmlPre + "Foot-in-Mouth" + htmlPost);          // :-!
    newString = newString.replace(/:\-\[/gi, htmlPre + "Embarrassed" + htmlPost);            // :-[
    newString = newString.replace(/:\-\\/gi, htmlPre + "Hmmmm" + htmlPost);                  // :-\
    newString = newString.replace(/:\'\(/gi, htmlPre + "Crying" + htmlPost);                 // :'(
    newString = newString.replace(/:\-X/gi, htmlPre + "Lips-are-Sealed" + htmlPost);         // :-X
    newString = newString.replace(/8\-\)/gi, htmlPre + "Joe-Cool" + htmlPost);               // 8-)
    
    return newString;
}

///////////////////////////////////////////////////////////////////////////////
// makeSafeUrl
// check that url starts with a valid prefix for an href
// if it doesn't, return an empty string.
///////////////////////////////////////////////////////////////////////////////
function makeSafeUrl(url)
{
    safeUrl = "";

    idx = url.search("http://");
    if (idx == 0)
    {
        safeUrl = url;
    }

    idx = url.search("https://");
    if (idx == 0)
    {
        safeUrl = url;
    }

    return removeInjections(safeUrl);
};



///////////////////////////////////////////////////////////////////////////////
// removeInjections
///////////////////////////////////////////////////////////////////////////////
function removeInjections (str)
{
    if (str)
    {
        str = String(str);

        str = str.replace( /[<>\"\'\\\n\r]/g,
                function( c )
                {
                    c = escape( c );
                    return c;
                }
        );
    }

    return str;
}

function parseStringFromText(text, startString, endString, startIdx)
{
    var newString;
    if (startString && endString && (startIdx > -1))    
    {
        var endIdx = -1;
        
        if (!startIdx)
        {
            startIdx = 0;
        }
        
        startIdx = text.indexOf(startString, startIdx);
        
        if (startIdx > 0)
        {
            startIdx += startString.length;
            endIdx = text.indexOf(endString, startIdx);    
            if (endIdx > startIdx)
            {
                newString = text.substring(startIdx, endIdx);
            }
        }
    }
    return newString;
}